C
C      BOUSSINESQ MODEL Ver4.6c8a
C
C                                              PROGRAMED BY KATSUYA HIRAYAMA
C                                              LAST UPDATE: 10 Jun. 2010
C
C///////////////////////////////////////////////////////////////////////////
C
C   ( IS <= E(I,J) <= IE ) ( IS+1 <= P(I,J) <= IE ) ( IS   <= Q(I,J) <= IE )
C   ( JS <= E(I,J) <= JE ) ( JS   <= P(I,J) <= JE ) ( JS+1 <= Q(I,J) <= JE )
C                                                                           
C      |        |        |        |       |                                 
C      ---------------------[]--- -[]-----                              
C      |        |        |        |       |                                 
C JS+1 |        |         [] [][][]                               
C      |        |        |        |       |                                 
C      ---------------------[]-----[]-----                              
C      |        |        |        |       |                                 
C   JS |        |P:IS,JS  [] [][][]                               
C      |        |        |        |       |                                 
C      -----------------------------------                              
C      |        |        |Q:IS,JS |       |                                 
C      |        |        |        |       |                                 
C      |        |        |        |       |                                 
C      ---------------------------------------                              
C      |        |        |        |       |                                 
C      |        |        |        |       |                                 
C      |        |        |        |       |                                 
C      ---------------------------------------                              
C                            IS     IS+1                                    
C                                                                           
C      ---------------------------------------                              
C         |        |        |        |       |                              
C         |        |        |        |       |                              
C         |        |        |        |       |                              
C      ---------------------------------------                              
C         |        |        |        |       |                              
C         |        | Q:IE,JE+1       |       |                              
C         |        |        |        |       |                              
C      -----------------------------------                              
C         |        |        |        |       |                              
C   JE   [][] [][]   P:IE+1,JE     |                              
C         |        |        |        |       |                              
C      -----[]-----[]---------------------                              
C         |        |        |        |       |                              
C JE-1   [][] [][]         |       |                              
C         |        |        |        |       |                              
C      -----[]-----[]---------------------                              
C         |        |        |        |       |                              
C            IE-1      IE                                                   
C                                                                           
C///////////////////////////////////////////////////////////////////////////
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C
C******** zTCY̓Ǎ **************************
      include 'bsq_bsq46c8a_r1.inc'
      include 'rgn_bsq46c8a_r1.inc'
      include 'wav_bsq46c8a_r1.inc'
C
C
      DIMENSION   E(IMAX,JMAX), EOLD(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX), POLD(IMAX,JMAX), PTMP(IMAX,JMAX)
      DIMENSION   Q(IMAX,JMAX), QOLD(IMAX,JMAX), QTMP(IMAX,JMAX)
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HY(IMAX,JMAX), 
     &            HP(IMAX,JMAX), DH(IMAX,JMAX)
      DIMENSION   FD(IMAX,JMAX), FDX(IMAX,JMAX), FDY(IMAX,JMAX)
      DIMENSION   XNYU(IMAX,JMAX), YNYU(IMAX,JMAX)
      DIMENSION   EMIN(IMAX,JMAX), EMAX(IMAX,JMAX), HAKOU(IMAX,JMAX)
      DIMENSION   HRMS(IMAX,JMAX), UAVG(IMAX,JMAX), VAVG(IMAX,JMAX)
      DIMENSION   HRMS2(IMAX,JMAX)
      DIMENSION   DQDY(IMAX,JMAX), DPDX(IMAX,JMAX)
      DIMENSION   FFX(IMAX,JMAX), FFY(IMAX,JMAX)
      DIMENSION   EAVG(IMAX,JMAX)
      DIMENSION   FXT(IMAX,JMAX), FYT(IMAX,JMAX)
C
      DIMENSION   SUMH(IMAX,JMAX), SUMU(IMAX,JMAX), SUMV(IMAX,JMAX)
      DIMENSION   SUME(IMAX,JMAX), SUME2(IMAX,JMAX)
C
      DIMENSION   RY(0:1,IMAX,JMAX), CA(0:1,IMAX,JMAX)
      DIMENSION   RUY(0:1,IMAX,JMAX), CUA(0:1,IMAX,JMAX)
      DIMENSION   RVY(0:1,IMAX,JMAX), CVA(0:1,IMAX,JMAX)
C
      DIMENSION   U(IMAX,JMAX),  V(IMAX,JMAX)
C
      DIMENSION   SUMU2(IMAX,JMAX), SUMV2(IMAX,JMAX)
      DIMENSION   SUMEU(IMAX,JMAX), SUMEV(IMAX,JMAX)
      DIMENSION   EUAVG(IMAX,JMAX), EVAVG(IMAX,JMAX)
      DIMENSION   DIRM2(IMAX,JMAX)
      DIMENSION   AGCWX2(IMAX,JMAX), AGCWY2(IMAX,JMAX)
C
      DIMENSION   SUMWAVE(IMAX,JMAX)
      DIMENSION   NWAVE(IMAX,JMAX)
C
      DIMENSION   SUMCWX(IMAX,JMAX), SUMCWY(IMAX,JMAX)
      DIMENSION   AVGCWX(IMAX,JMAX), AVGCWY(IMAX,JMAX)
      DIMENSION   CWX(IMAX,JMAX), CWY(IMAX,JMAX)
      DIMENSION   DIRM(IMAX,JMAX)
      DIMENSION   SYUKI(IMAX,JMAX),SUMSYUKI(IMAX,JMAX)
      DIMENSION   NZST(IMAX,JMAX), NDIRC(IMAX,JMAX)
C
      INTEGER     NHRMS,NHRMS2,NUAVG,NVAVG,NUAVG2,NVAVG2
      CHARACTER   CC*20
C
      DIMENSION   us(imax,jmax), vs(imax,jmax)
     &     , prouss(imax,jmax)
     &     , anyud(imax,jmax), bnyud(imax,jmax), dmean(imax,jmax)
     &     , dmold(imax,jmax), suv(imax,jmax), Pmax(imax,jmax)
     &     , Pmaxold(imax,jmax), Pmin(imax,jmax), Pminold(imax,jmax)
     &     , Qmax(imax,jmax), Qmaxold(imax,jmax), Qmin(imax,jmax)
     &     , Qminold(imax,jmax)
C
      INTEGER IBFLAG(imax,jmax)
C
      DIMENSION  brkmesh(imax,jmax)
C
      COMMON /FF/ FF1,FF2
C
      DIMENSION   HZ(JMAX)
C
C
      COMMON/ IRWAVE / AMP, AK, SITW, F, EPS
      DIMENSION        AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)
C
      COMMON/ IRWAVE2 / AMP_P, AK_P
      DIMENSION         AMP_P(NN,JMAX), AK_P(NN,JMAX)
C
      COMMON/ IRWAVE3 / AMP_J, AK_J, PHSJ
      DIMENSION         AMP_J(NN,JMAX), AK_J(NN,JMAX), PHSJ(NN,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
C
      INTEGER    LPXJ(LDM),LXD1(LDM),LXD2(LDM),
     &           LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
C
      PARAMETER (NPMAX=200)
      INTEGER     NPII(NPMAX),NPJJ(NPMAX)
      DIMENSION   PTHR(NPMAX,3)
C
C
      CHARACTER IB(IMAX,JMAX)*1,ICH(54)*1
C
      DATA ICH/' ','A','B','C','D','E','F','G','H','I','J',
     1         'K','L','M','N','O','P','Q','R','S','T',
     2         'U','V','W','X','Y','Z',
     3         '.','a','b','c','d','e','f','g','h','i','j',
     4         'k','l','m','n','o','p','q','r','s','t',
     5         'u','v','w','x','y','z'/ 
C
C
      CHARACTER DIR_I*150, DIR_O*150
C
C
C //////////////////////////////////////////////////////////////////////
      OPEN( 91, FILE = 'calcnd_d', status='old' )
C //////////////////////////////////////////////////////// I/O FILES ///
      READ(91,'(A)') DIR_I
      DO 771 ICHR_I=1,150
        IF( DIR_I(ICHR_I:ICHR_I+1).EQ.'  ' ) GO TO 772
  771 CONTINUE
  772 ICHR_I=ICHR_I-1
C
      READ(91,'(A)') DIR_O
      DO 773 ICHR_O=1,150
        IF( DIR_O(ICHR_O:ICHR_O+1).EQ.'  ' ) GO TO 774
  773 CONTINUE
  774 ICHR_O=ICHR_O-1
C
      WRITE(*,'(A20,A)') '  INPUT  FILES DIR; ',DIR_I(1:ICHR_I)
      WRITE(*,'(A20,A)') '  OUTPUT FILES DIR; ',DIR_O(1:ICHR_O)
C //////////////////////////////////////////////////////////////////////
C
C***** READ FILES **********************************
      OPEN( 13, FILE = DIR_I(1:ICHR_I)//'depth_d',status='old' )
      OPEN(  9, FILE = DIR_I(1:ICHR_I)//'addfd_d',status='old' )
      OPEN( 31, FILE = DIR_I(1:ICHR_I)//'pnt'  ,status='old' )
C***************************************************
C
C***** WRITE FILES *********************************
      OPEN(11,FILE=DIR_O(1:ICHR_O)//'eta'   ,status='unknown')
      OPEN(14,FILE=DIR_O(1:ICHR_O)//'h'     ,status='unknown')
      OPEN(17,FILE=DIR_O(1:ICHR_O)//'h13'   ,status='unknown')
      OPEN(18,FILE=DIR_O(1:ICHR_O)//'uvavg' ,status='unknown')
      OPEN(20,FILE=DIR_O(1:ICHR_O)//'depth2',status='unknown')
      OPEN(21,FILE=DIR_O(1:ICHR_O)//'saiha' ,status='unknown')
      OPEN(23,FILE=DIR_O(1:ICHR_O)//'te'    ,status='unknown')
      OPEN(29,FILE=DIR_O(1:ICHR_O)//'fd'    ,status='unknown')
      OPEN(34,FILE=DIR_O(1:ICHR_O)//'eavg'  ,status='unknown')
      OPEN(35,FILE=DIR_O(1:ICHR_O)//'cwavg1',status='unknown')
      OPEN(36,FILE=DIR_O(1:ICHR_O)//'cwavg2',status='unknown')
      OPEN(40,FILE=DIR_O(1:ICHR_O)//'nwave' ,status='unknown')
C
      OPEN(30,FILE=DIR_O(1:ICHR_O)//'eh'    ,status='unknown')
      OPEN(90,FILE=DIR_O(1:ICHR_O)//'foravs',status='unknown')
C
C********* 萔 ********************************************************
      PI = 3.14159265D0
      G  = 9.8D0
      ZERO = 0.0D0
C
C///////////////////////////////////////////////////
C          INITIALIZE
C///////////////////////////////////////////////////
C
      CALL INITZR( IMAX, JMAX, NN, LDM, NPMAX,
     1      E, EOLD, P, POLD, Q, QOLD, PTMP, QTMP,
     2      EIN, EINOLD, PIN, PINOLD, QIN, QINOLD, H, HX, HY, HP, DH,
     3      FD, FDX, FDY, XNYU, YNYU, EMIN, EMAX, HAKOU, HRMS, 
     4      UAVG, VAVG, DQDY, DPDX, FFX, FFY, EAVG, FXT, FYT,
     5      SUMH, SUMU, SUMV, SUME, SUME2, SUMWAVE, NWAVE,
     6      us, vs, prouss, anyud, bnyud, dmean, dmold, suv,
     7      Pmax, Pmaxold, Pmin, Pminold, Qmax, Qmaxold, Qmin, Qminold,
     8      UB, VB, U, V, UMEAN, VMEAN, UMOLD, VMOLD,
     9      IBFLAG, brkmesh, PMEAN, QMEAN,
     +      AMP, AK, SITW, F, EPS,
     1      LPXJ, LXD1, LXD2, LPYI, LYD1, LYD2,
     2      NPII, NPJJ, PTHR,
     3      TT, ND, NSTEP, NHRMS, NHRMS2, NUAVG, NVAVG )
C
C***********************************************************************
C  vZݒt@C̓ǂݍ
C
      call readcalcnd(IMAX, JMAX,
     &                HH13, T13, SIT0, SMAX, NS, WL, H10, HLIMIT2,
     &                IBRK, RB, HLIMIT3,
     &                DT, TDEL, TOUT, TTIN, TSVE, TEND, 
     &                KAISU, IWTP, FLIMIT, FF1, FF2, FFHLM)
C
      CLOSE(91)
C
C******** ʖCWiFFHLM:FF1FF2̋E[j**********************
C
C******** H10:\[ WL: KAISU:X[WO **************
      H1 = H10+WL
C
C******** HLANDFIX:Œ藤iq̐ݒ ***********************************
      HLANDFIX = 0.0D0
C
C******** HLIMIT :ʉZ̐[0.0mݒ ***************************
      HLIMIT = 0.0D0
C
C******** HLIMIT2:ʉZ̍ŏ[ݒ ( HLIMIT2 > HLIMIT ) ******
C
C******** HLIMIT3:ʉZ̕ϑS[̍ŏlݒ(ӔgvZ) *******
C
C********* ӔgvZ̗LiIBRK=1̂ƂӔgvZsj*****************
C
C********* RB:ӔgwW (Kg:0.6 - 0.7AsKg:(0.6 - 0.7)*0.8j****
      IF( NS.NE.1 ) RB = RB*0.8D0
C
C******** QSɂgGlM[ *******************************
C      C1 = 8.0D0 * 10.0D0**(-4) * 0.0D0
C      S0 = 0.02D0
C
C******** GlM[zW̑W *********************************
      FTHETA = 2.0D0  ! "RECOMMENDED" for the high-order sponge layer
C
C***** vZiTTIN:ɑgԁATSVE:gL^JnATEND:vZԁj****
C
      NDT = INT( T13 / DT + 0.1 ) * 2
C
C !!!! ϐʂ̐U݂ꍇɂ͒߂ɐݒ肷
      NTTIN = IDINT( TTIN / DT + 0.1 ) * 2
C
C !!!! ȂƂvZ̈֓˔gSɓ`dgQꂪƂ݂Ȃ
C !!!! ȍ~Ƃi˔gAgɂ闬ꓙjB
C !!!! ƂɁAvZr̕ϐʂ̕ωɂڂꍇɂ́AɁA
C !!!! Kgł30gAsKgł100gxo߂ݒ肷B
      NTSVE = IDINT( TSVE / DT + 0.1 ) * 2
C
C !!!! TSVE班ȂƂAKgł30gAsKgł100gxo
C !!!! ݒ肷B
      NTEND = IDINT( TEND / DT + 0.1 ) * 2
C
C**** o͎ԁiNOUT:ʃf[^o͎AIOPN:nf[^o͊Ԋuj****
cccccc      NOUT = NDT * ( 60 )
      NOUT = NTEND
      IOPN = INT(TDEL/DT+0.001)*2
C
C******** ʏo͎ԊԊu *********************************************
      KOUT = NDT
      DS=HH13/2.0D0*0.2D0
C
C******** lU̗} ***********************************************
      LB1 = 1  ! using artificial diffusion "DANGER! NOT RECOMMENDED"
      LB2 = 2  ! averaging temporary eta on each computational box
C C      LABEL = LB1+LB2
      LABEL=2  ! or LABEL=0 "RECOMMENDED"
C
C******** Aj[Vf[^̏o ***********************************
      AVSST = TSVE
      AVSED = TSVE + 1.0D0*T13
      AVSDT = T13/20.0D0
C
C///////////////////////////////////////////////////
C          INPUT PNT
C///////////////////////////////////////////////////
C
      READ(31,4420) NPMX
      DO 4430 NNP=1,NPMX
        READ(31,4440) NPII(NNP), NPJJ(NNP)
 4430 CONTINUE
 4420 FORMAT(I10)
 4440 FORMAT(2I5)
      CLOSE(31)
C
C
C///////////////////////////////////////////////////
C          INPUT DEPTH
C///////////////////////////////////////////////////
C
      READ(13,'(4I10,F10.0)' ) IS, I0, I1, IE, DX
      READ(13,'(4I10)'       ) JS, J0, J1, JE
C
      READ( 13, '( A20, 2I10 )' )  CC, IMAX2, JMAX2
!      WRITE( *, '( A20, 2I10 )' )  CC, IMAX2, JMAX2
      DO  8  J = 1, JMAX2
        READ( 13, '( 8F10.0 )'  ) ( H(I,J), I = 1, IMAX2 )
    8 CONTINUE
      CLOSE(13)
C
      DO 83 J = 1, JMAX
        DO 84 I = 1, IMAX
          IF( H(I,J).GT.HLANDFIX ) H(I,J) = H(I,J) + WL
   84   CONTINUE
   83 CONTINUE
C
      DY = DX ! Yiq̐ݒ
C
C----Check Value
      IF(IE >= IMAX .OR. (IE+2) /= IMAX) THEN
       WRITE(*,*) 'CHECK IE'
       STOP
      ENDIF

      IF(JE >= JMAX .OR. (JE+2) /= JMAX) THEN
       WRITE(*,*) 'CHECK JE'
       STOP
      ENDIF

      IF(DX <= 0.0D0) THEN
       WRITE(*,*) 'CHECK DX'
       STOP
      ENDIF

      WRITE(*,*) '*** MESH CONDITION ***'
      WRITE(*,6600)  IS,I0,I1,IE
      WRITE(*,6601)  JS,J0,J1,JE
      WRITE(*,6602)  DX
 6600 FORMAT(2x,'IS =',I5,2X,'I0 =',I5,2X,'I1 =',I5,2X,'IE =',I5)
 6601 FORMAT(2x,'JS =',I5,2X,'J0 =',I5,2X,'J1 =',I5,2X,'JE =',I5)
 6602 FORMAT(2x,'DX =',F5.1)

C///////////////////////////////////////////////////
C          MODIFY DEPTH
C///////////////////////////////////////////////////
C
      CALL INPDEP( IMAX, JMAX, H, HX, HY, HP, DH,
     1  DMEAN, DMOLD, HLIMIT, HLIMIT2, HLIMIT3, FFX, FFY,
     2  FFHLM, KAISU, FXT, FYT, HLANDFIX )
C
      DO 17 J = 1, JMAX
        HZ(J) = HX(I0,J)
   17 CONTINUE
C
C///////////////////////////////////////////////////
C          SET ABSORPTION AREA
C///////////////////////////////////////////////////
C
      READ( 9,'(4I10,F10.0)' ) IS_D, I0_D, I1_D, IE_D, DX_D
      READ( 9,'(4I10)'       ) JS_D, J0_D, J1_D, JE_D
C
      READ ( 9, '( A20, 2I10 )' )  CC, IMAX2, JMAX2
!      WRITE( *, '( A20, 2I10 )' )  CC, IMAX2, JMAX2
      DO 19 J = 1, JMAX2
        READ( 9, '(8F10.0)' )  ( FD(I,J), I = 1, IMAX2 )
   19 CONTINUE
      CLOSE(9)
C
      CALL  CALCFD( IMAX, JMAX, H, HLIMIT,
     1     FD, FDX, FDY, FTHETA, T13, DX, DY )
C
C
C///////////////////////////////////////////////////
C          OUTPUT DEPTH2
C///////////////////////////////////////////////////
C
      WRITE(20,'(4I10,F10.4)' ) IS, I0, I1, IE, DX
      WRITE(20,'(4I10)'       ) JS, J0, J1, JE
C
      WRITE( 20, 8000 )  IMAX, JMAX
      DO 18 J = 1, JMAX
        WRITE( 20, '(8F10.4)' )  ( H(I,J), I = 1, IMAX )
   18 CONTINUE
 8000 FORMAT ( '              depth2', 2I10 )
C
C///////////////////////////////////////////////////
C          OUTPUT ABSORPTION COFFICIENT
C///////////////////////////////////////////////////
C
      WRITE(29,'(4I10,F10.4)' ) IS, I0, I1, IE, DX
      WRITE(29,'(4I10)'       ) JS, J0, J1, JE
C
          WRITE( 29, 296 ) IMAX, JMAX
  296     FORMAT ( '          FD        ', 2I10 )
          DO  297  J = 1, JMAX
            WRITE( 29, 298 ) ( FD(I,J), I = 1, IMAX )
  298       FORMAT ( 8F10.6 )
  297     CONTINUE
C
C
C///////////////////////////////////////////////////
C          SET KEISU
C///////////////////////////////////////////////////
C
      CALL  KEISU( DT, DX, DY )
C
C///////////////////////////////////////////////////
C          IRREGULAR WAVE
C///////////////////////////////////////////////////
C
      IF(NS > 0) THEN
        IF( (NS.EQ.1).OR.((IWTP.EQ.1).OR.(IWTP.EQ.2)) )THEN
          CALL IREGWAV_M( HZ,HH13,T13,H10,H1,SIT0,SMAX,NS,FLIMIT,IWTP )
          NRP = 1
        ELSE
          WRITE(*,*) 'gt@CO͂Ă'
          STOP
        END IF
      ELSEIF(NS < 0) THEN
        CALL READSPECTIN( NRP,HZ,H10,H1,NS,IWTP,GAMMA )
      ENDIF

      IF( (NRP.EQ.1).AND.(H10.GT.0.0D0) )THEN
        DO N = 1, NS
          DO J = 3, JMAX-2
            DELY = DBLE(J-J0)*DY
            PHSJ(N,J) = AK_J(N,J)*DELY*SIN(SITW(N))
          END DO
        END DO
      ELSE
        DO N = 1, NS
          DO J = 3, JMAX-2
            IF( J.LT.J0 )THEN
              PHSJ(N,J) = 0.0D0
              DO JJ = J, J0-1
                PHSJ(N,J) = PHSJ(N,J) - AK_J(N,JJ  )*DY*SIN(SITW(N))
              END DO
            ELSE IF( J.GT.J0 )THEN
              PHSJ(N,J) = 0.0D0
              DO JJ = J0+1, J
                PHSJ(N,J) = PHSJ(N,J) + AK_J(N,JJ-1)*DY*SIN(SITW(N))
              END DO
            ELSE
              PHSJ(N,J) = 0.0D0
            END IF
          END DO
        END DO
      END IF
C
C
C*********  ****************************************************
C
      IF( H10.GT.0.0D0 )THEN
        DEP = H1
      ELSE
        JC  = JMAX/2
        DEP = HZ(JC)
      END IF
      CALL WVL_M (DEP, T13, AL )
      WRITE(*,'(14H DX DT ALPHA =,3F10.5)') DX, DT, (T13/DT)/(AL/DX)
C
C***********************************************************************
C
C
      nd=0
C
C
      TT = 0.0D0
      NSTEP = 0
      NHRMS = 0
      NHRMS2= 0
      NUAVG = 0
      NVAVG = 0
      NUAVG2 = 0
      NVAVG2 = 0
C
C
      IF( NS.EQ.1 )THEN
        NN0 = NDT*30
      ELSE
        NN0 = NDT*100
      END IF
      RN0 = 0.0D0
      RN1 = 0.0D0
      RN2 = 0.0D0
      RUN0 = 0.0D0
      RUN1 = 0.0D0
      RUN2 = 0.0D0
      RVN0 = 0.0D0
      RVN1 = 0.0D0
      RVN2 = 0.0D0
C
C
!      WRITE(*,*) NS ,IWTP
C
      IF( NS.EQ.1 )THEN           ! (Regular)
        RLH = 2.828D0
        RLG = 1.0D0
      ELSE
       IF(IWTP.EQ.1) THEN
        RLH = 4.004D0             ! (BS Sf)
        RLG = 1.597D0             ! (BS Sf)
       ELSEIF(IWTP.EQ.2) THEN
        RLH = 3.8D0               ! (BS-G Sf)
        RLG = 1.565D0             ! (BS-G Sf)
       ELSEIF(IWTP.EQ.3) THEN
        IF(GAMMA == 1.0D0) THEN
         RLH = 3.80D0
         RLG = 1.565D0
        ELSEIF(GAMMA == 3.3D0) THEN
         RLH = 3.87D0
         RLG = 1.573D0
        ELSEIF(GAMMA == 10.0D0) THEN
         RLH = 3.91D0
         RLG = 1.576D0
        ELSEIF(GAMMA == 20.0D0) THEN
         RLH = 3.93D0
         RLG = 1.577D0
        ELSE
         CALL CALRLHRLG(F,AMP,NS,RLH,RLG)
        ENDIF
cccccc       ELSEIF(IWTP.EQ.9) THEN
       ELSE
         CALL CALRLHRLG(F,AMP,NS,RLH,RLG)
       END IF
      ENDIF
C
C
C     ============  CALCULATION START  =============
C
C
      CALL  BDCALX2D( IMAX, JMAX, H, E, HLIMIT,
     1                LDM, LPX1, LPXJ, LXD1, LXD2 )
C
      CALL  BDCALY2D( IMAX, JMAX, H, E, HLIMIT,
     1                LDM, LPY1, LPYI, LYD1, LYD2 )
C
 1000 CONTINUE
C
C
C           X - DIRECTION
C
C
      NSTEP = NSTEP + 1
      TT = DBLE(NSTEP) * DT * 0.5D0
C
C
      CALL  INWAVEX_M( IMAX, JMAX, EIN, EINOLD, H, HLIMIT,
     1                 PIN, PINOLD,
     2                 DX, DY, TT, TTIN, NS, DT )
C
      CALL  CALCX( IMAX, JMAX, E, EOLD,
     1                   P, POLD, Q, QOLD, PTMP,
     2                   EIN, EINOLD,
     3                   PIN, PINOLD, QIN, QINOLD,
     4                   FDX, XNYU, HLIMIT,
     5                   H, HX, HP, DX, DY, DT,
     6                   DQDY, FFX, FXT,
     9                   LDM, LPX1, LPXJ, LXD1, LXD2,
     3                   LABEL )
C
      CALL CALHAKOU ( IMAX, JMAX,
     &   E, EOLD, EMIN, EMAX, HAKOU, HLIMIT, H, HX, HY, P, Q,
     &   SUMCWX, SUMCWY, CWX, CWY, SYUKI, SUMSYUKI,
     &   EAVG, UAVG, VAVG, POLD, QOLD,
     &   NZST, NDIRC, NSTEP, NDT, NWAVE, SUMWAVE, NTSVE )
C
      CALL SUMHEAVG( IMAX, JMAX, SUMH, SUME, SUME2, E, EAVG,
     &               NHRMS, NHRMS2, NSTEP, NTSVE, HRMS2,
     &               NN0, CA, RY, RN0, RN1, RN2 )
C
      CALL CALCUV( IMAX, JMAX, P, Q, POLD, QOLD, EOLD,
     &      U, V, HX, HY,
     &      NSTEP, LDM, LPX1, LPXJ, LXD1, LXD2, LPY1, LPYI, LYD1, LYD2 )
C
      CALL SUMUVAVG( IMAX, JMAX, NUAVG, NVAVG, NUAVG2, NVAVG2,
     &     U, V, SUMU, SUMV, SUMU2, SUMV2, UAVG, VAVG,
     &     EOLD, SUMEU, SUMEV, NTSVE,
     &     NN0, CUA, RUY, RUN0, RUN1, RUN2, CVA, RVY, RVN0, RVN1, RVN2,
     &     NSTEP, LDM, LPX1, LPXJ, LXD1, LXD2, LPY1, LPYI, LYD1, LYD2 )
C
      IF( IBRK.EQ.1 )THEN
C
      CALL calbrk( nstep, imax, jmax, NS
     &         , NDT, T13, dx, dy, TT, EAVG
     &         , P, Q, Pold, Qold, us, vs, prouss
     &         , anyud, bnyud, dmean, dmold, E, EOLD
     &         , h, hx, hy, XNYU, YNYU, suv
     &         , Pmax, Pmaxold, Pmin, Pminold
     &         , Qmax, Qmaxold, Qmin, Qminold
     &         , HAKOU, U, V, IBFLAG
     &         , nd
     &         , HLIMIT, EMIN, EMAX
     &         , S0, C1, RB
     &         , LDM, LPX1, LPXJ, LXD1, LXD2
     &         ,      LPY1, LPYI, LYD1, LYD2 )
C
      END IF
C
C
C        Y - DIRECTION
C
C
      NSTEP = NSTEP + 1
      TT = DBLE(NSTEP) * DT * 0.5D0
C
C
      CALL  INWAVEY_M( IMAX, JMAX, EIN, EINOLD, H, HLIMIT,
     1                 QIN, QINOLD,
     2                 DX, DY, TT, TTIN, NS, DT )
C
      CALL  CALCY( IMAX, JMAX, E, EOLD,
     1                   P, POLD, Q, QOLD, QTMP,
     2                   EIN, EINOLD, 
     3                   PIN, PINOLD, QIN, QINOLD,
     4                   FDY, YNYU, HLIMIT,
     5                   H, HY, HP, DX, DY, DT,
     6                   DPDX, FFY, FYT,
     9                   LDM, LPY1, LPYI, LYD1, LYD2,
     3                   LABEL )
C
      CALL CALHAKOU ( IMAX, JMAX,
     &   E, EOLD, EMIN, EMAX, HAKOU, HLIMIT, H, HX, HY, P, Q,
     &   SUMCWX, SUMCWY, CWX, CWY, SYUKI, SUMSYUKI,
     &   EAVG, UAVG, VAVG, POLD, QOLD,
     &   NZST, NDIRC, NSTEP, NDT, NWAVE, SUMWAVE, NTSVE )
C
      CALL SUMHEAVG( IMAX, JMAX, SUMH, SUME, SUME2, E, EAVG,
     &               NHRMS, NHRMS2, NSTEP, NTSVE, HRMS2,
     &               NN0, CA, RY, RN0, RN1, RN2 )
C
      CALL CALCUV( IMAX, JMAX, P, Q, POLD, QOLD, EOLD,
     &      U, V, HX, HY,
     &      NSTEP, LDM, LPX1, LPXJ, LXD1, LXD2, LPY1, LPYI, LYD1, LYD2 )
C
      CALL SUMUVAVG( IMAX, JMAX, NUAVG, NVAVG, NUAVG2, NVAVG2,
     &     U, V, SUMU, SUMV, SUMU2, SUMV2, UAVG, VAVG,
     &     EOLD, SUMEU, SUMEV, NTSVE,
     &     NN0, CUA, RUY, RUN0, RUN1, RUN2, CVA, RVY, RVN0, RVN1, RVN2,
     &     NSTEP, LDM, LPX1, LPXJ, LXD1, LXD2, LPY1, LPYI, LYD1, LYD2 )
C
      IF( IBRK.EQ.1 )THEN
C
      CALL calbrk( nstep, imax, jmax, NS
     &         , NDT, T13, dx, dy, TT, EAVG
     &         , P, Q, Pold, Qold, us, vs, prouss
     &         , anyud, bnyud, dmean, dmold, E, EOLD
     &         , h, hx, hy, XNYU, YNYU, suv
     &         , Pmax, Pmaxold, Pmin, Pminold
     &         , Qmax, Qmaxold, Qmin, Qminold
     &         , HAKOU, U, V, IBFLAG
     &         , nd
     &         , HLIMIT, EMIN, EMAX
     &         , S0, C1, RB
     &         , LDM, LPX1, LPXJ, LXD1, LXD2
     &         ,      LPY1, LPYI, LYD1, LYD2 )
C
      END IF
C
C
C===============================================================
      DO 649 J = 1, JMAX
      DO 649 I = 1, IMAX
        IF( HRMS2(I,J).GT.HLIMIT )THEN
          HRTP = HRMS2(I,J)**2-EAVG(I,J)**2
          IF( HRTP.GT.HLIMIT )THEN
            HRMS(I,J) = SQRT( HRTP )
          ELSE
            HRMS(I,J) = 0.0D0
          END IF
        END IF
  649 CONTINUE
C===============================================================
C
C
      IF(MOD(NSTEP,KOUT).EQ.0)THEN
      DO 100 I=IS,IE,2
      DO 101 J=JE,JS,-4
C
      HCHR = E(I,J)
C
      IF(HCHR.LT.ZERO) GOTO 70
      IF(HCHR.EQ.ZERO) GOTO 80
      IF(HCHR.GT.ZERO) GOTO 90
   70 ICHR=INT(ABS(HCHR)/DS)+29
      IF(ICHR.GE.54) ICHR=54
      GO TO 199
   80 ICHR=28
      GO TO 199
   90 ICHR=INT(HCHR/DS)+2
      IF(ICHR.GE.27) ICHR=27
  199 IB(I,J)=ICH(ICHR)
  101 CONTINUE
  100 CONTINUE
      DO 280 J=JE,JS,-4
        IF(J.EQ.J0) WRITE(*,'(A61)')
     +'0---------1---------2---------3---------4---------5---------6'
        IF(J.EQ.J1) WRITE(*,'(A61)')
     +'0---------1---------2---------3---------4---------5---------6'
        WRITE(*,200)(IB(I,J),I=IS,IE,4)
  280 CONTINUE
  200 FORMAT(79A1)
      WRITE(*,'(10X,A2,F10.2,5X,A7,I10)')
     +  'T=',DT*DBLE(NSTEP/2),' NSTEP=',NSTEP
      END IF
C
C
C///////////////////////////////////////////////////
C          OUTPUT RUNTIME DATA
C///////////////////////////////////////////////////
C
C      IF ( ( NSTEP - (NSTEP/NDT) * NDT ) .EQ. 0 ) THEN
C      JC = ( J0 + J1 ) / 2
C      WRITE( 6, '(I10,F10.4,5F10.4)' ) NSTEP, TT,
C     &             HAKOU(IS,JC),HAKOU(I0-1,JC),HAKOU(I0,JC),
C     &             HAKOU(I1,JC),HAKOU(IE,JC)
C      ENDIF
      IF ( ( NSTEP - (NSTEP/NDT) * NDT ) .EQ. 0 ) THEN
      JC = ( J0 + J1 ) / 2
        if( nstep.lt.ntsve )then
      WRITE( 6, '(I10,F10.4,2F10.4,1X,E9.2,4X,A2,4X,1X,E9.2)' )
     &  NSTEP, TT, HAKOU(I1-1,JC),HRMS2(I1-1,JC),
     &  SUME(I1-1,JC)/DBLE(NHRMS),'--',
     &  EAVG(I1-1,JC)
        else
      WRITE( 6, '(I10,F10.4,2F10.4,3(1X,E9.2))' )
     &  NSTEP, TT, HAKOU(I1-1,JC),HRMS2(I1-1,JC),
     &  SUME(I1-1,JC)/DBLE(NHRMS),SUME2(I1-1,JC)/DBLE(NHRMS2),
     &  EAVG(I1-1,JC)
        end if
      ENDIF
C
C
C///////////////////////////////////////////////////
C          OUTPUT CALCLATION RESULTS
C///////////////////////////////////////////////////
C
C
 6120 FORMAT ( 8F10.5 )
C
C
      IF ( ((NSTEP-INT(NSTEP/NOUT)*NOUT).EQ.0).OR.(TT.GE.TEND) )THEN
C
       WRITE( 6, '(6H CHECK,2I20)' ) NSTEP, NOUT
C
C *** OUTPUT WATER SURFACE ELEVATION
C
          WRITE( 11, 6100 )  IMAX, JMAX
          DO  6110  J = 1, JMAX
            WRITE( 11, 6120 ) ( E(I,J), I = 1, IMAX )
 6110     CONTINUE
 6100     FORMAT ( '                 ETA', 2I10 )
C
C *** OUTPUT WAVE HEIGHT (Hrms)
C
          WRITE( 17, 650 ) IMAX, JMAX
          DO  651  J = 1, JMAX
            WRITE( 17, 6120 )  (HRMS(I,J)*RLH,I=1,IMAX)
  651     CONTINUE
  650     FORMAT ( '                HRMS', 2I10 )
C
C *** OUTPUT WAVE HEIGHT
C
          WRITE( 14, 6101 )  IMAX, JMAX
          DO  6111  J = 1, JMAX
            WRITE( 14, 6120 )  (HAKOU(I,J)*RLG,I=1,IMAX)
 6111     CONTINUE
 6101     FORMAT ( '               HAKOU', 2I10 )
C
C *** OUTPUT NWAVE
C
          WRITE( 40, 6501 )  IMAX, JMAX
          DO  6511  J = 1, JMAX
              WRITE( 40, '(8I10)' ) ( NWAVE(I,J), I = 1, IMAX )
 6511     CONTINUE
 6501     FORMAT ( '               NWAVE', 2I10 )
C
C *** OUTPUT   EAVG
          WRITE( 34, 6109 )  IMAX, JMAX
          DO  6119  J = 1, JMAX
            WRITE( 34, 6120 ) ( EAVG(I,J), I = 1, IMAX )
 6119     CONTINUE
 6109     FORMAT ( '                EAVG', 2I10 )
        IF ( TT.GE.TEND )THEN
          WRITE( 34, 6108 )  IMAX, JMAX
          DO  6118  J = 1, JMAX
            WRITE( 34, 6120 ) ( SUME2(I,J)/DBLE(NHRMS2), I = 1, IMAX )
 6118     CONTINUE
 6108     FORMAT ( '               EAVG2', 2I10 )
        END IF
C
C *** OUTPUT AVERAGE VELOCITY
C
          WRITE( 18, 652 ) IMAX, JMAX
          DO  653  J = 1, JMAX
            WRITE( 18, 6120 )  ( UAVG(I,J), I = 1, IMAX )
  653     CONTINUE
  652     FORMAT ( '                UAVG', 2I10 )
          WRITE( 18, 654 ) IMAX, JMAX
          DO  655  J = 1, JMAX
            WRITE( 18, 6120 )  ( VAVG(I,J), I = 1, IMAX )
  655     CONTINUE
  654     FORMAT ( '                VAVG', 2I10 )
        IF ( TT.GE.TEND )THEN
          WRITE( 18, 657 ) IMAX, JMAX
          DO  656  J = 1, JMAX
            WRITE( 18, 6120 )  ( SUMU2(I,J)/DBLE(NUAVG2), I = 1, IMAX )
  656     CONTINUE
  657     FORMAT ( '               UAVG2', 2I10 )
          WRITE( 18, 659 ) IMAX, JMAX
          DO  658  J = 1, JMAX
            WRITE( 18, 6120 )  ( SUMV2(I,J)/DBLE(NVAVG2), I = 1, IMAX )
  658     CONTINUE
  659     FORMAT ( '               VAVG2', 2I10 )
        END IF
C
C *** OUTPUT WAVE DIRCTION 1
C
      DO 7010 J = 1, JMAX
        DO 7011 I = 1, IMAX
          IF( NDIRC(I,J).GT.0 )THEN
            AVGCWX(I,J) = SUMCWX(I,J) / DBLE(NDIRC(I,J))
            AVGCWY(I,J) = SUMCWY(I,J) / DBLE(NDIRC(I,J))
            IF( AVGCWX(I,J).GT.0.0D0 )THEN
              DIRM(I,J) = atan(AVGCWY(I,J)/AVGCWX(I,J))/PI*180.0D0
              IF( DIRM(I,J).LT.0.0D0 )
     &          DIRM(I,J) = DIRM(I,J) + 360.0D0
            ELSE IF( AVGCWX(I,J).LT.0.0D0 )THEN
              DIRM(I,J) = atan(AVGCWY(I,J)/AVGCWX(I,J))/PI*180.D0
     &                    + 180.D0
            ELSE IF( AVGCWX(I,J).EQ.0.0D0 )THEN
              IF( AVGCWY(I,J).GT.0.0D0 ) DIRM(I,J) =  90.0D0
              IF( AVGCWY(I,J).LT.0.0D0 ) DIRM(I,J) = 270.0D0
              IF( AVGCWY(I,J).EQ.0.0D0 ) DIRM(I,J) =-900.0D0  ! error code
            ENDIF
          ELSE
            AVGCWX(I,J) = 0.0D0
            AVGCWY(I,J) = 0.0D0
            DIRM(I,J)   = 0.0D0
          END IF
 7011   CONTINUE
 7010 CONTINUE
C
        WRITE( 35, '(A20,2I10)' ) '              AVGCWX',IMAX,JMAX
        DO  663  J = 1, JMAX
          WRITE( 35, 6120 )  ( AVGCWX(I,J), I = 1, IMAX )
  663   CONTINUE
        WRITE( 35, '(A20,2I10)' ) '              AVGCWY',IMAX,JMAX
        DO  664  J = 1, JMAX
          WRITE( 35, 6120 )  ( AVGCWY(I,J), I = 1, IMAX )
  664   CONTINUE
        WRITE( 35, '(A20,2I10)' ) '                DIRM',IMAX,JMAX
        DO  665  J = 1, JMAX
          WRITE( 35, 6120 )  ( DIRM(I,J), I = 1, IMAX )
  665   CONTINUE
        WRITE( 35, '(A20,2I10)' ) '               SYUKI',IMAX,JMAX
        DO  666  J = 1, JMAX
          WRITE( 35, 6120 )  ( SYUKI(I,J)*DT/2.0D0, I = 1, IMAX )
  666   CONTINUE
        WRITE( 35, '(A20,2I10)' ) '               NDIRC',IMAX,JMAX
        DO  667  J = 1, JMAX
          WRITE( 35, '(8I10)' )  ( NDIRC(I,J), I = 1, IMAX )
  667   CONTINUE
C
C *** OUTPUT WAVE DIRCTION 2
C
        DO 7060 J=JS,JE
          DO 7061 I=IS,IE
          IF( (NUAVG2.GT.0).AND.(NVAVG2.GT.0) )THEN
            EUAVG(I,J) = SUMEU(I,J)/DBLE(NUAVG2) - EAVG(I,J)*UAVG(I,J)
            EVAVG(I,J) = SUMEV(I,J)/DBLE(NVAVG2) - EAVG(I,J)*VAVG(I,J)
            IF( EUAVG(I,J).GT.0.0D0 )THEN
              DIRM2(I,J) = atan(EVAVG(I,J)/EUAVG(I,J))/PI*180.0D0
              IF( DIRM2(I,J).LT.0.0D0 ) DIRM2(I,J) = DIRM2(I,J) +360.0D0
            ELSE IF( EUAVG(I,J).LT.0.0D0 )THEN
              DIRM2(I,J) = atan(EVAVG(I,J)/EUAVG(I,J))/PI*180.D0 +180.D0
            ELSE IF( EUAVG(I,J).EQ.0.0D0 )THEN
              IF( EVAVG(I,J).GT.0.0D0 ) DIRM2(I,J) =  90.0D0
              IF( EVAVG(I,J).LT.0.0D0 ) DIRM2(I,J) = 270.0D0
              IF( EVAVG(I,J).EQ.0.0D0 ) DIRM2(I,J) =-900.0D0  ! error code
            ENDIF
              EM00= HRMS2(I,J)**2-EAVG(I,J)**2
            IF( (EM00.GT.0.0D0).AND.(DIRM2(I,J).NE.-900.0D0))THEN
C *** U@icA1981jAqx̋Uł͍ *********
C              AVGK2 = SQRT( EUAVG(I,J)**2+EVAVG(I,J)**2 )/EM00
C              CWVEC = SQRT( G/AVGK2*TANH(AVGK2*(H(I,J)-EAVG(I,J))) )
C *** ώgAgZ肷@ *****************************
              SWD = H(I,J)-EAVG(I,J)
              IF( NS.EQ.1 )THEN
                TPT = SYUKI(I,J)*DT*0.5D0
              ELSE
                TPT = SYUKI(I,J)*DT*0.5D0 *1.2D0
              END IF
              CALL WVL ( SWD, TPT, APL )
                AVGK2 = 2.0D0*PI/APL
                CWVEC = SQRT( G/AVGK2*TANH(AVGK2*SWD) )
C **********************************************************************
              AGCWX2(I,J) = CWVEC * COS( DIRM2(I,J)/180.0D0*PI )
              AGCWY2(I,J) = CWVEC * SIN( DIRM2(I,J)/180.0D0*PI )
            ELSE
              AGCWX2(I,J) = 0.0D0
              AGCWY2(I,J) = 0.0D0
            END  IF
          ELSE
            AGCWX2(I,J) = 0.0D0
            AGCWY2(I,J) = 0.0D0
          END IF
 7061     CONTINUE
 7060   CONTINUE
C
        WRITE( 36, '(A20,2I10)' ) '              AGCWX2',IMAX,JMAX
        DO  7063  J = 1, JMAX
          WRITE( 36, 6120 )  ( AGCWX2(I,J), I = 1, IMAX )
 7063   CONTINUE
        WRITE( 36, '(A20,2I10)' ) '              AGCWY2',IMAX,JMAX
        DO  7064  J = 1, JMAX
          WRITE( 36, 6120 )  ( AGCWY2(I,J), I = 1, IMAX )
 7064   CONTINUE
        WRITE( 36, '(A20,2I10)' ) '               DIRM2',IMAX,JMAX
        DO  7065  J = 1, JMAX
          WRITE( 36, 6120 )  ( DIRM2(I,J), I = 1, IMAX )
 7065   CONTINUE
C
      ENDIF
C
C///////////////////////////////////////////////////
C          OUTPUT FOR ANIMATION
C///////////////////////////////////////////////////
C
      NOUTAVS = INT( AVSDT/DT+0.001 )*2
      IF ( MOD(NSTEP,NOUTAVS).EQ.0 )THEN
C
        IF( (TT.GE.AVSST).AND.(TT.LE.AVSED) )THEN
C
        WRITE( 90, '(F10.4,2I10)' ) TT,I1-I0,J1-J0
        DO  6996  J = J0, J1-1
          WRITE( 90, '(8F10.5)' ) ( E(I,J),I = I0, I1-1 )
 6996   CONTINUE
C
        ENDIF
C
      ENDIF
C
C///////////////////////////////////////////////////
C          OUTPUT TIME SERIES DATA
C///////////////////////////////////////////////////
C
      IF(NPMX.EQ.0) GO TO 6999
      IF(MOD(NSTEP,IOPN).EQ.0)THEN
C
      MILISEC = 1000*DT*NSTEP/2
      DO 6610 NNP=1,NPMX
       IP=NPII(NNP)
       JP=NPJJ(NNP)
C C       PTHR(NNP,1) = EOLD(IP,JP)                   * 100.0D0  ![cm]
C C       PTHR(NNP,2) = ( U(IP,JP)+U(IP+1,JP) )/2.0D0 * 100.0D0  ![cm]
C C       PTHR(NNP,3) = ( V(IP,JP)+V(IP,JP+1) )/2.0D0 * 100.0D0  ![cm]
       PTHR(NNP,1) = EOLD(IP,JP)
       PTHR(NNP,2) = ( U(IP,JP)+U(IP+1,JP) )/2.0D0
       PTHR(NNP,3) = ( V(IP,JP)+V(IP,JP+1) )/2.0D0
C C       WRITE(23,6611)MILISEC,NNP,NPII(NNP),NPJJ(NNP),(PTHR(NNP,L),L=1,3)
C C 6611 FORMAT(I10,2X,3I4,2X,3F9.3)
 6610 CONTINUE
C
      WRITE(23,'(600F10.4)') (PTHR(NNP,1),NNP=1,NPMX),
     &  (PTHR(NNP,2),NNP=1,NPMX),(PTHR(NNP,3),NNP=1,NPMX)
C
      END IF
 6999 CONTINUE
C
C
C            RETURN TO START OF LOOP 
C
C
      IF ( TT .LT. TEND ) GOTO 1000
C
C
C///////////////////////////////////////////////////
C          OUTPUT WAVE BREAKING JUDGEMENT
C///////////////////////////////////////////////////
C
      DO 6122 J=1,JMAX
      DO 6123 I=2,IMAX
        brkmesh(i,j)=IBFLAG(i-1,j)+IBFLAG(i,j)
 6123 CONTINUE
        brkmesh(1,j)=IBFLAG(1,j)
 6122 CONTINUE
C
      WRITE( 21, 6131 )  IMAX, JMAX
      DO  6121  J = 1, JMAX
        WRITE( 21, '(20f4.1)' ) ( brkmesh(I,J), I = 1, IMAX )
 6121 CONTINUE
 6131 FORMAT ( '               SAIHA', 2I10 )
C
C///////////////////////////////////////////////////
C
      JC = ( J0 + J1 ) / 2
      DO 7000 I = IS, IE
        WRITE(30,'(I5,4F10.4,3(1X,E9.2))')
     &  I,H(I,JC),HAKOU(I,JC)*RLG,HRMS(I,JC)*RLH,HRMS2(I,JC)*RLH,
     &  SUME(I,JC)/DBLE(NHRMS),SUME2(I,JC)/DBLE(NHRMS2),EAVG(I,JC)
 7000 CONTINUE
C
C///////////////////////////////////////////////////
C
      CLOSE(11)
      CLOSE(14)
      CLOSE(17)
      CLOSE(18)
      CLOSE(20)
      CLOSE(21)
      CLOSE(23)
      CLOSE(29)
      CLOSE(34)
      CLOSE(35)
      CLOSE(36)
C
C      CLOSE(30)
C      CLOSE(50)
C
      CLOSE(90)
C
 9999 CONTINUE
C
      STOP
      END
C
C    ================== MAIN PROGRAM END ============
C
C
C     -------------  INITIALIZE  ---------------
C
      SUBROUTINE INITZR( IMAX, JMAX, NN, LDM, NPMAX,
     1      E, EOLD, P, POLD, Q, QOLD, PTMP, QTMP,
     2      EIN, EINOLD, PIN, PINOLD, QIN, QINOLD, H, HX, HY, HP, DH,
     3      FD, FDX, FDY, XNYU, YNYU, EMIN, EMAX, HAKOU, HRMS, 
     4      UAVG, VAVG, DQDY, DPDX, FFX, FFY, EAVG, FXT, FYT,
     5      SUMH, SUMU, SUMV, SUME, SUME2, SUMWAVE, NWAVE,
     6      us, vs, prouss, anyud, bnyud, dmean, dmold, suv,
     7      Pmax, Pmaxold, Pmin, Pminold, Qmax, Qmaxold, Qmin, Qminold,
     8      UB, VB, U, V, UMEAN, VMEAN, UMOLD, VMOLD,
     9      IBFLAG, brkmesh, PMEAN, QMEAN,
     +      AMP, AK, SITW, F, EPS,
     1      LPXJ, LXD1, LXD2, LPYI, LYD1, LYD2,
     2      NPII, NPJJ, PTHR,
     3      TT, ND, NSTEP, NHRMS, NHRMS2, NUAVG, NVAVG )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   E(IMAX,JMAX), EOLD(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX), POLD(IMAX,JMAX), PTMP(IMAX,JMAX)
      DIMENSION   Q(IMAX,JMAX), QOLD(IMAX,JMAX), QTMP(IMAX,JMAX)
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HY(IMAX,JMAX), 
     1            HP(IMAX,JMAX), DH(IMAX,JMAX)
      DIMENSION   FD(IMAX,JMAX), FDX(IMAX,JMAX), FDY(IMAX,JMAX)
      DIMENSION   XNYU(IMAX,JMAX), YNYU(IMAX,JMAX)
      DIMENSION   EMIN(IMAX,JMAX), EMAX(IMAX,JMAX), HAKOU(IMAX,JMAX)
      DIMENSION   HRMS(IMAX,JMAX), UAVG(IMAX,JMAX), VAVG(IMAX,JMAX)
      DIMENSION   DQDY(IMAX,JMAX), DPDX(IMAX,JMAX)
      DIMENSION   FFX(IMAX,JMAX), FFY(IMAX,JMAX)
      DIMENSION   EAVG(IMAX,JMAX)
      DIMENSION   FXT(IMAX,JMAX), FYT(IMAX,JMAX)
C
      DIMENSION   SUMH(IMAX,JMAX), SUMU(IMAX,JMAX), SUMV(IMAX,JMAX)
      DIMENSION   SUME(IMAX,JMAX), SUME2(IMAX,JMAX)
C
      DIMENSION   SUMWAVE(IMAX,JMAX)
      DIMENSION   NWAVE(IMAX,JMAX)
C
      DIMENSION us(imax,jmax), vs(imax,jmax)
     &     , prouss(imax,jmax)
     &     , anyud(imax,jmax), bnyud(imax,jmax), dmean(imax,jmax)
     &     , dmold(imax,jmax), suv(imax,jmax), Pmax(imax,jmax)
     &     , Pmaxold(imax,jmax), Pmin(imax,jmax), Pminold(imax,jmax)
     &     , Qmax(imax,jmax), Qmaxold(imax,jmax), Qmin(imax,jmax)
     &     , Qminold(imax,jmax)
C
      DIMENSION  U(IMAX,JMAX), V(IMAX,JMAX)
      INTEGER    IBFLAG(imax,jmax)
      DIMENSION  brkmesh(imax,jmax)
C
      DIMENSION  AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)
C
      INTEGER    LPXJ(LDM),LXD1(LDM),LXD2(LDM),
     *           LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
      INTEGER    NPII(NPMAX), NPJJ(NPMAX)
      DIMENSION  PTHR(NPMAX,3)
C
C
      DO  100  I = 1, IMAX
        DO  110  J = 1, JMAX
C
          E(I,J)       = 0.0D0
          EOLD(I,J)    = 0.0D0
          P(I,J)       = 0.0D0
          POLD(I,J)    = 0.0D0
          Q(I,J)       = 0.0D0
          QOLD(I,J)    = 0.0D0
          EIN(I,J)     = 0.0D0
          EINOLD(I,J)  = 0.0D0
          PIN(I,J)     = 0.0D0
          PINOLD(I,J)  = 0.0D0
          QIN(I,J)     = 0.0D0
          QINOLD(I,J)  = 0.0D0
          H(I,J)       = 0.0D0
          HX(I,J)      = 0.0D0
          HY(I,J)      = 0.0D0
          HP(I,J)      = 0.0D0
          DH(I,J)      = 0.0D0
          FD(I,J)      = 0.0D0
          FDX(I,J)     = 0.0D0
          FDY(I,J)     = 0.0D0
          XNYU(I,J)    = 0.0D0
          YNYU(I,J)    = 0.0D0
          EMIN(I,J)    =  1.0D5
          EMAX(I,J)    = -1.0D5
          HAKOU(I,J)   = 0.0D0
          HRMS(I,J)    = 0.0D0
          UAVG(I,J)    = 0.0D0
          VAVG(I,J)    = 0.0D0
          DQDY(I,J)    = 0.0D0
          DPDX(I,J)    = 0.0D0
          FFX(I,J)     = 0.0D0
          FFY(I,J)     = 0.0D0
          EAVG(I,J)    = 0.0D0
          SUMH(I,J)    = 0.0D0
          SUMU(I,J)    = 0.0D0
          SUMV(I,J)    = 0.0D0
          SUME(I,J)    = 0.0D0
          SUME2(I,J)   = 0.0D0
          SUMWAVE(I,J) = 0.0D0
          US(I,J)      = 0.0D0
          VS(I,J)      = 0.0D0
          PROUSS(I,J)  = 0.0D0
          ANYUD(I,J)   = 0.0D0
          BNYUD(I,J)   = 0.0D0
          DMEAN(I,J)   = 0.0D0
          DMOLD(I,J)   = 0.0D0
          SUV(I,J)     = 0.0D0
C         PMAX(I,J)    = -1.0D4
C         PMAXOLD(I,J) = -1.0D4
C         PMIN(I,J)    =  1.0D4
C         PMINOLD(I,J) =  1.0D4
C         QMAX(I,J)    = -1.0D4
C         QMAXOLD(I,J) = -1.0D4
C         QMIN(I,J)    =  1.0D4
C         QMINOLD(I,J) =  1.0D4
*--- modified by T.Naruke & K.Hirayama (2006.05.29)
          PMAX(I,J)    = 0.0D0
          PMAXOLD(I,J) = 0.0D0
          PMIN(I,J)    = 0.0D0
          PMINOLD(I,J) = 0.0D0
          QMAX(I,J)    = 0.0D0
          QMAXOLD(I,J) = 0.0D0
          QMIN(I,J)    = 0.0D0
          QMINOLD(I,J) = 0.0D0
*---
          U(I,J)       = 0.0D0
          V(I,J)       = 0.0D0
          BRKMESH(I,J) = 0.0D0
C
          IBFLAG(I,J)  = 0
          NWAVE(I,J)   = 0
C
          FXT(I,J)     = 0.0D0
          FYT(I,J)     = 0.0D0
C
          PTMP(I,J)    = 0.0D0
          QTMP(I,J)    = 0.0D0
C
  110   CONTINUE
  100 CONTINUE
C
      DO 200  I = 1, NN
        AMP(I)  = 0.0D0
        AK(I)   = 0.0D0
        SITW(I) = 0.0D0
        F(I)    = 0.0D0
        EPS(I)  = 0.0D0
  200 CONTINUE
C
      DO 300  I = 1, LDM
        LPXJ(I) = 0
        LXD1(I) = 0
        LXD2(I) = 0
        LPYI(I) = 0
        LYD1(I) = 0
        LYD2(I) = 0
  300 CONTINUE
C
      DO 400  I = 1, NPMAX
        NPII(I) = 0
        NPJJ(I) = 0
        DO 410 K = 1, 3
          PTHR(I,K) = 0.0D0
  410   CONTINUE
  400 CONTINUE
C
      TT     = 0.0D0
      ND     = 0
      NSTEP  = 0
      NHRMS  = 0
      NHRMS2 = 0
      NUAVG  = 0
      NVAVG  = 0
C
      RETURN
      END
C
C     --------- HRMS NO KEISAN ------------
C
      SUBROUTINE SUMHEAVG( IMAX, JMAX, SUMH, SUME, SUME2, E, EAVG,
     &                     NHRMS, NHRMS2, NSTEP, NTSVE, HRMS2,
     &                     NN0, CA, RY, RN0, RN1, RN2 )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION E(IMAX,JMAX)
      DIMENSION SUMH(IMAX,JMAX),  HRMS2(IMAX,JMAX)
      DIMENSION SUME(IMAX,JMAX),  EAVG(IMAX,JMAX)
      DIMENSION SUME2(IMAX,JMAX)
C
      DIMENSION RY(0:1,IMAX,JMAX), CA(0:1,IMAX,JMAX)
C
      NHRMS=NHRMS+1
      IF( NSTEP.GE.NTSVE ) NHRMS2=NHRMS2+1
C
      IF( NHRMS.LE.NN0 )THEN
        RN0 = DBLE(NHRMS)
        RN1 = RN1+RN0
        RN2 = RN2+RN0*RN0
      END IF
      C00 = RN0*RN2-RN1*RN1
C
      DO  7025  J = 1, JMAX
        DO  7026  I = 1, IMAX
C
          SUME(I,J)  = SUME(I,J) +E(I,J)
C
          IF( NHRMS.LE.NN0 )THEN
            RY(1,I,J) = RY(1,I,J)+E(I,J)*RN0
            RY(0,I,J) = RY(0,I,J)+E(I,J)
          ELSE
            RY(1,I,J) = RY(1,I,J)+E(I,J)*RN0-RY(0,I,J)
              EG0 = CA(0,I,J)+CA(1,I,J)*2.0D0
              EG1 = CA(0,I,J)+CA(1,I,J)*(RN0+1.0D0)
            RY(0,I,J) = RN0*0.5D0*( EG0+EG1 )
          END IF
          IF( NHRMS.LE.1 )THEN
            EAVG(I,J) = SUME(I,J)/DBLE(NHRMS)
            CA(1,I,J) = 0.0D0
            CA(0,I,J) = E(I,J)
          ELSE
            EAVG(I,J) = RY(0,I,J)/RN0
            CA(1,I,J) = ( RN0*RY(1,I,J)-RN1*RY(0,I,J) )/C00
            CA(0,I,J) = ( RN2*RY(0,I,J)-RN1*RY(1,I,J) )/C00
          END IF
C
          IF( NSTEP.GE.NTSVE )THEN
            SUMH(I,J) = SUMH(I,J)+E(I,J)*E(I,J)
CCC            SUMH(I,J) = SUMH(I,J)+(E(I,J)-EAVG(I,J))**2
            SUME2(I,J) = SUME2(I,J)+E(I,J)
            HRMS2(I,J) = SQRT( SUMH(I,J)/DBLE(NHRMS2) )
          END IF
C
 7026   CONTINUE
 7025 CONTINUE
C
      RETURN
      END
C
C
      SUBROUTINE SUMUVAVG( IMAX, JMAX, NUAVG, NVAVG, NUAVG2, NVAVG2,
     &     U, V, SUMU, SUMV, SUMU2, SUMV2, UAVG, VAVG,
     &     EOLD, SUMEU, SUMEV, NTSVE,
     &     NN0, CUA, RUY, RUN0, RUN1, RUN2, CVA, RVY, RVN0, RVN1, RVN2,
     &     NSTEP, LDM, LPX1, LPXJ, LXD1, LXD2, LPY1, LPYI, LYD1, LYD2 )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION U(IMAX,JMAX), V(IMAX,JMAX), EOLD(IMAX,JMAX)
      DIMENSION SUMU(IMAX,JMAX), SUMV(IMAX,JMAX)
      DIMENSION UAVG(IMAX,JMAX), VAVG(IMAX,JMAX)
      DIMENSION SUMU2(IMAX,JMAX), SUMV2(IMAX,JMAX)
      DIMENSION SUMEU(IMAX,JMAX), SUMEV(IMAX,JMAX)
      DIMENSION EUAVG2(IMAX,JMAX), EVAVG2(IMAX,JMAX)
C
      DIMENSION RUY(0:1,IMAX,JMAX), CUA(0:1,IMAX,JMAX)
      DIMENSION RVY(0:1,IMAX,JMAX), CVA(0:1,IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      INTEGER   LPX1,
     1          LPXJ(LDM),LXD1(LDM),LXD2(LDM)
      INTEGER   LPY1,
     1          LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
C
      IF( MOD(NSTEP,2).EQ.1 )THEN
C
        NUAVG=NUAVG+1
        IF( NSTEP.GE.NTSVE ) NUAVG2=NUAVG2+1
C
        IF( NUAVG.LE.NN0/2 )THEN
          RUN0 = DBLE(NUAVG)
          RUN1 = RUN1+RUN0
          RUN2 = RUN2+RUN0*RUN0
        END IF
        CU00 = RUN0*RUN2-RUN1*RUN1
C
        DO  7030  M = 1, LPX1
          J = LPXJ(M)
          IF( LXD2(M).GT.LXD1(M) )THEN
          DO  7031  I = LXD1(M)-1, LXD2(M)
C
            IF( I .EQ. I0-1 )THEN
              SUMU(I,J) = SUMU(I,J)+U(I,J)
            ELSE
              SUMU(I,J) = SUMU(I,J)+( U(I,J)+U(I+1,J) )*0.5D0
            END IF
C
            IF( NUAVG.LE.NN0/2 )THEN
              IF( I .EQ. I0-1 )THEN
                RUY(1,I,J) = RUY(1,I,J)+U(I,J)*RUN0
                RUY(0,I,J) = RUY(0,I,J)+U(I,J)
              ELSE
                RUY(1,I,J) = RUY(1,I,J)+( U(I,J)+U(I+1,J) )*0.5D0*RUN0
                RUY(0,I,J) = RUY(0,I,J)+( U(I,J)+U(I+1,J) )*0.5D0
              END IF
            ELSE
              IF( I .EQ. I0-1 )THEN
                RUY(1,I,J) = RUY(1,I,J)+U(I,J)*RUN0-RUY(0,I,J)
              ELSE
                RUY(1,I,J) = RUY(1,I,J)+( U(I,J)+U(I+1,J) )*0.5D0*RUN0
     &                      -RUY(0,I,J)
              END IF
                  UG0 = CUA(0,I,J)+CUA(1,I,J)*2.0D0
                  UG1 = CUA(0,I,J)+CUA(1,I,J)*(RUN0+1.0D0)
                RUY(0,I,J) = RUN0*0.5D0*( UG0+UG1 )
            END IF
            IF( NUAVG.LE.1 )THEN
              UAVG(I,J) = SUMU(I,J)/DBLE(NUAVG)
              CUA(1,I,J) = 0.0D0
              IF( I.EQ.I0-1 )THEN
                CUA(0,I,J) = U(I,J)
              ELSE
                CUA(0,I,J) = ( U(I,J)+U(I+1,J) )*0.5D0
              END IF
            ELSE
              UAVG(I,J) = RUY(0,I,J)/RUN0
              CUA(1,I,J) = ( RUN0*RUY(1,I,J)-RUN1*RUY(0,I,J) )/CU00
              CUA(0,I,J) = ( RUN2*RUY(0,I,J)-RUN1*RUY(1,I,J) )/CU00
            END IF
C
            IF( NSTEP.GE.NTSVE )THEN
              IF( I .EQ. I0-1 )THEN
                SUMU2(I,J) = SUMU2(I,J)+U(I,J)
                SUMEU(I,J) = SUMEU(I,J)+EOLD(I,J)*U(I,J)
              ELSE
                SUMU2(I,J) = SUMU2(I,J)+( U(I,J)+U(I+1,J) )*0.5D0
                SUMEU(I,J) = SUMEU(I,J)+EOLD(I,J)
     &                                  *( U(I,J)+U(I+1,J) )*0.5D0
              END IF
            END IF
C
 7031     CONTINUE
          END IF
 7030   CONTINUE
C
      ELSE IF( MOD(NSTEP,2).EQ.0 )THEN
C
        NVAVG=NVAVG+1
        IF( NSTEP.GE.NTSVE ) NVAVG2=NVAVG2+1
C
        IF( NVAVG.LE.NN0/2 )THEN
          RVN0 = DBLE(NVAVG)
          RVN1 = RVN1+RVN0
          RVN2 = RVN2+RVN0*RVN0
        END IF
        CV00 = RVN0*RVN2-RVN1*RVN1
C
        DO  7040  M = 1, LPY1
          I = LPYI(M)
          IF( LYD2(M).GT.LYD1(M) )THEN
          DO  7041  J = LYD1(M)-1, LYD2(M)
C
            SUMV(I,J)  = SUMV(I,J)+( V(I,J)+V(I,J+1) )*0.5D0
C
            IF( NVAVG.LE.NN0/2 )THEN
              RVY(1,I,J) = RVY(1,I,J)+( V(I,J)+V(I,J+1) )*0.5D0*RVN0
              RVY(0,I,J) = RVY(0,I,J)+( V(I,J)+V(I,J+1) )*0.5D0
            ELSE
              RVY(1,I,J) = RVY(1,I,J)+( V(I,J)+V(I,J+1) )*0.5D0*RVN0
     &                    -RVY(0,I,J)
                VG0 = CVA(0,I,J)+CVA(1,I,J)*2.0D0
                VG1 = CVA(0,I,J)+CVA(1,I,J)*(RVN0+1.0D0)
              RVY(0,I,J) = RVN0*0.5D0*( VG0+VG1 )
            END IF
            IF( NVAVG.LE.1 )THEN
              VAVG(I,J) = SUMV(I,J)/DBLE(NVAVG)
              CVA(1,I,J) = 0.0D0
              CVA(0,I,J) = ( V(I,J)+V(I,J+1) )*0.5D0
            ELSE
              VAVG(I,J) = RVY(0,I,J)/RVN0
              CVA(1,I,J) = ( RVN0*RVY(1,I,J)-RVN1*RVY(0,I,J) )/CV00
              CVA(0,I,J) = ( RVN2*RVY(0,I,J)-RVN1*RVY(1,I,J) )/CV00
            END IF
C
            IF( NSTEP.GE.NTSVE )THEN
              SUMV2(I,J) = SUMV2(I,J)+( V(I,J)+V(I,J+1) )*0.5D0
              SUMEV(I,J) = SUMEV(I,J)+EOLD(I,J)
     &                                *( V(I,J)+V(I,J+1) )*0.5D0
            END IF
C
 7041     CONTINUE
          END IF
 7040   CONTINUE
C
      END IF
C
C
      RETURN
      END
C
C     -------------  KEISU  ---------------
C
      SUBROUTINE  KEISU( DT, DX, DY )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      COMMON / BKEISU / DTR4DX, R4DX, DTR4DX2, R3DX2DT, DTR2DX2,
     1                  DR3DX2DT, RDX2, RDX2DT,
     2                  DTR4DY, R4DY, DTR4DY2, R3DY2DT, DTR2DY2,
     3                  DR3DY2DT, RDY2, RDY2DT, RDXDYDT,
     4                  RDXDY, R4DX2, R4DY2
C
      DTR4DX   = DT / 4.0D0 / DX
      R4DX     = 1.0D0 / 4.0D0 / DX
      DTR4DX2  = DT / 4.0D0 / DX / DX
      R3DX2DT  = 1.0D0 / 3.0D0 / DX / DX / DT
      DTR2DX2  = DT / 2.0D0 / DX / DX
      DR3DX2DT = 2.0D0 / 3.0D0 / DX / DX / DT
      RDX2     = 1.0D0 / DX / DX
      RDX2DT   = 1.0D0 / DX / DX / DT
C
      DTR4DY   = DT / 4.0D0 / DY
      R4DY     = 1.0D0 / 4.0D0 / DY
      DTR4DY2  = DT / 4.0D0 / DY / DY
      R3DY2DT  = 1.0D0 / 3.0D0 / DY / DY / DT
      DTR2DY2  = DT / 2.0D0 / DY / DY
      DR3DY2DT = 2.0D0 / 3.0D0 / DY / DY / DT
      RDY2     = 1.0D0 / DY / DY
      RDY2DT   = 1.0D0 / DY / DY / DT
C
      RDXDYDT  = 1.0D0 / DX  / DY / DT
C
      RDXDY    = 1.0D0 / DX / DY
      R4DX2    = 1.0D0 / DX / DX / 4.0D0
      R4DY2    = 1.0D0 / DY / DY / 4.0D0
C
!      WRITE( 6, '(8F10.4)' ) DT,DX,DY
!      WRITE( 6, '(8F10.4)' ) DTR4DX, R4DX, DTR4DX2, R3DX2DT, DTR2DX2,
!     1                       DR3DX2DT, RDX2, RDX2DT
!      WRITE( 6, '(8F10.4)' ) DTR4DY, R4DY, DTR4DY2, R3DY2DT, DTR2DY2,
!     1                       DR3DY2DT, RDY2, RDY2DT
!      WRITE( 6, '(8F10.4)' ) RDXDYDT
!      WRITE( 6, '(8F10.4)' ) RDXDY, R4DX2, R4DY2
C
      RETURN
      END
C
C     -------  INPUT DEPTH  H  ----------
C
      SUBROUTINE INPDEP( IMAX, JMAX, H, HX, HY, HP, DH,
     1  DMEAN, DMOLD, HLIMIT, HLIMIT2, HLIMIT3, FFX, FFY,
     2  FFHLM, KAISU, FXT, FYT, HLANDFIX )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HY(IMAX,JMAX),
     1            HP(IMAX,JMAX)
      DIMENSION      DMEAN(IMAX,JMAX), DMOLD(IMAX,JMAX)
      DIMENSION      DH(IMAX,JMAX)
      DIMENSION      FFX(IMAX,JMAX), FFY(IMAX,JMAX)
      DIMENSION      DHP(4)
      DIMENSION      FXT(IMAX,JMAX), FYT(IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      COMMON /FF/ FF1,FF2
C
      HSMS = 0.0D0
C
      DO  2000  J = 1, JMAX
        DO  2010  I = 1, IMAX
          DH(I,J) = 0.0D0
          IF  ( ( H(I,J) .LE. HLIMIT2 ).AND.( H(I,J) .GT. HLANDFIX ) )
     1               H(I,J) = HLIMIT2
 2010   CONTINUE
 2000 CONTINUE
C
C
      IF ( KAISU .NE. 0 ) THEN
C
      DO 119 K = 1, KAISU
C
        DO  112  J = JS+1, JE-1
          DO  113  I = IS+1, IE-1
C
           IF ( H(I,J) .GT. HSMS ) THEN
            DHSUM=0.0D0
            KBUNBO=0
            IF( H(I,J).GT.HLIMIT )THEN
              DHSUM=2.0D0*H(I,J)
              KBUNBO=2
              IF( H(I+1,J).GT.HLIMIT )THEN
                DHSUM=DHSUM+H(I+1,J)
                KBUNBO=KBUNBO+1
              END IF
              IF( H(I-1,J).GT.HLIMIT )THEN
                DHSUM=DHSUM+H(I-1,J)
                KBUNBO=KBUNBO+1
              END IF
              IF( H(I,J-1).GT.HLIMIT )THEN
                DHSUM=DHSUM+H(I,J-1)
                KBUNBO=KBUNBO+1
              END IF
              IF( H(I,J+1).GT.HLIMIT )THEN
                DHSUM=DHSUM+H(I,J+1)
                KBUNBO=KBUNBO+1
              END IF
              DH(I,J)=DHSUM/DBLE(KBUNBO)
            END IF
           ENDIF
C
  113     CONTINUE
  112   CONTINUE
C
        DO  114  J = JS, JE
          DH(IS,J) = H(IS,J)
          DH(IE,J) = H(IE,J)
  114   CONTINUE
        DO  115  I = IS, IE
          DH(I,JS) = H(I,JS)
          DH(I,JE) = H(I,JE)
  115   CONTINUE
C
        DO  116  J = JS+1, JE-1
          DO  117  I = IS+1, IE-1
C
           IF ( DH(I,J) .GT. HSMS ) THEN
            HSUM=0.0D0
            KBUNBO=0
            IF( H(I,J).GT.HLIMIT )THEN
              HSUM=2.0D0*DH(I,J)
              KBUNBO=2
              IF( H(I+1,J).GT.HLIMIT )THEN
                HSUM=HSUM+DH(I+1,J)
                KBUNBO=KBUNBO+1
              END IF
              IF( H(I-1,J).GT.HLIMIT )THEN
                HSUM=HSUM+DH(I-1,J)
                KBUNBO=KBUNBO+1
              END IF
              IF( H(I,J-1).GT.HLIMIT )THEN
                HSUM=HSUM+DH(I,J-1)
                KBUNBO=KBUNBO+1
              END IF
              IF( H(I,J+1).GT.HLIMIT )THEN
                HSUM=HSUM+DH(I,J+1)
                KBUNBO=KBUNBO+1
              END IF
              H(I,J)=HSUM/DBLE(KBUNBO)
            END IF
           ENDIF
C
  117     CONTINUE
  116   CONTINUE
C
  119 CONTINUE
C
      ENDIF
C
C
      DO  200  J = 1, JMAX
        DO  210  I = 2, IMAX
          IF ( ( H(I-1,J).GT.HLIMIT ).AND.( H(I,J).GT.HLIMIT ) ) THEN
            HX(I,J) = ( H(I-1,J) + H(I,J) ) / 2.0D0
          ELSEIF ( H(I-1,J).GT.HLIMIT ) THEN
            HX(I,J) = H(I-1,J)
          ELSEIF ( H(I,J).GT.HLIMIT ) THEN
            HX(I,J) = H(I,J)
          ENDIF
  210   CONTINUE
  200 CONTINUE
C
      DO  300  J = 2, JMAX
        DO  310  I = 1, IMAX
          IF ( ( H(I,J-1).GT.HLIMIT ).AND.( H(I,J).GT.HLIMIT ) ) THEN
            HY(I,J) = ( H(I,J-1) + H(I,J) ) / 2.0D0
          ELSEIF ( H(I,J-1).GT.HLIMIT ) THEN
            HY(I,J) = H(I,J-1)
          ELSEIF ( H(I,J).GT.HLIMIT ) THEN
            HY(I,J) = H(I,J)
          ENDIF
  310   CONTINUE
  300 CONTINUE
C
      DO  600  J = 2, JMAX
        DO  610  I = 2, IMAX
          HPSUM = 0.0D0
          KSUM = 0
          DHP(1) = H(I-1,J-1)
          DHP(2) = H(I,J-1)
          DHP(3) = H(I-1,J)
          DHP(4) = H(I,J)
          DO  620  K = 1, 4
            IF( DHP(K).GT.HLIMIT )THEN
              KSUM = KSUM+1
              HPSUM = HPSUM+DHP(K)
            END IF
  620     CONTINUE
          IF( KSUM.GT.0 )THEN
            HP(I,J) = HPSUM/DBLE(KSUM)
          END IF
  610   CONTINUE
  600 CONTINUE
C
C
      DO 400 J=1,JMAX
        DO 410 I=2,IMAX
        IF( HX(I,J).GT.HLIMIT )THEN
          IF( HX(I,J).LE.FFHLM )THEN
            FFX(I,J)=FF1
          ELSE
            FFX(I,J)=FF2
          END IF
          FXT(I,J)=FFX(I,J)
        END IF
  410   CONTINUE
  400 CONTINUE
C
      DO 420 J=2,JMAX
        DO 430 I=1,IMAX
        IF( HY(I,J).GT.HLIMIT )THEN
          IF( HY(I,J).LE.FFHLM )THEN
            FFY(I,J)=FF1
          ELSE
            FFY(I,J)=FF2
          END IF
          FYT(I,J)=FFY(I,J)
        END IF
  430   CONTINUE
  420 CONTINUE
C
C
      DO  500  J = 1, JMAX
        DO  510  I = 1, IMAX
          IF( H(I,J) .GT. HLIMIT3 ) THEN
            DMOLD(I,J) = H(I,J)
            DMEAN(I,J) = H(I,J)
          ELSE
            DMOLD(I,J) = HLIMIT3
            DMEAN(I,J) = HLIMIT3
          ENDIF
  510   CONTINUE
  500 CONTINUE
C
C
      RETURN
      END
C
C
C     ---------- CALCULATION  FD  --------------
C
C
      SUBROUTINE  CALCFD( IMAX, JMAX, H, HLIMIT,
     1     FD, FDX, FDY, FTHETA, T13, DX, DY )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION      H(IMAX,JMAX)
      DIMENSION      FD(IMAX,JMAX), FDX(IMAX,JMAX), FDY(IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      G = 9.8D0
      FDLIMIT = 3.0D0
C
C
      DO  220  J = J0, J1-1
        IF(I0-1.GT.IS) THEN
          HH = H(I0,J)
          IF( HH .GT. HLIMIT ) THEN
            FHABA = DBLE(I0-1-IS)*DX
            FMAX = FTHETA * SQRT( G / HH )
            DO  225  I = IS, I0-1
              XX = 3.0D0 * DBLE((I0-1)-I) * DX / FHABA
              IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
              FD(I,J) = 0.2137D0 * FMAX
     1              * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  225       CONTINUE
          END IF
        END IF
        IF(IE.GT.I1) THEN
          HH = H(I1,J)
          IF( HH .GT. HLIMIT ) THEN
            FHABA = DBLE(IE-I1)*DX
            FMAX = FTHETA * SQRT( G / HH )
            DO  230  I = I1, IE
              XX = 3.0D0 * DBLE(I-I1) * DX / FHABA
              IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
              FD(I,J) = 0.2137D0 * FMAX
     1              * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  230       CONTINUE
          END IF
        END IF
  220 CONTINUE
C
      DO  240  I = I0, I1-1
        IF(J0-1.GT.JS) THEN
          HH = H(I,J0)
          IF( HH .GT. HLIMIT ) THEN
            FHABA = DBLE(J0-1-JS)*DY
            FMAX = FTHETA * SQRT( G / HH )
            DO  245  J = JS, J0-1
              XX = 3.0D0 * DBLE(J0-1-J) * DX / FHABA
              IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
              FD(I,J) = 0.2137D0 * FMAX
     1              * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  245       CONTINUE
          END IF
        END IF
        IF(JE.GT.J1) THEN
          HH = H(I,J1)
          IF( HH .GT. HLIMIT ) THEN
            FHABA = DBLE(JE-J1)*DY
            FMAX = FTHETA * SQRT( G / HH )
            DO  250  J = J1, JE
              XX = 3.0D0 * DBLE(J-J1) * DX / FHABA
              IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
              FD(I,J) = 0.2137D0 * FMAX
     1              * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  250       CONTINUE
          END IF
        END IF
  240 CONTINUE
C
      IF( (I0-1.GT.IS).AND.(J0-1.GT.JS) )THEN
      HH = H(I0,J0)
      IF( HH .GT. HLIMIT ) THEN
        FHABA = DBLE(I0-1-IS)*DX
        FMAX = FTHETA * SQRT( G / HH )
        DO  260  I = IS, I0-1
          DO  265  J = JS, J0-1
            AX = DBLE(I0-1-I)*DX
            AY = DBLE(J0-1-J)*DY
            RR = SQRT( AX*AX+AY*AY )
            XX = 3.0D0 * RR / FHABA
            IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
            FD(I,J) = 0.2137D0 * FMAX
     1            * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  265     CONTINUE
  260   CONTINUE
      ENDIF
      ENDIF
C
      IF( (IE.GT.I1).AND.(J0-1.GT.JS) )THEN
      HH = H(I1,J0)
      IF( HH .GT. HLIMIT ) THEN
        FHABA = DBLE(IE-I1)*DX
        FMAX = FTHETA * SQRT( G / HH )
        DO  270  I = I1, IE
          DO  275  J = JS, J0-1
            AX = DBLE(I-I1)*DX
            AY = DBLE(J0-1-J)*DY
            RR = SQRT( AX*AX+AY*AY )
            XX = 3.0D0 * RR / FHABA
            IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
            FD(I,J) = 0.2137D0 * FMAX
     1            * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  275     CONTINUE
  270   CONTINUE
      ENDIF
      ENDIF
C
      IF( (IE.GT.I1).AND.(JE.GT.J1) )THEN
      HH = H(I1,J1)
      IF( HH .GT. HLIMIT ) THEN
        FHABA = DBLE(IE-I1)*DX
        FMAX = FTHETA * SQRT( G / HH )
        DO  280  I = I1, IE
          DO  285  J = J1, JE
            AX = DBLE(I-I1)*DX
            AY = DBLE(J-J1)*DY
            RR = SQRT( AX*AX+AY*AY )
            XX = 3.0D0 * RR / FHABA
            IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
            FD(I,J) = 0.2137D0 * FMAX
     1            * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  285     CONTINUE
  280   CONTINUE
      ENDIF
      ENDIF
C
      IF( (I0-1.GT.IS).AND.(JE.GT.J1) )THEN
      HH = H(I0,J1)
      IF( HH .GT. HLIMIT ) THEN
        FHABA = DBLE(I0-1-IS)*DX
        FMAX = FTHETA * SQRT( G / HH )
        DO  290  I = IS, I0-1
          DO  295  J = J1, JE
            AX = DBLE(I0-1-I)*DX
            AY = DBLE(J-J1)*DY
            RR = SQRT( AX*AX+AY*AY )
            XX = 3.0D0 * RR / FHABA
            IF ( XX .GT. FDLIMIT ) XX = FDLIMIT
            FD(I,J) = 0.2137D0 * FMAX
     1            * ( ( EXP(XX) + EXP(-XX) ) / 2.0D0 - 1.0D0 )
  295     CONTINUE
  290   CONTINUE
      ENDIF
      ENDIF
C
C
      DO 112 J = JS,JE
        DO 113 I = IS+1,IE
          IF ( ( H(I-1,J).GT.HLIMIT ).AND.( H(I,J).GT.HLIMIT ) ) THEN
            FDX(I,J) = (FD(I-1,J)+FD(I,J))/2.0D0
          ELSEIF ( H(I-1,J).GT.HLIMIT ) THEN
            FDX(I,J) = FD(I-1,J)
          ELSEIF ( H(I,J).GT.HLIMIT ) THEN
            FDX(I,J) = FD(I,J)
          ENDIF
  113   CONTINUE
  112 CONTINUE
C
      DO 114 I = IS,IE
        DO 115 J = JS+1,JE
          IF ( ( H(I,J-1).GT.HLIMIT ).AND.( H(I,J).GT.HLIMIT ) ) THEN
            FDY(I,J) = (FD(I,J-1)+FD(I,J))/2.0D0
          ELSEIF ( H(I,J-1).GT.HLIMIT ) THEN
            FDY(I,J) = FD(I,J-1)
          ELSEIF ( H(I,J).GT.HLIMIT ) THEN
            FDY(I,J) = FD(I,J)
          ENDIF
  115   CONTINUE
  114 CONTINUE
C
      RETURN
      END
C
C                                                                       
C     --------  INCIDENT WAVE FUNCTION  EIN  --------                   
C                                                                       
      FUNCTION GETEIN_M( I, J, I0, J0, DX, DY, TT, XDIF, YDIF, NS)
C                                                                       
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      INTEGER   I, J, I0, J0, NS                                        
C                                                                       
      include 'bsq_bsq46c8a_r1.inc'
      include 'wav_bsq46c8a_r1.inc'
C
      COMMON/ IRWAVE / AMP, AK, SITW, F, EPS                            
      DIMENSION        AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)        
C
      COMMON/ IRWAVE3 / AMP_J, AK_J, PHSJ
      DIMENSION         AMP_J(NN,JMAX), AK_J(NN,JMAX), PHSJ(NN,JMAX)
C                                                                       
      DELX = ( DBLE( I - I0 ) + XDIF ) * DX
      DELY = (                  YDIF ) * DY
cccccc      DELY = ( DBLE( J - J0 ) + YDIF ) * DY
C
      PI = 3.14159265D0
      GETEIN_M = 0.0D0
C
      DO 100  N = 1, NS
        GETEIN_M = GETEIN_M
     1           + AMP_J(N,J) * SIN( AK_J(N,J)*DELX*COS(SITW(N))
     2                              +AK_J(N,J)*DELY*SIN(SITW(N))
     2                              +PHSJ(N,J)
     3                              -2.0D0*PI*F(N)*TT + EPS(N) )
  100 CONTINUE
C
      RETURN
      END                                                               
C                                                                       
C     --------  INCIDENT WAVE FUNCTION  PIN  --------                   
C                                                                       
      FUNCTION GETPIN_M( I, J, I0, J0, DX, DY, TT, XDIF, YDIF, NS)
C                                                                       
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      INTEGER   I, J, I0, J0, NS                                        
C                                                                       
      include 'bsq_bsq46c8a_r1.inc'
      include 'wav_bsq46c8a_r1.inc'
C
      COMMON/ IRWAVE / AMP, AK, SITW, F, EPS                            
      DIMENSION        AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)        
C
      COMMON/ IRWAVE3 / AMP_J, AK_J, PHSJ
      DIMENSION         AMP_J(NN,JMAX), AK_J(NN,JMAX), PHSJ(NN,JMAX)
C                                                                       
      DELX = ( DBLE( I - I0 ) + XDIF ) * DX                             
      DELY = (                  YDIF ) * DY                             
cccccc      DELY = ( DBLE( J - J0 ) + YDIF ) * DY                             
C                                                                       
      PI = 3.14159265D0
      G  = 9.8D0
      GETPIN_M = 0.0D0
C                                                                       
      DO 100  N = 1, NS                                                 
        C = 2.0D0 * PI * F(N) / AK_J(N,J)
        GETPIN_M = GETPIN_M                                             
     1           + ( AMP_J(N,J) * SIN( AK_J(N,J)*DELX*COS(SITW(N))      
     2                                +AK_J(N,J)*DELY*SIN(SITW(N))      
     2                                +PHSJ(N,J)
     3                                -2.0D0*PI*F(N)*TT + EPS(N) ) )    
     4           * C * COS(SITW(N))                                     
  100 CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C     --------  INCIDENT WAVE FUNCTION  QIN  --------                   
C                                                                       
      FUNCTION GETQIN_M( I, J, I0, J0, DX, DY, TT, XDIF, YDIF, NS)
C                                                                       
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      INTEGER   I, J, I0, J0, NS                                        
C                                                                       
      include 'bsq_bsq46c8a_r1.inc'
      include 'wav_bsq46c8a_r1.inc'
C
      COMMON/ IRWAVE / AMP, AK, SITW, F, EPS                            
      DIMENSION        AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)        
C
      COMMON/ IRWAVE3 / AMP_J, AK_J, PHSJ
      DIMENSION         AMP_J(NN,JMAX), AK_J(NN,JMAX), PHSJ(NN,JMAX)
C                                                                       
      DELX = ( DBLE( I - I0 ) + XDIF ) * DX                             
      DELY = (                  YDIF ) * DY                             
cccccc      DELY = ( DBLE( J - J0 ) + YDIF ) * DY                             
C                                                                       
      PI = 3.14159265D0                                                 
      G  = 9.8D0
      GETQIN_M = 0.0D0                                                  
C                                                                       
      DO 100  N = 1, NS                                                 
        C = 2.0D0 * PI * F(N) / AK_J(N,J)
        GETQIN_M = GETQIN_M                                             
     1           + ( AMP_J(N,J) * SIN( AK_J(N,J)*DELX*COS(SITW(N))      
     2                                +AK_J(N,J)*DELY*SIN(SITW(N))      
     2                                +PHSJ(N,J)
     3                                -2.0D0*PI*F(N)*TT + EPS(N) ) )    
     4           * C * SIN(SITW(N))                                     
  100 CONTINUE
C
      RETURN
      END
C
C     ---------  CALCULATION INCIDENT WAVE ---------
C
      SUBROUTINE  INWAVEX_M( IMAX, JMAX, EIN, EINOLD, H, HLIMIT,    
     1                       PIN, PINOLD,                           
     2                       DX, DY, TT, TTIN, NS, DT )
C                                                                       
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   H(IMAX,JMAX)
      INTEGER   NS                                                      
C                                                                       
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE               
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE               
C
C
      ZERO = 0.0D0
      ZER5 = 0.5D0
C
      DO  100  J = JS, JE                                               
        DO  110  I = I0-2, I0+1
C                                                                       
        IF( H(I,J).GT.HLIMIT )THEN

          XDIF = ZER5
          YDIF = ZER5

          EINOLD(I,J)  = EIN(I,J)

          IF ( TT .LT. TTIN ) THEN                                      
            EIN(I,J) = GETEIN_M( I, J, I0, J0, DX, DY, TT,
     1                                 XDIF, YDIF, NS ) * TT / TTIN     
          ELSE
            EIN(I,J) = GETEIN_M( I, J, I0, J0, DX, DY, TT,
     1                                 XDIF, YDIF, NS )                 
          ENDIF

        END IF
C
  110   CONTINUE                                                        
  100 CONTINUE                                                          
C
      TTP = TT+DT/2.0D0
C                                                                       
      DO  300  J = JS, JE                                               
        DO  310  I = I0-1, I0                                           
C
        IF( (H(I,J).GT.HLIMIT).AND.(H(I-1,J).GT.HLIMIT) )THEN

          PINOLD(I,J)  = PIN(I,J)

          XDIF = ZERO
          YDIF = ZER5

          IF ( TT .LT. TTIN ) THEN                                      
            PIN(I,J) = GETPIN_M( I, J, I0, J0, DX, DY,TTP,
     1                                 XDIF, YDIF, NS ) * TTP / TTIN    
          ELSE                                                          
            PIN(I,J) = GETPIN_M( I, J, I0, J0, DX, DY,TTP,
     1                                 XDIF, YDIF, NS )                 
          ENDIF                                                         

        END IF
C                                                                       
  310   CONTINUE                                                        
  300 CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C     ---------  CALCULATION INCIDENT WAVE ---------                    
C                                                                       
      SUBROUTINE  INWAVEY_M( IMAX, JMAX, EIN, EINOLD, H, HLIMIT,    
     1                       QIN, QINOLD,                           
     2                       DX, DY, TT, TTIN, NS, DT )                 
C                                                                       
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
      DIMENSION   H(IMAX,JMAX)
      INTEGER   NS                                                      
C                                                                       
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE               
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE               
C
C
      ZERO = 0.0D0
      ZER5 = 0.5D0
C                                                                       
      DO  100  J = JS, JE                                             
        DO  110  I = I0-2, I0+1
C                                                                       
        IF( H(I,J).GT.HLIMIT )THEN

          EINOLD(I,J)  = EIN(I,J)

          XDIF = ZER5
          YDIF = ZER5

          IF ( TT .LT. TTIN ) THEN                                      
            EIN(I,J) = GETEIN_M( I, J, I0, J0, DX, DY, TT,
     1                                   XDIF, YDIF, NS ) * TT / TTIN   
          ELSE                                                          
            EIN(I,J) = GETEIN_M( I, J, I0, J0, DX, DY, TT,
     1                                   XDIF, YDIF, NS )               
          ENDIF                                                         

        END IF
C                                                                       
  110   CONTINUE                                                        
  100 CONTINUE                                                          
C
      TTQ = TT+DT/2.0D0
C                                                                       
      DO  200  J = JS+1, JE                                             
        DO  210  I = I0-1, I0                                           
C                                                                       
        IF( (H(I,J).GT.HLIMIT).AND.(H(I,J-1).GT.HLIMIT) )THEN

          QINOLD(I,J)  = QIN(I,J)

          XDIF = ZER5
          YDIF = ZERO

          IF ( TT .LT. TTIN ) THEN                                      
            QIN(I,J) = GETQIN_M( I, J, I0, J0, DX, DY,TTQ,
     1                                   XDIF, YDIF, NS ) * TTQ / TTIN  
          ELSE                                                          
            QIN(I,J) = GETQIN_M( I, J, I0, J0, DX, DY,TTQ,
     1                                   XDIF, YDIF, NS )               
          ENDIF                                                         

        END IF
C                                                                       
  210   CONTINUE                                                        
  200 CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                       
C                                                                       
C
C     -----------  CALCULATION  X - DIRECTION -------------
C
      SUBROUTINE  CALCX( IMAX, JMAX, E, EOLD,
     1                   P, POLD, Q, QOLD, PTMP,
     2                   EIN, EINOLD, 
     3                   PIN, PINOLD, QIN, QINOLD,
     4                   FDX, XNYU, HLIMIT,
     5                   H, HX, HP, DX, DY, DT,
     6                   DQDY, FFX, FXT,
     9                   LDM, LPX1, LPXJ, LXD1, LXD2,
     3                   LABEL )
C
c
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   E(IMAX,JMAX),   EOLD(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX),   POLD(IMAX,JMAX), PTMP(IMAX,JMAX)
      DIMENSION   Q(IMAX,JMAX),   QOLD(IMAX,JMAX)
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
C
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HY(IMAX,JMAX)
      DIMENSION   HP(IMAX,JMAX)
      DIMENSION   FDX(IMAX,JMAX)
      DIMENSION   XNYU(IMAX,JMAX)
      DIMENSION   FFX(IMAX,JMAX)
      DIMENSION   FXT(IMAX,JMAX)
C
      DIMENSION   DQDY(IMAX,JMAX)
C
      INTEGER   LPX1,
     1          LPXJ(LDM),LXD1(LDM),LXD2(LDM)
C
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
C
C
      COMMON / BKEISU / DTR4DX, R4DX, DTR4DX2, R3DX2DT, DTR2DX2,
     1                  DR3DX2DT, RDX2, RDX2DT,
     2                  DTR4DY, R4DY, DTR4DY2, R3DY2DT, DTR2DY2,
     3                  DR3DY2DT, RDY2, RDY2DT, RDXDYDT,
     4                  RDXDY, R4DX2, R4DY2
C
C
      DO  220  M = 1, LPX1
        J = LPXJ(M)
        DO  230  I = LXD1(M)-1, LXD2(M)
          EOLD(I,J) = E(I,J)
  230   CONTINUE
  220 CONTINUE
C
      DO  10  M = 1, LPX1
        J = LPXJ(M)
        IF( LXD1(M).GT.IS+1 )THEN
          P(LXD1(M)-1,J)    = 0.0D0
          POLD(LXD1(M)-1,J) = 0.0D0
        ELSE IF( LXD2(M).LT.IE )THEN
          P(LXD2(M)+1,J)    = 0.0D0
          POLD(LXD2(M)+1,J) = 0.0D0
        END IF

   10 CONTINUE
C
C
      DO  60  M = 1, LPX1
        J = LPXJ(M)
        DO  70  I = LXD1(M)-1, LXD2(M)
C
        IF( (J.GT.JS).AND.(J.LT.JE) )THEN
          DIJP1    = H(I,J+1)   + E(I,J+1)
          DIJM1    = H(I,J-1)   + E(I,J-1)
          IF ( DIJP1.LE. HLIMIT ) THEN
            Q(I,J+1)    = 0.0D0
            QOLD(I,J+1) = 0.0D0
          ENDIF
          IF ( DIJM1.LE. HLIMIT ) THEN
            Q(I,J)    = 0.0D0
            QOLD(I,J) = 0.0D0
          ENDIF
        END IF
C
          EIP1JO2 = EOLD(I+1,J)
          EIM1JO2 = EOLD(I-1,J)
          EIJP1O2 = EOLD(I,J+1)
          EIJM1O2 = EOLD(I,J-1)
          IF( H(I+1,J).LE. HLIMIT ) EIP1JO2 = EOLD(I,J)
          IF( H(I-1,J).LE. HLIMIT ) EIM1JO2 = EOLD(I,J)
          IF( H(I,J+1).LE. HLIMIT ) EIJP1O2 = EOLD(I,J)
          IF( H(I,J-1).LE. HLIMIT ) EIJM1O2 = EOLD(I,J)
C
          IF ( I .EQ. I0-1 ) THEN
            PIP1J = P(I+1,J) - PINOLD(I0,J)
            DPDX = DT/DX/2.0D0 * ( PIP1J - P(I,J) )
            DQDY(I,J) = DTR4DY * ( Q(I,J+1) - Q(I,J)
     1                           + QOLD(I,J+1) - QOLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              IF( H(I+1,J).GT.HLIMIT )THEN
                EIP1JO = EIP1JO2 - EINOLD(I0,J)
              ELSE
                EIP1JO = EIP1JO2
              END IF
              EIJOLD = 0.5D0*( EOLD(I,J)
     1                      +0.25D0*(EIP1JO+EIM1JO2+EIJP1O2+EIJM1O2) )
              E(I,J) = EIJOLD - ( DPDX + DQDY(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DPDX + DQDY(I,J) )
            END IF
          ELSE IF ( I .EQ. I0 ) THEN
            DPDX = DT/DX/2.0D0 * ( P(I+1,J) - P(I,J) )
            DQDY(I,J) = DTR4DY * ( Q(I,J+1) - Q(I,J)
     1                           + QOLD(I,J+1) - QOLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              IF( H(I-1,J).GT.HLIMIT )THEN
                EIM1JO = EIM1JO2 + EINOLD(I0-1,J)
              ELSE
                EIM1JO = EIM1JO2
              END IF
              EIJOLD = 0.5D0*( EOLD(I,J)
     1                      +0.25D0*(EIP1JO2+EIM1JO+EIJP1O2+EIJM1O2) )
              E(I,J) = EIJOLD - ( DPDX + DQDY(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DPDX + DQDY(I,J) )
            END IF
          ELSE
            DPDX = DT/DX/2.0D0 * ( P(I+1,J) - P(I,J) )
            DQDY(I,J) = DTR4DY * ( Q(I,J+1) - Q(I,J)
     1                           + QOLD(I,J+1) - QOLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              EIJOLD = 0.5D0*(EOLD(I,J)
     1                        +0.25D0*(EIP1JO2+EIM1JO2+EIJP1O2+EIJM1O2))
              E(I,J) = EIJOLD - ( DPDX + DQDY(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DPDX + DQDY(I,J) )
            END IF
          ENDIF
C
   70   CONTINUE
   60 CONTINUE
C
C
      DO  100  M = 1, LPX1
        J = LPXJ(M)
C C        IF ( LXD1(M) .NE. LXD2(M) )THEN
        CALL  CALCP( IMAX, JMAX, J, LXD1(M), LXD2(M), E, EOLD,
     2                   P, POLD, Q, QOLD,
     3                   EIN, EINOLD, PIN, PINOLD, QIN, QINOLD,
     4                   FDX, XNYU, HLIMIT,
     5                   H, HX, HP, DX, DY, DT,
     6                   DQDY, FFX )
C C        END IF
  100 CONTINUE
C
        DO  120  M = 1, LPX1
          J = LPXJ(M)
          DO  130  I = LXD1(M), LXD2(M)
            ABC = POLD(I,J)
            POLD(I,J) = P(I,J)
            P(I,J) = ABC
  130     CONTINUE
  120   CONTINUE
C
      IF( (LABEL.EQ.1).OR.(LABEL.EQ.3) )
     &  CALL  AFLVCSX( IMAX, JMAX, P, PIN, PTMP, HX, HLIMIT,
     &                 LDM, LPX1, LPXJ, LXD1, LXD2 )
C
C
C             CALCULATION E
C
      DO  200  M = 1, LPX1
        J = LPXJ(M)
        DO  210  I = LXD1(M)-1, LXD2(M)
C
          IF ( I .EQ. I0-1 ) THEN
            PIP1J = P(I+1,J) - PIN(I0,J)
            PIP1JO = POLD(I+1,J) - PINOLD(I0,J)
            DPDX = DTR4DX*( PIP1J - P(I,J) + PIP1JO - POLD(I,J))
            E(I,J) = EOLD(I,J) - ( DPDX + DQDY(I,J) )
          ELSE
            DPDX = DTR4DX*( P(I+1,J) - P(I,J) + POLD(I+1,J)-POLD(I,J))
            E(I,J) = EOLD(I,J) - ( DPDX + DQDY(I,J) )
          ENDIF
C
  210   CONTINUE
  200 CONTINUE
C
      RETURN
      END
C
C     -----------  CALCULATION  Y - DIRECTION -------------
C
      SUBROUTINE  CALCY( IMAX, JMAX, E, EOLD,
     1                   P, POLD, Q, QOLD, QTMP,
     2                   EIN, EINOLD, 
     3                   PIN, PINOLD, QIN, QINOLD,
     4                   FDY, YNYU, HLIMIT,
     5                   H, HY, HP, DX, DY, DT,
     6                   DPDX, FFY, FYT,
     9                   LDM, LPY1, LPYI, LYD1, LYD2,
     3                   LABEL )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   E(IMAX,JMAX),   EOLD(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX),   POLD(IMAX,JMAX)
      DIMENSION   Q(IMAX,JMAX),   QOLD(IMAX,JMAX), QTMP(IMAX,JMAX)
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
C
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HY(IMAX,JMAX)
      DIMENSION   HP(IMAX,JMAX)
      DIMENSION   FDY(IMAX,JMAX)
      DIMENSION   YNYU(IMAX,JMAX)
      DIMENSION   FFY(IMAX,JMAX)
      DIMENSION   FYT(IMAX,JMAX)
C
      DIMENSION   DPDX(IMAX,JMAX)
C
C
      INTEGER   LPY1,
     1          LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      COMMON / BKEISU / DTR4DX, R4DX, DTR4DX2, R3DX2DT, DTR2DX2,
     1                  DR3DX2DT, RDX2, RDX2DT,
     2                  DTR4DY, R4DY, DTR4DY2, R3DY2DT, DTR2DY2,
     3                  DR3DY2DT, RDY2, RDY2DT, RDXDYDT,
     4                  RDXDY, R4DX2, R4DY2
C
C
      DO  220  M = 1, LPY1
        I = LPYI(M)
        DO  230  J = LYD1(M)-1, LYD2(M)
          EOLD(I,J) = E(I,J)
  230   CONTINUE
  220 CONTINUE
C
      DO  10  M = 1, LPY1
        I = LPYI(M)
        IF( LYD1(M).GT.JS+1 )THEN
          Q(I,LYD1(M)-1)    = 0.0D0
          QOLD(I,LYD1(M)-1) = 0.0D0
        ELSE IF( LYD2(M).LT.JE )THEN
          Q(I,LYD2(M)+1)    = 0.0D0
          QOLD(I,LYD2(M)+1) = 0.0D0
        END IF
   10 CONTINUE
C
C
      DO  60  M = 1, LPY1
        I = LPYI(M)
C
        IF ( ( I .EQ. IS ).OR.( I .EQ. IE ) ) THEN
          DO  70  J = LYD1(M)-1, LYD2(M)
            EIP1JO2 = EOLD(I+1,J)
            EIM1JO2 = EOLD(I-1,J)
            EIJP1O2 = EOLD(I,J+1)
            EIJM1O2 = EOLD(I,J-1)
            IF( H(I+1,J).LE. HLIMIT ) EIP1JO2 = EOLD(I,J)
            IF( H(I-1,J).LE. HLIMIT ) EIM1JO2 = EOLD(I,J)
            IF( H(I,J+1).LE. HLIMIT ) EIJP1O2 = EOLD(I,J)
            IF( H(I,J-1).LE. HLIMIT ) EIJM1O2 = EOLD(I,J)
            DQDY = DT/DY/2.0 * ( Q(I,J+1) - Q(I,J) )
            DPDX(I,J) = DTR4DX * ( P(I+1,J) - P(I,J)
     1                           + POLD(I+1,J) - POLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              EIJOLD = 0.5D0*(EOLD(I,J)
     1                        +0.25D0*(EIP1JO2+EIM1JO2+EIJP1O2+EIJM1O2))
              E(I,J) = EIJOLD - ( DQDY + DPDX(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DQDY + DPDX(I,J) )
            END IF
   70     CONTINUE
C
        ELSEIF ( I .EQ. I0-1 ) THEN
          DO  71  J = LYD1(M)-1, LYD2(M)
            EIP1JO2 = EOLD(I+1,J)
            EIM1JO2 = EOLD(I-1,J)
            EIJP1O2 = EOLD(I,J+1)
            EIJM1O2 = EOLD(I,J-1)
            IF( H(I+1,J).LE. HLIMIT ) EIP1JO2 = EOLD(I,J)
            IF( H(I-1,J).LE. HLIMIT ) EIM1JO2 = EOLD(I,J)
            IF( H(I,J+1).LE. HLIMIT ) EIJP1O2 = EOLD(I,J)
            IF( H(I,J-1).LE. HLIMIT ) EIJM1O2 = EOLD(I,J)
            DIP1J    = H(I+1,J)   + E(I+1,J)
            DIM1J    = H(I-1,J)   + E(I-1,J)
            IF ( DIP1J. LE. HLIMIT ) THEN
              P(I+1,J)    = 0.0D0
              POLD(I+1,J) = 0.0D0
            ENDIF
            IF ( DIM1J. LE. HLIMIT ) THEN
              P(I,J)    = 0.0D0
              POLD(I,J) = 0.0D0
            ENDIF
            PIP1J = P(I+1,J) - PIN(I0,J)
            PIP1JO = POLD(I+1,J) - PINOLD(I0,J)
            DQDY = DT/DY/2.0D0 * ( Q(I,J+1) - Q(I,J) )
            DPDX(I,J) = DTR4DX * ( PIP1J - P(I,J)
     1                           + PIP1JO - POLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              IF( H(I+1,J).GT.HLIMIT )THEN
                EIP1JO = EIP1JO2 - EINOLD(I0,J)
              ELSE
                EIP1JO = EIP1JO2
              END IF
              EIJOLD = 0.5D0*( EOLD(I,J)
     1                      +0.25D0*(EIP1JO+EIM1JO2+EIJP1O2+EIJM1O2) )
              E(I,J) = EIJOLD - ( DQDY + DPDX(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DQDY + DPDX(I,J) )
            END IF
   71     CONTINUE
C
        ELSEIF ( I .EQ. I0 ) THEN
          DO  73  J = LYD1(M)-1, LYD2(M)
            EIP1JO2 = EOLD(I+1,J)
            EIM1JO2 = EOLD(I-1,J)
            EIJP1O2 = EOLD(I,J+1)
            EIJM1O2 = EOLD(I,J-1)
            IF( H(I+1,J).LE. HLIMIT ) EIP1JO2 = EOLD(I,J)
            IF( H(I-1,J).LE. HLIMIT ) EIM1JO2 = EOLD(I,J)
            IF( H(I,J+1).LE. HLIMIT ) EIJP1O2 = EOLD(I,J)
            IF( H(I,J-1).LE. HLIMIT ) EIJM1O2 = EOLD(I,J)
            DIP1J    = H(I+1,J)   + E(I+1,J)
            DIM1J    = H(I-1,J)   + E(I-1,J)
            IF ( DIP1J. LE. HLIMIT ) THEN
              P(I+1,J)    = 0.0D0
              POLD(I+1,J) = 0.0D0
            ENDIF
            IF ( DIM1J. LE. HLIMIT ) THEN
              P(I,J)    = 0.0D0
              POLD(I,J) = 0.0D0
            ENDIF
            DQDY = DT/DY/2.0D0 * ( Q(I,J+1) - Q(I,J) )
            DPDX(I,J) = DTR4DX * ( P(I+1,J) - P(I,J)
     1                           + POLD(I+1,J) - POLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              IF( H(I-1,J).GT.HLIMIT )THEN
                EIM1JO = EIM1JO2 + EINOLD(I0-1,J)
              ELSE
                EIM1JO = EIM1JO2
              END IF
              EIJOLD = 0.5D0*( EOLD(I,J)
     1                      +0.25D0*(EIP1JO2+EIM1JO+EIJP1O2+EIJM1O2) )
              E(I,J) = EIJOLD - ( DQDY + DPDX(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DQDY + DPDX(I,J) )
            END IF
   73     CONTINUE
C
        ELSE
          DO  72  J = LYD1(M)-1, LYD2(M)
            EIP1JO2 = EOLD(I+1,J)
            EIM1JO2 = EOLD(I-1,J)
            EIJP1O2 = EOLD(I,J+1)
            EIJM1O2 = EOLD(I,J-1)
            IF( H(I+1,J).LE. HLIMIT ) EIP1JO2 = EOLD(I,J)
            IF( H(I-1,J).LE. HLIMIT ) EIM1JO2 = EOLD(I,J)
            IF( H(I,J+1).LE. HLIMIT ) EIJP1O2 = EOLD(I,J)
            IF( H(I,J-1).LE. HLIMIT ) EIJM1O2 = EOLD(I,J)
            DIP1J    = H(I+1,J)   + E(I+1,J)
            DIM1J    = H(I-1,J)   + E(I-1,J)
            IF ( DIP1J. LE. HLIMIT ) THEN
              P(I+1,J)    = 0.0D0
              POLD(I+1,J) = 0.0D0
            ENDIF
            IF ( DIM1J. LE. HLIMIT ) THEN
              P(I,J)    = 0.0D0
              POLD(I,J) = 0.0D0
            ENDIF
            DQDY = DT/DY/2.0D0 * ( Q(I,J+1) - Q(I,J) )
            DPDX(I,J) = DTR4DX * ( P(I+1,J) - P(I,J)
     1                           + POLD(I+1,J) - POLD(I,J) )
            IF( (LABEL.EQ.2).OR.(LABEL.EQ.3) )THEN
              EIJOLD = 0.5D0*(EOLD(I,J)
     1                        +0.25D0*(EIP1JO2+EIM1JO2+EIJP1O2+EIJM1O2))
              E(I,J) = EIJOLD - ( DQDY + DPDX(I,J) )  ! for STABILITY
            ELSE
              E(I,J) = EOLD(I,J) - ( DQDY + DPDX(I,J) )
            END IF
   72     CONTINUE
C
        ENDIF
C
   60 CONTINUE
C
C
      DO  100  M = 1, LPY1
        I = LPYI(M)
C C        IF ( LYD1(M) .NE. LYD2(M) )THEN
        CALL  CALCQ( IMAX, JMAX, I, LYD1(M), LYD2(M), E, EOLD,
     2                   P, POLD, Q, QOLD,
     3                   EIN, EINOLD, PIN, PINOLD, QIN, QINOLD,
     4                   FDY, YNYU, HLIMIT,
     5                   H, HY, HP, DX, DY, DT,
     6                   DPDX, FFY )
C C        END IF
  100 CONTINUE
C
        DO  120  M = 1, LPY1
          I = LPYI(M)
          DO  130  J = LYD1(M), LYD2(M)
            ABC = QOLD(I,J)
            QOLD(I,J) = Q(I,J)
            Q(I,J) = ABC
  130     CONTINUE
  120   CONTINUE
C
      IF( (LABEL.EQ.1).OR.(LABEL.EQ.3) )
     &  CALL  AFLVCSY( IMAX, JMAX, Q, QIN, QTMP, HY, HLIMIT,
     &                 LDM, LPY1, LPYI, LYD1, LYD2 )
C
C
C             CALCULATION E
C
      DO  200  M = 1, LPY1
        I = LPYI(M)
        DO  210  J = LYD1(M)-1, LYD2(M)
          DQDY =DTR4DY*( Q(I,J+1) - Q(I,J) + QOLD(I,J+1) - QOLD(I,J) )
          E(I,J) = EOLD(I,J) - ( DQDY + DPDX(I,J) )
  210   CONTINUE
  200 CONTINUE
C
      RETURN
      END
C
C     -----------  CALCULATION  P -------------
C
      SUBROUTINE  CALCP( IMAX, JMAX, J, IIS, IIE, E, EOLD,
     1                   P, POLD, Q, QOLD,
     2                   EIN, EINOLD, PIN, PINOLD, QIN, QINOLD,
     3                   FDX, XNYU, HLIMIT,
     4                   H, HX, HP, DX, DY, DT,
     5                   DQDY, FFX )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      include 'rgn_bsq46c8a_r1.inc'
C
      DIMENSION   RMATRIX(LDM,4), RX(LDM)
C
      DIMENSION   E(IMAX,JMAX),   EOLD(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX),   POLD(IMAX,JMAX)
      DIMENSION   Q(IMAX,JMAX),   QOLD(IMAX,JMAX)
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
C
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HP(IMAX,JMAX)
      DIMENSION   FDX(IMAX,JMAX)
      DIMENSION   XNYU(IMAX,JMAX)
      DIMENSION   FFX(IMAX,JMAX)
C
      DIMENSION   DQDY(IMAX,JMAX)
C
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
C
      COMMON / BKEISU / DTR4DX, R4DX, DTR4DX2, R3DX2DT, DTR2DX2,
     1                  DR3DX2DT, RDX2, RDX2DT,
     2                  DTR4DY, R4DY, DTR4DY2, R3DY2DT, DTR2DY2,
     3                  DR3DY2DT, RDY2, RDY2DT, RDXDYDT,
     4                  RDXDY, R4DX2, R4DY2
C
      G = 9.8D0
C
C
C             CALCULATION P
C
C
       BB = 1.0D0/15.0D0
C
C
       DO  110  I = IIS, IIE
C
         PIJP12  = P(I,J+1)
         PIJM12  = P(I,J-1)
C
         EIJP12 = E(I,J+1)
         EIJM12 = E(I,J-1)
         EIM1JP12 = E(I-1,J+1)
         EIM1JM12 = E(I-1,J-1)
         EINIM1JP12 = EIN(I-1,J+1)
         EINIM1JM12 = EIN(I-1,J-1)
C
         EIM2J2 = E(I-2,J)
         EIP1J2 = E(I+1,J)
         EINIM2J2 = EIN(I-2,J)
         EINIP1J2 = EIN(I+1,J)
C
         IF ( (H(I-1,J+1).LE. HLIMIT ).AND.( H(I,J+1).LE. HLIMIT ) )
     1                                     PIJP12  = P(I,J)
         IF ( (H(I-1,J-1).LE. HLIMIT ).AND.( H(I,J-1).LE. HLIMIT ) )
     1                                     PIJM12  = P(I,J)
C
         IF ( H(I,J+1).LE. HLIMIT ) EIJP12 = E(I,J)
         IF ( H(I,J-1).LE. HLIMIT ) EIJM12 = E(I,J)
         IF ( H(I-1,J+1).LE. HLIMIT ) THEN
           EIM1JP12 = E(I-1,J)
           EINIM1JP12 = EIN(I-1,J)
         END IF
         IF ( H(I-1,J-1).LE. HLIMIT ) THEN
           EIM1JM12 = E(I-1,J)
           EINIM1JM12 = EIN(I-1,J)
         END IF
C
         IF ( H(I-2,J).LE. HLIMIT ) THEN
           EIM2J2 = E(I-1,J)
           EINIM2J2 = EIN(I-1,J)
         END IF
         IF ( H(I+1,J).LE. HLIMIT ) THEN
           EIP1J2 = E(I,J)
           EINIP1J2 = EIN(I,J)
         END IF
C
        IF ( I .EQ. I0-1 ) THEN
          PIP1J = P(I+1,J) - PINOLD(I0,J)
          IF( H(I+1,J).GT.HLIMIT )THEN
            EIP1J = EIP1J2 - EINIP1J2
          ELSE
            EIP1J = EIP1J2
          END IF
          DC2 = HX(I,J) + ( E(I,J) + E(I-1,J) ) / 2.0D0
          DR2 = H(I,J) + E(I,J)
          DL2 = H(I-1,J) + E(I-1,J)
          DU2 = HP(I,J+1)
     1       + ( E(I,J) + E(I-1,J) + EIJP12 + EIM1JP12 ) / 4.0D0
          DD2 = HP(I,J)
     1       + ( E(I,J) + E(I-1,J) + EIJM12 + EIM1JM12 ) / 4.0D0
          QAVG = ( Q(I-1,J)+Q(I,J)+Q(I-1,J+1)+Q(I,J+1) )
     1           / 4.0D0
C
          QU = ( Q(I,J+1)+Q(I-1,J+1) ) / 2.0D0
          QD = ( Q(I,J)+Q(I-1,J) ) / 2.0D0
          QR = ( Q(I,J)+Q(I,J+1) ) / 2.0D0
          QL = ( Q(I-1,J)+Q(I-1,J+1) ) / 2.0D0
          QUOLD = ( QOLD(I,J+1)+QOLD(I-1,J+1) ) / 2.0D0
          QDOLD = ( QOLD(I,J)+QOLD(I-1,J) ) / 2.0D0
          QROLD = ( QOLD(I,J)+QOLD(I,J+1) ) / 2.0D0
          QLOLD = ( QOLD(I-1,J)+QOLD(I-1,J+1) ) / 2.0D0
          EE = ( EIP1J+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+E(I-1,J) ) / 2.0D0
          EW = ( E(I-1,J)+EIM2J2 ) / 2.0D0
          EN = ( EIJP12+EIM1JP12 ) / 2.0D0
          ES = ( EIJM12+EIM1JM12 ) / 2.0D0
          ENE = ( EIJP12+E(I,J) ) / 2.0D0
          ENW = ( EIM1JP12+E(I-1,J) ) / 2.0D0
          ESE = ( E(I,J)+EIJM12 ) / 2.0D0
          ESW = ( E(I-1,J)+EIM1JM12 ) / 2.0D0
C
          BUN = ( 1.0/3.0+BB ) * HX(I,J)*HX(I,J) *( 
     1          - RDX2DT*( PIP1J-2.0D0*P(I,J)+P(I-1,J) )
     2          + RDXDYDT*( ( Q(I,J+1)-Q(I-1,J+1)
     3                                   -Q(I,J)+Q(I-1,J) )
     4                     -( QOLD(I,J+1)-QOLD(I-1,J+1)
     5                                 -QOLD(I,J)+QOLD(I-1,J) ) ) )
          BUN2 = BB*G*HX(I,J)*HX(I,J)*HX(I,J) *( 
     1       1.0D0/DX/DX/DX*( EIP1J-3.0D0*E(I,J)+3.0D0*E(I-1,J)-EIM2J2 )
     2     + 1.0D0/DX/DY/DY*( ( EIJP12-2.0D0*E(I,J)+EIJM12 )
     3                       -( EIM1JP12-2.0D0*E(I-1,J)+EIM1JM12 ) ) )
          BUN3 = BB*G*HX(I,J)*HX(I,J)*( 
     1         ( H(I,J)-H(I-1,J) )/DX * ( 
     2                     2.0D0*( EE-2.0D0*EC+EW )/DX/DX
     3                       + ( EN-2.0D0*EC+ES )/DY/DY )
     4       + ( HP(I,J+1)-HP(I,J) )/DY * 
     5             ( ENE-ENW-ESE+ESW )/DX/DY )
          SATSU = FFX(I,J) * SQRT(P(I,J)*P(I,J)+QAVG*QAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = XNYU(I,J) * RDX2 / 2.0D0
C
          RMATRIX(I,1) = -R4DX*( P(I,J)+P(I-1,J) )/DL2 - DTR4DX2*G*DC2
     1                   - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J)*HX(I,J)
     2                   - SAIHA
     3                   + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,2) = 1.0/DT
     1       + R4DX * ( (P(I,J)+PIP1J)/DR2 - (P(I,J)+P(I-1,J))/DL2 )
     2    + R4DY * ( (Q(I-1,J+1)+Q(I,J+1))/DU2 - (Q(I-1,J)+Q(I,J))/DD2)
     3                 + DTR2DX2*G*DC2
     4           + ( 2.0D0/3.0D0+2.0D0*BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     4                 + FDX(I,J)/2.0D0 + SATSU + SAIHA*2.0D0
          RMATRIX(I,3) = R4DX*( P(I,J)+PIP1J )/DR2 - DTR4DX2*G*DC2
     1                 - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     2                   - SAIHA
     3                   - HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,4) = 1.0/DT*P(I,J)
     1                 - R4DY * ( PIJP12*(Q(I-1,J+1)+Q(I,J+1))/DU2
     2                          - PIJM12*(Q(I-1,J)+Q(I,J))/DD2 )
     3    - G/DX*DC2*( EOLD(I,J) - EOLD(I-1,J)
     4               - DTR4DX*( PIP1J - 2.0D0*P(I,J) + P(I-1,J) )
     5               - ( DQDY(I,J) - DQDY(I-1,J) ) )
     6    + BUN + BUN2 + BUN3 - FDX(I,J)*P(I,J)/2.0D0 - SATSU*P(I,J)
     7    + SAIHA*( PIP1J-2.0D0*P(I,J)+P(I-1,J) )
     8    + XNYU(I,J)*RDY2*( PIJP12-2.0D0*P(I,J)+PIJM12 )
     9    + RMATRIX(I,3) * PIN(I0,J)
     1    + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX * (
     2     - ( PIP1J-P(I-1,J) )/DX/6.0D0
     3     + ( QU-QD-QUOLD+QDOLD )/DY/6.0D0 )
     1    + HX(I,J)*( HP(I,J+1)-HP(I,J) )/DT/DY * (
     2     + ( QR-QL-QROLD+QLOLD )/DX/6.0D0 )
C
         ELSEIF ( I .EQ. I0 ) THEN
          QIM1J = Q(I-1,J) + QIN(I0-1,J)
          QIM1JO = QOLD(I-1,J) + QINOLD(I0-1,J)
          QIM1JP1 = Q(I-1,J+1) + QIN(I0-1,J+1)
          QIM1JP1O = QOLD(I-1,J+1) + QINOLD(I0-1,J+1)
          PIM1J = P(I-1,J) + PINOLD(I0-1,J)
          EIM1J = E(I-1,J) + EIN(I0-1,J)
          EIM1JM1 = EIM1JM12 + EINIM1JM12
          EIM1JP1 = EIM1JP12 + EINIM1JP12
          EIM2J = EIM2J2 + EINIM2J2
          EIM1JO = EOLD(I-1,J) + EINOLD(I0-1,J)
          DC2 = HX(I,J) + ( E(I,J) + EIM1J ) / 2.0D0
          DR2 = H(I,J) + E(I,J)
          DL2 = H(I-1,J) + EIM1J
          DU2 = HP(I,J+1)
     1       + ( E(I,J) + EIM1J + EIJP12 + EIM1JP1 ) / 4.0D0
          DD2 = HP(I,J)
     1       + ( E(I,J) + EIM1J + EIJM12 + EIM1JM1 ) / 4.0D0
          QAVG = ( QIM1J+Q(I,J)+QIM1JP1+Q(I,J+1) )
     1           / 4.0D0
C
          QU = ( Q(I,J+1)+QIM1JP1 ) / 2.0D0
          QD = ( Q(I,J)+QIM1J ) / 2.0D0
          QR = ( Q(I,J)+Q(I,J+1) ) / 2.0D0
          QL = ( QIM1J+QIM1JP1 ) / 2.0D0
          QUOLD = ( QOLD(I,J+1)+QIM1JP1O ) / 2.0D0
          QDOLD = ( QOLD(I,J)+QIM1JO ) / 2.0D0
          QROLD = ( QOLD(I,J)+QOLD(I,J+1) ) / 2.0D0
          QLOLD = ( QIM1JO+QIM1JP1O ) / 2.0D0
          EE = ( EIP1J2+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+EIM1J ) / 2.0D0
          EW = ( EIM1J+EIM2J ) / 2.0D0
          EN = ( EIJP12+EIM1JP1 ) / 2.0D0
          ES = ( EIJM12+EIM1JM1 ) / 2.0D0
          ENE = ( EIJP12+E(I,J) ) / 2.0D0
          ENW = ( EIM1JP1+EIM1J ) / 2.0D0
          ESE = ( E(I,J)+EIJM12 ) / 2.0D0
          ESW = ( EIM1J+EIM1JM1 ) / 2.0D0
C
          BUN = ( 1.0D0/3.0D0+BB ) * HX(I,J)*HX(I,J) *( 
     1          - RDX2DT*( P(I+1,J)-2.0D0*P(I,J)+PIM1J )
     2          + RDXDYDT*( ( Q(I,J+1)-QIM1JP1
     3                                   -Q(I,J)+QIM1J )
     4                     -( QOLD(I,J+1)-QIM1JP1O
     5                                 -QOLD(I,J)+QIM1JO ) ) )
          BUN2 = BB*G*HX(I,J)*HX(I,J)*HX(I,J) *( 
     1         1.0D0/DX/DX/DX*( EIP1J2-3.0D0*E(I,J)+3.0D0*EIM1J-EIM2J )
     2       + 1.0D0/DX/DY/DY*( ( EIJP12-2.0D0*E(I,J)+EIJM12 )
     3                       -( EIM1JP1-2.0D0*EIM1J+EIM1JM1 ) ) )
          BUN3 = BB*G*HX(I,J)*HX(I,J)*( 
     1         ( H(I,J)-H(I-1,J) )/DX * ( 
     2                     2.0D0*( EW-2.0D0*EC+EE )/DX/DX
     3                       + ( EN-2.0D0*EC+ES )/DY/DY )
     4       + ( HP(I,J+1)-HP(I,J) )/DY * 
     5             ( ENE-ENW-ESE+ESW )/DX/DY )
          SATSU = FFX(I,J) * SQRT(P(I,J)*P(I,J)+QAVG*QAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = XNYU(I,J) * RDX2 / 2.0D0
C
          RMATRIX(I,1) = -R4DX*( P(I,J)+PIM1J )/DL2 - DTR4DX2*G*DC2
     1                   - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J)*HX(I,J)
     2                   - SAIHA
     3                   + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,2) = 1.0D0/DT
     1       + R4DX * ( (P(I,J)+P(I+1,J))/DR2 - (P(I,J)+PIM1J)/DL2 )
     2    + R4DY * ( (QIM1JP1+Q(I,J+1))/DU2 - (QIM1J+Q(I,J))/DD2)
     3                 + DTR2DX2*G*DC2
     4           + ( 2.0D0/3.0D0+2.0D0*BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     4                 + FDX(I,J)/2.0D0 + SATSU + SAIHA*2.0D0
          RMATRIX(I,3) = R4DX*( P(I,J)+P(I+1,J) )/DR2 - DTR4DX2*G*DC2
     1                - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     2                   - SAIHA
     3                   - HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,4) = 1.0D0/DT*P(I,J)
     1                 - R4DY * ( PIJP12*(QIM1JP1+Q(I,J+1))/DU2
     2                          - PIJM12*(QIM1J+Q(I,J))/DD2 )
     3    - G/DX*DC2*( EOLD(I,J) - EIM1JO
     4               - DTR4DX*( P(I+1,J) - 2.0D0*P(I,J) + PIM1J )
C C     5               - ( DQDY(I,J) - DQDY(I-1,J) ) )  ! DQDY(I-1,J) is out of region
     5              - DTR4DY*( ( Q(I,J+1)-Q(I,J)+QOLD(I,J+1)-QOLD(I,J) )
     6                        -( QIM1JP1-QIM1J
     7                                  +QIM1JP1O-QIM1JO ) ) )
     6    + BUN + BUN2 + BUN3 - FDX(I,J)*P(I,J)/2.0D0 - SATSU*P(I,J)
     7    + SAIHA*( P(I+1,J)-2.0D0*P(I,J)+PIM1J )
     8    + XNYU(I,J)*RDY2*( PIJP12-2.0D0*P(I,J)+PIJM12 )
     9    - RMATRIX(I,1) * PIN(I0-1,J)
     1    + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX * (
     2     - ( P(I+1,J)-PIM1J )/DX/6.0D0
     3     + ( QU-QD-QUOLD+QDOLD )/DY/6.0D0 )
     1    + HX(I,J)*( HP(I,J+1)-HP(I,J) )/DT/DY * (
     2     + ( QR-QL-QROLD+QLOLD )/DX/6.0D0 )
C
         ELSE IF( I.EQ.I0+1 )THEN
          IF( H(I-2,J).GT.HLIMIT )THEN
            EIM2J = EIM2J2 + EINIM2J2
          ELSE
            EIM2J = EIM2J2
          END IF
          DC2 = HX(I,J) + ( E(I,J) + E(I-1,J) ) / 2.0D0
          DR2 = H(I,J) + E(I,J)
          DL2 = H(I-1,J) + E(I-1,J)
          DU2 = HP(I,J+1)
     1       + ( E(I,J) + E(I-1,J) + EIJP12 + EIM1JP12 ) / 4.0D0
          DD2 = HP(I,J)
     1       + ( E(I,J) + E(I-1,J) + EIJM12 + EIM1JM12 ) / 4.0D0
          QAVG = ( Q(I-1,J)+Q(I,J)+Q(I-1,J+1)+Q(I,J+1) )
     1           / 4.0D0
C
          QU = ( Q(I,J+1)+Q(I-1,J+1) ) / 2.0D0
          QD = ( Q(I,J)+Q(I-1,J) ) / 2.0D0
          QR = ( Q(I,J)+Q(I,J+1) ) / 2.0D0
          QL = ( Q(I-1,J)+Q(I-1,J+1) ) / 2.0D0
          QUOLD = ( QOLD(I,J+1)+QOLD(I-1,J+1) ) / 2.0D0
          QDOLD = ( QOLD(I,J)+QOLD(I-1,J) ) / 2.0D0
          QROLD = ( QOLD(I,J)+QOLD(I,J+1) ) / 2.0D0
          QLOLD = ( QOLD(I-1,J)+QOLD(I-1,J+1) ) / 2.0D0
          EE = ( EIP1J2+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+E(I-1,J) ) / 2.0D0
          EW = ( E(I-1,J)+EIM2J ) / 2.0D0
          EN = ( EIJP12+EIM1JP12 ) / 2.0D0
          ES = ( EIJM12+EIM1JM12 ) / 2.0D0
          ENE = ( EIJP12+E(I,J) ) / 2.0D0
          ENW = ( EIM1JP12+E(I-1,J) ) / 2.0D0
          ESE = ( E(I,J)+EIJM12 ) / 2.0D0
          ESW = ( E(I-1,J)+EIM1JM12 ) / 2.0D0
C
          BUN = ( 1.0D0/3.0D0+BB ) * HX(I,J)*HX(I,J) *( 
     1          - RDX2DT*( P(I+1,J)-2.0D0*P(I,J)+P(I-1,J) )
     2          + RDXDYDT*( ( Q(I,J+1)-Q(I-1,J+1)
     3                                   -Q(I,J)+Q(I-1,J) )
     4                     -( QOLD(I,J+1)-QOLD(I-1,J+1)
     5                                 -QOLD(I,J)+QOLD(I-1,J) ) ) )
          BUN2 = BB*G*HX(I,J)*HX(I,J)*HX(I,J) *( 
     1       1.0D0/DX/DX/DX*( EIP1J2-3.0D0*E(I,J)+3.0D0*E(I-1,J)-EIM2J )
     2       + 1.0D0/DX/DY/DY*( ( EIJP12-2.0D0*E(I,J)+EIJM12 )
     3                       -( EIM1JP12-2.0D0*E(I-1,J)+EIM1JM12 ) ) )
          BUN3 = BB*G*HX(I,J)*HX(I,J)*( 
     1         ( H(I,J)-H(I-1,J) )/DX * ( 
     2                     2.0D0*( EE-2.0D0*EC+EW )/DX/DX
     3                       + ( EN-2.0D0*EC+ES )/DY/DY )
     4       + ( HP(I,J+1)-HP(I,J) )/DY * 
     5             ( ENE-ENW-ESE+ESW )/DX/DY )
          SATSU = FFX(I,J) * SQRT(P(I,J)*P(I,J)+QAVG*QAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = XNYU(I,J) * RDX2 / 2.0D0
C
          RMATRIX(I,1) = -R4DX*( P(I,J)+P(I-1,J) )/DL2 - DTR4DX2*G*DC2
     1                   - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J)*HX(I,J)
     2                   - SAIHA
     3                   + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,2) = 1.0D0/DT
     1       + R4DX * ( (P(I,J)+P(I+1,J))/DR2 - (P(I,J)+P(I-1,J))/DL2 )
     2    + R4DY * ( (Q(I-1,J+1)+Q(I,J+1))/DU2 - (Q(I-1,J)+Q(I,J))/DD2)
     3                 + DTR2DX2*G*DC2
     4           + ( 2.0D0/3.0D0+2.0D0*BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     4                 + FDX(I,J)/2.0D0 + SATSU + SAIHA*2.0D0
          RMATRIX(I,3) = R4DX*( P(I,J)+P(I+1,J) )/DR2 - DTR4DX2*G*DC2
     1               - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     2                   - SAIHA
     3                   - HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,4) = 1.0D0/DT*P(I,J)
     1                 - R4DY * ( PIJP12*(Q(I-1,J+1)+Q(I,J+1))/DU2
     2                          - PIJM12*(Q(I-1,J)+Q(I,J))/DD2 )
     3    - G/DX*DC2*( EOLD(I,J) - EOLD(I-1,J)
     4               - DTR4DX*( P(I+1,J) - 2.0D0*P(I,J) + P(I-1,J) )
     5               - ( DQDY(I,J) - DQDY(I-1,J) ) )
     6    + BUN + BUN2 + BUN3 - FDX(I,J)*P(I,J)/2.0D0 - SATSU*P(I,J)
     7    + SAIHA*( P(I+1,J)-2.0D0*P(I,J)+P(I-1,J) )
     8    + XNYU(I,J)*RDY2*( PIJP12-2.0D0*P(I,J)+PIJM12 )
     1    + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX * (
     2     - ( P(I+1,J)-P(I-1,J) )/DX/6.0D0
     3     + ( QU-QD-QUOLD+QDOLD )/DY/6.0D0 )
     1    + HX(I,J)*( HP(I,J+1)-HP(I,J) )/DT/DY * (
     2     + ( QR-QL-QROLD+QLOLD )/DX/6.0D0 )
C
         ELSE
C
          DC2 = HX(I,J) + ( E(I,J) + E(I-1,J) ) / 2.0D0
          DR2 = H(I,J) + E(I,J)
          DL2 = H(I-1,J) + E(I-1,J)
          DU2 = HP(I,J+1)
     1       + ( E(I,J) + E(I-1,J) + EIJP12 + EIM1JP12 ) / 4.0D0
          DD2 = HP(I,J)
     1       + ( E(I,J) + E(I-1,J) + EIJM12 + EIM1JM12 ) / 4.0D0
          QAVG = ( Q(I-1,J)+Q(I,J)+Q(I-1,J+1)+Q(I,J+1) )
     1           / 4.0D0
C
          QU = ( Q(I,J+1)+Q(I-1,J+1) ) / 2.0D0
          QD = ( Q(I,J)+Q(I-1,J) ) / 2.0D0
          QR = ( Q(I,J)+Q(I,J+1) ) / 2.0D0
          QL = ( Q(I-1,J)+Q(I-1,J+1) ) / 2.0D0
          QUOLD = ( QOLD(I,J+1)+QOLD(I-1,J+1) ) / 2.0D0
          QDOLD = ( QOLD(I,J)+QOLD(I-1,J) ) / 2.0D0
          QROLD = ( QOLD(I,J)+QOLD(I,J+1) ) / 2.0D0
          QLOLD = ( QOLD(I-1,J)+QOLD(I-1,J+1) ) / 2.0D0
          EE = ( EIP1J2+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+E(I-1,J) ) / 2.0D0
          EW = ( E(I-1,J)+EIM2J2 ) / 2.0D0
          EN = ( EIJP12+EIM1JP12 ) / 2.0D0
          ES = ( EIJM12+EIM1JM12 ) / 2.0D0
          ENE = ( EIJP12+E(I,J) ) / 2.0D0
          ENW = ( EIM1JP12+E(I-1,J) ) / 2.0D0
          ESE = ( E(I,J)+EIJM12 ) / 2.0D0
          ESW = ( E(I-1,J)+EIM1JM12 ) / 2.0D0
C
          BUN = ( 1.0D0/3.0D0+BB ) * HX(I,J)*HX(I,J) *( 
     1          - RDX2DT*( P(I+1,J)-2.0D0*P(I,J)+P(I-1,J) )
     2          + RDXDYDT*( ( Q(I,J+1)-Q(I-1,J+1)
     3                                   -Q(I,J)+Q(I-1,J) )
     4                     -( QOLD(I,J+1)-QOLD(I-1,J+1)
     5                                 -QOLD(I,J)+QOLD(I-1,J) ) ) )
          BUN2 = BB*G*HX(I,J)*HX(I,J)*HX(I,J) *( 
     1       1.0/DX/DX/DX*( EIP1J2-3.0D0*E(I,J)+3.0D0*E(I-1,J)-EIM2J2 )
     2       + 1.0/DX/DY/DY*( ( EIJP12-2.0D0*E(I,J)+EIJM12 )
     3                       -( EIM1JP12-2.0D0*E(I-1,J)+EIM1JM12 ) ) )
          BUN3 = BB*G*HX(I,J)*HX(I,J)*( 
     1         ( H(I,J)-H(I-1,J) )/DX * ( 
     2                     2.0D0*( EE-2.0D0*EC+EW )/DX/DX
     3                       + ( EN-2.0D0*EC+ES )/DY/DY )
     4       + ( HP(I,J+1)-HP(I,J) )/DY * 
     5             ( ENE-ENW-ESE+ESW )/DX/DY )
          BUN4 = HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX * (
     1                       - ( P(I+1,J)-P(I-1,J) )/DX/6.0D0
     2                       + ( QU-QD-QUOLD+QDOLD )/DY/6.0D0 )
     3         + HX(I,J)*( HP(I,J+1)-HP(I,J) )/DT/DY * (
     4                       + ( QR-QL-QROLD+QLOLD )/DX/6.0D0 )
          SATSU = FFX(I,J) * SQRT(P(I,J)*P(I,J)+QAVG*QAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = XNYU(I,J) * RDX2 / 2.0D0
C
          PORO2 = FDX(I,J)*( P(I,J)*0.5D0 - (
     1              ( 1.0D0/3.0D0+BB ) *HX(I,J)*HX(I,J)
     2              *( ( P(I+1,J)-2.0D0*P(I,J)+P(I-1,J) )*RDX2*0.5D0
     3                +( Q(I,J+1)-Q(I-1,J+1)-Q(I,J)+Q(I-1,J) )*RDXDY )
     4            + HX(I,J)*( H(I,J)-H(I-1,J) )
     5              *( 1.0D0/3.0D0*( P(I+1,J)-P(I-1,J) )*R4DX2
     6                +1.0D0/6.0D0*( QU      -QD       )*RDXDY )
     7            + HX(I,J)*( HP(I,J+1)-HP(I,J) )
     8              *( 1.0D0/6.0D0*( QR      -QL       )*RDXDY )     ) )
C
C
          RMATRIX(I,1) = -R4DX*( P(I,J)+P(I-1,J) )/DL2
     1      - DTR4DX2*G*DC2
     2                   - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J)*HX(I,J)
     3                   - SAIHA
     4                   + HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,1) = RMATRIX(I,1)
     &    + FDX(I,J)*( - ( 1.0D0/3.0D0+BB )*HX(I,J)*HX(I,J)*RDX2*0.5D0
     &                 + HX(I,J)*( H(I,J)-H(I-1,J) )*R4DX2/3.0D0 )
C
          RMATRIX(I,2) = 1.0D0/DT
     1       + R4DX * ( (P(I,J)+P(I+1,J))/DR2 - (P(I,J)+P(I-1,J))/DL2 )
     2    + R4DY * ( (Q(I-1,J+1)+Q(I,J+1))/DU2 - (Q(I-1,J)+Q(I,J))/DD2)
     3           + DTR2DX2*G*DC2
     4           + ( 2.0D0/3.0D0+2.0D0*BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     5           + SATSU + SAIHA*2.0D0
          RMATRIX(I,2) = RMATRIX(I,2)
     &    + FDX(I,J)*( 0.5D0+RDX2*( 1.0D0/3.0D0+BB )*HX(I,J)*HX(I,J) )
C
          RMATRIX(I,3) = R4DX*( P(I,J)+P(I+1,J) )/DR2
     1      - DTR4DX2*G*DC2
     2               - ( 1.0D0/3.0D0+BB )/DX/DX/DT * HX(I,J) * HX(I,J)
     3                   - SAIHA
     4                   - HX(I,J)*( H(I,J)-H(I-1,J) )/DT/DX/DX/6.0D0
          RMATRIX(I,3) = RMATRIX(I,3)
     &    + FDX(I,J)*( - ( 1.0D0/3.0D0+BB )*HX(I,J)*HX(I,J)*RDX2*0.5D0
     &                 - HX(I,J)*( H(I,J)-H(I-1,J) )*R4DX2/3.0D0 )
C
          RMATRIX(I,4) = 1.0/DT*P(I,J)
     1                 - R4DY * ( PIJP12*(Q(I-1,J+1)+Q(I,J+1))/DU2
     2                          - PIJM12*(Q(I-1,J)+Q(I,J))/DD2 )
     3    - G/DX*DC2*( EOLD(I,J) - EOLD(I-1,J)
     4               - DTR4DX*( P(I+1,J) - 2.0D0*P(I,J) + P(I-1,J) )
     5               - ( DQDY(I,J) - DQDY(I-1,J) ) )
     8               + BUN + BUN2 + BUN3 + BUN4 - SATSU*P(I,J)
     9    + SAIHA*( P(I+1,J)-2.0*P(I,J)+P(I-1,J) )
     1    + XNYU(I,J)*RDY2*( PIJP12-2.0*P(I,J)+PIJM12 )
          RMATRIX(I,4) = RMATRIX(I,4)
     &    - PORO2
C
         ENDIF
C
  110 CONTINUE
C
C
        CALL  TRISOL( LDM, IIS, IIE, RMATRIX, RX )
C
C
        DO  120  I = IIS, IIE
          POLD(I,J) = RX(I)
  120   CONTINUE
C
      RETURN
      END
C
C     -----------  CALCULATION  Q -------------
C
      SUBROUTINE  CALCQ( IMAX, JMAX, I, JJS, JJE, E, EOLD,
     1                   P, POLD, Q, QOLD,
     2     EIN, EINOLD, PIN, PINOLD, QIN, QINOLD,
     3                   FDY, YNYU, HLIMIT,
     4                   H, HY, HP, DX, DY, DT,
     5                   DPDX, FFY )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      include 'rgn_bsq46c8a_r1.inc'
C
      DIMENSION   RMATRIX(LDM,4), RX(LDM)
C
      DIMENSION   E(IMAX,JMAX),   EOLD(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX),   POLD(IMAX,JMAX)
      DIMENSION   Q(IMAX,JMAX),   QOLD(IMAX,JMAX)
      DIMENSION   EIN(IMAX,JMAX), EINOLD(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX), PINOLD(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX), QINOLD(IMAX,JMAX)
C
      DIMENSION   H(IMAX,JMAX), HY(IMAX,JMAX), HP(IMAX,JMAX)
      DIMENSION   FDY(IMAX,JMAX)
      DIMENSION   YNYU(IMAX,JMAX)
      DIMENSION   FFY(IMAX,JMAX)
C
      DIMENSION   DPDX(IMAX,JMAX)
C
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      COMMON / BKEISU / DTR4DX, R4DX, DTR4DX2, R3DX2DT, DTR2DX2,
     1                  DR3DX2DT, RDX2, RDX2DT,
     2                  DTR4DY, R4DY, DTR4DY2, R3DY2DT, DTR2DY2,
     3                  DR3DY2DT, RDY2, RDY2DT, RDXDYDT,
     4                  RDXDY, R4DX2, R4DY2
C
      G = 9.8D0
C
C
C             CALCULATION Q
C
C
      BB = 1.0D0/15.0D0
C
C
      IF ( I .EQ. I0-1 ) THEN
C
        DO  110  J = JJS, JJE
C
          QIP1J2 = Q(I+1,J)
          QIM1J2 = Q(I-1,J)
          QINIP1JO2 = QINOLD(I+1,J)
          QINIM1JO2 = QINOLD(I-1,J)
          EIP1J2   = E(I+1,J)
          EIP1JM12 = E(I+1,J-1)
          EIM1J2   = E(I-1,J)
          EIM1JM12 = E(I-1,J-1)
          EINIP1J2   = EIN(I+1,J)
          EINIP1JM12 = EIN(I+1,J-1)
          EINIM1J2   = EIN(I-1,J)
          EINIM1JM12 = EIN(I-1,J-1)
          EIJM22 = E(I,J-2)
          EIJP12 = E(I,J+1)
          IF ( (H(I+1,J-1).LE.HLIMIT ).AND.(H(I+1,J).LE.HLIMIT ) ) THEN
            QIP1J2 = Q(I,J)
            QINIP1JO2 = QINOLD(I,J)
          END IF
          IF ( (H(I-1,J-1).LE.HLIMIT ).AND.(H(I-1,J).LE.HLIMIT ) ) THEN
            QIM1J2 = Q(I,J)
            QINIM1JO2 = QINOLD(I,J)
          END IF
          IF ( H(I+1,J).LE. HLIMIT ) THEN
            EIP1J2 = E(I,J)
            EINIP1J2 = EIN(I,J)
          END IF
          IF ( H(I+1,J-1).LE. HLIMIT ) THEN
            EIP1JM12 = E(I,J-1)
            EINIP1JM12 = EIN(I,J-1)
          END IF
          IF ( H(I-1,J).LE. HLIMIT ) THEN
            EIM1J2 = E(I,J)
            EINIM1J2 = EIN(I,J)
          END IF
          IF ( H(I-1,J-1).LE. HLIMIT ) THEN
            EIM1JM12 = E(I,J-1)
            EINIM1JM12 = EIN(I,J-1)
          END IF
          IF ( H(I,J-2).LE. HLIMIT ) THEN
            EIJM22 = E(I,J-1)
          ENDIF
          IF ( H(I,J+1).LE. HLIMIT ) THEN
            EIJP12 = E(I,J)
          ENDIF
C
          PIP1JM1 = P(I+1,J-1) - PIN(I0,J-1)
          PIP1JM1O = POLD(I+1,J-1) - PINOLD(I0,J-1)
          PIP1J = P(I+1,J) - PIN(I0,J)
          PIP1JO = POLD(I+1,J) - PINOLD(I0,J)
          IF( H(I+1,J-1).GT.HLIMIT )THEN
            EIP1JM1 = EIP1JM12 - EINIP1JM12
            QIP1J = QIP1J2 - QINIP1JO2
          ELSE
            EIP1JM1 = EIP1JM12
            QIP1J = QIP1J2
          END IF
          IF( H(I+1,J).GT.HLIMIT )THEN
            EIP1J = EIP1J2 - EINIP1J2
            QIP1J = QIP1J2 - QINIP1JO2
          ELSE
            EIP1J = EIP1J2
            QIP1J = QIP1J2
          END IF
          DC2 = HY(I,J) + ( E(I,J) + E(I,J-1) ) / 2.0D0
          DU2 = H(I,J) + E(I,J)
          DD2 = H(I,J-1) + E(I,J-1)
          DR2 = HP(I+1,J)
     1       + ( E(I,J) + E(I,J-1) + EIP1J + EIP1JM1 ) / 4.0D0
          DL2 = HP(I,J)
     1       + ( E(I,J) + E(I,J-1) + EIM1J2 + EIM1JM12 ) / 4.0D0
          PAVG = ( P(I,J-1)+P(I,J)+PIP1JM1+PIP1J )
     1           / 4.0D0
C
          PR = ( PIP1J+PIP1JM1 ) / 2.0D0
          PL = ( P(I,J)+P(I,J-1) ) / 2.0D0
          PU = ( PIP1J+P(I,J) ) / 2.0D0
          PD = ( PIP1JM1+P(I,J-1) ) / 2.0D0
          PROLD = ( PIP1JO+PIP1JM1O ) / 2.0D0
          PLOLD = ( POLD(I,J)+POLD(I,J-1) ) / 2.0D0
          PUOLD = ( PIP1JO+POLD(I,J) ) / 2.0D0
          PDOLD = ( PIP1JM1O+POLD(I,J-1) ) / 2.0D0
          EN = ( EIJP12+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+E(I,J-1) ) / 2.0D0
          ES = ( E(I,J-1)+EIJM22 ) / 2.0D0
          EE = ( EIP1J+EIP1JM1 ) / 2.0D0
          EW = ( EIM1J2+EIM1JM12 ) / 2.0D0
          ENE = ( EIP1J+E(I,J) ) / 2.0D0
          ENW = ( E(I,J)+EIM1J2 ) / 2.0D0
          ESE = ( EIP1JM1+E(I,J-1) ) / 2.0D0
          ESW = ( E(I,J-1)+EIM1JM12 ) / 2.0D0
C
          BUN = ( 1.0D0/3.0D0+BB ) * HY(I,J)*HY(I,J) *( 
     1          - RDY2DT*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     2          + RDXDYDT*( ( PIP1J-PIP1JM1
     3                                   -P(I,J)+P(I,J-1) )
     4                     -( PIP1JO-PIP1JM1O
     5                                 -POLD(I,J)+POLD(I,J-1) ) ) )
          BUN2 = BB*G*HY(I,J)*HY(I,J)*HY(I,J) *( 
     1      1.0D0/DY/DY/DY*( EIJP12-3.0D0*E(I,J)+3.0D0*E(I,J-1)-EIJM22 )
     2     +1.0D0/DY/DX/DX*( ( EIP1J-2.0D0*E(I,J)+EIM1J2 )
     3                       -( EIP1JM1-2.0D0*E(I,J-1)+EIM1JM12 ) ) )
          BUN3 = BB*G*HY(I,J)*HY(I,J) *( 
     1         ( H(I,J)-H(I,J-1) )/DY *( 
     2              2.0D0*( EN-2.0D0*EC+ES )/DY/DY
     3                 +( EE-2.0D0*EC+EW )/DX/DX )
     4        +( HP(I+1,J)-HP(I,J) )/DX *
     5              ( ENE-ENW-ESE+ESW )/DX/DY )
          SATSU = FFY(I,J) * SQRT(Q(I,J)*Q(I,J)+PAVG*PAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = YNYU(I,J) * RDY2 / 2.0D0
C
          RMATRIX(J,1) = -R4DY*(Q(I,J)+Q(I,J-1))/DD2 - DTR4DY2*G*DC2
     1                - ( 1.0D0/3.0D0+BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     2                - SAIHA
     3                + HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY/DY/6.0D0
C
          RMATRIX(J,2) = 1.0/DT
     1      + R4DY*( (Q(I,J)+Q(I,J+1))/DU2 - (Q(I,J)+Q(I,J-1))/DD2 )
     2      + R4DX*( (PIP1JM1+PIP1J)/DR2-(P(I,J-1)+P(I,J))/DL2)
     3                 + DTR2DY2*G*DC2
     4           + ( 2.0D0/3.0D0+2.0D0*BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     5           + FDY(I,J)/2.0D0 + SATSU + SAIHA*2.0D0
C
          RMATRIX(J,3) = R4DY*(Q(I,J)+Q(I,J+1))/DU2 - DTR4DY2*G*DC2
     1                - ( 1.0D0/3.0D0+BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     2                - SAIHA
     3                - HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY/DY/6.0D0
          RMATRIX(J,4) = 1.0D0/DT*Q(I,J)
     1      - R4DX*( QIP1J*(PIP1JM1+PIP1J)/DR2
     2               - QIM1J2*(P(I,J-1)+P(I,J))/DL2 )
     3    - G/DY*DC2*( ( EOLD(I,J)-EOLD(I,J-1) )
     4               - DTR4DY*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     5               - ( DPDX(I,J) - DPDX(I,J-1) ) )
C C     5               -DTR4DX*( ( PIP1J-P(I,J)+PIP1JO-POLD(I,J) )  ! = DPDX(I,J)
C C     6                        -( PIP1JM1-P(I,J-1)                 ! = DPDX(I,J-1)
C C     7                                    +PIP1JM1O-POLD(I,J-1) ) ) )
     6    + BUN + BUN2 + BUN3 - FDY(I,J)*Q(I,J)/2.0D0 - SATSU*Q(I,J)
     7    + SAIHA*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     8    + YNYU(I,J)*RDX2*( QIP1J-2.0D0*Q(I,J)+QIM1J2 )
     1    + HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY* (
     2     - ( Q(I,J+1)-Q(I,J-1) )/DY/6.0D0
     3     + ( PR-PL-PROLD+PLOLD )/DX/6.0D0 )
     1    + HY(I,J)*( HP(I+1,J)-HP(I,J) )/DT/DX* (
     2     + ( PU-PD-PUOLD+PDOLD )/DY/6.0D0 )
C
  110   CONTINUE
C
      ELSEIF ( I .EQ. I0 ) THEN
C
        DO  111  J = JJS, JJE
C
          QIP1J2 = Q(I+1,J)
          QIM1J2 = Q(I-1,J)
          QINIP1JO2 = QINOLD(I+1,J)
          QINIM1JO2 = QINOLD(I-1,J)
          EIP1J2   = E(I+1,J)
          EIP1JM12 = E(I+1,J-1)
          EIM1J2   = E(I-1,J)
          EIM1JM12 = E(I-1,J-1)
          EINIP1J2   = EIN(I+1,J)
          EINIP1JM12 = EIN(I+1,J-1)
          EINIM1J2   = EIN(I-1,J)
          EINIM1JM12 = EIN(I-1,J-1)
          EIJM22 = E(I,J-2)
          EIJP12 = E(I,J+1)
          IF ( (H(I+1,J-1).LE.HLIMIT ).AND.(H(I+1,J).LE.HLIMIT ) ) THEN
            QIP1J2 = Q(I,J)
            QINIP1JO2 = QINOLD(I,J)
          END IF
          IF ( (H(I-1,J-1).LE.HLIMIT ).AND.(H(I-1,J).LE.HLIMIT ) ) THEN
            QIM1J2 = Q(I,J)
            QINIM1JO2 = QINOLD(I,J)
          END IF
          IF ( H(I+1,J).LE. HLIMIT ) THEN
            EIP1J2 = E(I,J)
            EINIP1J2 = EIN(I,J)
          END IF
          IF ( H(I+1,J-1).LE. HLIMIT ) THEN
            EIP1JM12 = E(I,J-1)
            EINIP1JM12 = EIN(I,J-1)
          END IF
          IF ( H(I-1,J).LE. HLIMIT ) THEN
            EIM1J2 = E(I,J)
            EINIM1J2 = EIN(I,J)
          END IF
          IF ( H(I-1,J-1).LE. HLIMIT ) THEN
            EIM1JM12 = E(I,J-1)
            EINIM1JM12 = EIN(I,J-1)
          END IF
          IF ( H(I,J-2).LE. HLIMIT ) THEN
            EIJM22 = E(I,J-1)
          ENDIF
          IF ( H(I,J+1).LE. HLIMIT ) THEN
            EIJP12 = E(I,J)
          ENDIF
C
          IF( H(I-1,J-1).GT.HLIMIT )THEN
            EIM1JM1 = EIM1JM12 + EINIM1JM12
            QIM1J = QIM1J2 + QINIM1JO2
          ELSE
            EIM1JM1 = EIM1JM12
            QIM1J = QIM1J2
          END IF
          IF( H(I-1,J).GT.HLIMIT )THEN
            EIM1J = EIM1J2 + EINIM1J2
            QIM1J = QIM1J2 + QINIM1JO2
          ELSE
            EIM1J = EIM1J2
            QIM1J = QIM1J2
          END IF
          DC2 = HY(I,J) + ( E(I,J) + E(I,J-1) ) / 2.0D0
          DU2 = H(I,J) + E(I,J)
          DD2 = H(I,J-1) + E(I,J-1)
          DR2 = HP(I+1,J)
     1       + ( E(I,J) + E(I,J-1) + EIP1J2 + EIP1JM12 ) / 4.0D0
          DL2 = HP(I,J)
     1       + ( E(I,J) + E(I,J-1) + EIM1J + EIM1JM1 ) / 4.0D0
          PAVG = ( P(I,J-1)+P(I,J)+P(I+1,J-1)+P(I+1,J) )
     1           / 4.0D0
C
          PR = ( P(I+1,J)+P(I+1,J-1) ) / 2.0D0
          PL = ( P(I,J)+P(I,J-1) ) / 2.0D0
          PU = ( P(I+1,J)+P(I,J) ) / 2.0D0
          PD = ( P(I+1,J-1)+P(I,J-1) ) / 2.0D0
          PROLD = ( POLD(I+1,J)+POLD(I+1,J-1) ) / 2.0D0
          PLOLD = ( POLD(I,J)+POLD(I,J-1) ) / 2.0D0
          PUOLD = ( POLD(I+1,J)+POLD(I,J) ) / 2.0D0
          PDOLD = ( POLD(I+1,J-1)+POLD(I,J-1) ) / 2.0D0
          EN = ( EIJP12+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+E(I,J-1) ) / 2.0D0
          ES = ( E(I,J-1)+EIJM22 ) / 2.0D0
          EE = ( EIP1J2+EIP1JM12 ) / 2.0D0
          EW = ( EIM1J+EIM1JM1 ) / 2.0D0
          ENE = ( EIP1J2+E(I,J) ) / 2.0D0
          ENW = ( E(I,J)+EIM1J ) / 2.0D0
          ESE = ( EIP1JM12+E(I,J-1) ) / 2.0D0
          ESW = ( E(I,J-1)+EIM1JM1 ) / 2.0D0
C
          BUN = ( 1.0D0/3.0D0+BB ) * HY(I,J)*HY(I,J) *( 
     1          - RDY2DT*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     2          + RDXDYDT*( ( P(I+1,J)-P(I+1,J-1)
     3                                   -P(I,J)+P(I,J-1) )
     4                     -( POLD(I+1,J)-POLD(I+1,J-1)
     5                                 -POLD(I,J)+POLD(I,J-1) ) ) )
          BUN2 = BB*G*HY(I,J)*HY(I,J)*HY(I,J) *( 
     1      1.0D0/DY/DY/DY*( EIJP12-3.0D0*E(I,J)+3.0D0*E(I,J-1)-EIJM22 )
     2     +1.0D0/DY/DX/DX*( ( EIP1J2-2.0D0*E(I,J)+EIM1J )
     3                       -( EIP1JM12-2.0D0*E(I,J-1)+EIM1JM1 ) ) )
          BUN3 = BB*G*HY(I,J)*HY(I,J) *( 
     1         ( H(I,J)-H(I,J-1) )/DY *( 
     2              2.0D0*( EN-2.0D0*EC+ES )/DY/DY
     3                 +( EE-2.0D0*EC+EW )/DX/DX )
     4        +( HP(I+1,J)-HP(I,J) )/DX *
     5              ( ENE-ENW-ESE+ESW )/DX/DY )
          SATSU = FFY(I,J) * SQRT(Q(I,J)*Q(I,J)+PAVG*PAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = YNYU(I,J) * RDY2 / 2.0D0
C
          RMATRIX(J,1) = -R4DY*(Q(I,J)+Q(I,J-1))/DD2 - DTR4DY2*G*DC2
     1                - ( 1.0D0/3.0D0+BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     2                - SAIHA
     3                + HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY/DY/6.0D0
C
          RMATRIX(J,2) = 1.0D0/DT
     1      + R4DY*( (Q(I,J)+Q(I,J+1))/DU2 - (Q(I,J)+Q(I,J-1))/DD2 )
     2      + R4DX*( (P(I+1,J-1)+P(I+1,J))/DR2-(P(I,J-1)+P(I,J))/DL2)
     3           + DTR2DY2*G*DC2
     4           + ( 2.0D0/3.0D0+2.0D0*BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     5           + FDY(I,J)/2.0D0 + SATSU + SAIHA*2.0D0
C
          RMATRIX(J,3) = R4DY*(Q(I,J)+Q(I,J+1))/DU2 - DTR4DY2*G*DC2
     1               - ( 1.0D0/3.0D0+BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     2               - SAIHA
     3               - HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY/DY/6.0D0
          RMATRIX(J,4) = 1.0D0/DT*Q(I,J)
     1      - R4DX*( QIP1J2*(P(I+1,J-1)+P(I+1,J))/DR2
     2               - QIM1J*(P(I,J-1)+P(I,J))/DL2 )
     3    - G/DY*DC2*( ( EOLD(I,J)-EOLD(I,J-1) )
     4               - DTR4DY*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     5               - ( DPDX(I,J) - DPDX(I,J-1) ) )
     6    + BUN + BUN2 + BUN3 - FDY(I,J)*Q(I,J)/2.0D0 - SATSU*Q(I,J)
     7    + SAIHA*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     8    + YNYU(I,J)*RDX2*( QIP1J2-2.0D0*Q(I,J)+QIM1J )
     1    + HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY* (
     2     - ( Q(I,J+1)-Q(I,J-1) )/DY/6.0D0
     3     + ( PR-PL-PROLD+PLOLD )/DX/6.0D0 )
     1    + HY(I,J)*( HP(I+1,J)-HP(I,J) )/DT/DX* (
     2     + ( PU-PD-PUOLD+PDOLD )/DY/6.0D0 )
C
  111   CONTINUE
C
      ELSE
C
        DO  112  J = JJS, JJE
C
          QIP1J2 = Q(I+1,J)
          QIM1J2 = Q(I-1,J)
          QINIP1JO2 = QINOLD(I+1,J)
          QINIM1JO2 = QINOLD(I-1,J)
          EIP1J2   = E(I+1,J)
          EIP1JM12 = E(I+1,J-1)
          EIM1J2   = E(I-1,J)
          EIM1JM12 = E(I-1,J-1)
          EINIP1J2   = EIN(I+1,J)
          EINIP1JM12 = EIN(I+1,J-1)
          EINIM1J2   = EIN(I-1,J)
          EINIM1JM12 = EIN(I-1,J-1)
          EIJM22 = E(I,J-2)
          EIJP12 = E(I,J+1)
          IF ( (H(I+1,J-1).LE.HLIMIT ).AND.(H(I+1,J).LE.HLIMIT ) ) THEN
            QIP1J2 = Q(I,J)
            QINIP1JO2 = QINOLD(I,J)
          END IF
          IF ( (H(I-1,J-1).LE.HLIMIT ).AND.(H(I-1,J).LE.HLIMIT ) ) THEN
            QIM1J2 = Q(I,J)
            QINIM1JO2 = QINOLD(I,J)
          END IF
          IF ( H(I+1,J).LE. HLIMIT ) THEN
            EIP1J2 = E(I,J)
            EINIP1J2 = EIN(I,J)
          END IF
          IF ( H(I+1,J-1).LE. HLIMIT ) THEN
            EIP1JM12 = E(I,J-1)
            EINIP1JM12 = EIN(I,J-1)
          END IF
          IF ( H(I-1,J).LE. HLIMIT ) THEN
            EIM1J2 = E(I,J)
            EINIM1J2 = EIN(I,J)
          END IF
          IF ( H(I-1,J-1).LE. HLIMIT ) THEN
            EIM1JM12 = E(I,J-1)
            EINIM1JM12 = EIN(I,J-1)
          END IF
          IF ( H(I,J-2).LE. HLIMIT ) THEN
            EIJM22 = E(I,J-1)
          ENDIF
          IF ( H(I,J+1).LE. HLIMIT ) THEN
            EIJP12 = E(I,J)
          ENDIF
C
          DC2 = HY(I,J) + ( E(I,J) + E(I,J-1) ) / 2.0D0
          DU2 = H(I,J) + E(I,J)
          DD2 = H(I,J-1) + E(I,J-1)
          DR2 = HP(I+1,J)
     1       + ( E(I,J) + E(I,J-1) + EIP1J2 + EIP1JM12 ) / 4.0D0
          DL2 = HP(I,J)
     1       + ( E(I,J) + E(I,J-1) + EIM1J2 + EIM1JM12 ) / 4.0D0
          PAVG = ( P(I,J-1)+P(I,J)+P(I+1,J-1)+P(I+1,J) )
     1           / 4.0D0
C
          PR = ( P(I+1,J)+P(I+1,J-1) ) / 2.0D0
          PL = ( P(I,J)+P(I,J-1) ) / 2.0D0
          PU = ( P(I+1,J)+P(I,J) ) / 2.0D0
          PD = ( P(I+1,J-1)+P(I,J-1) ) / 2.0D0
          PROLD = ( POLD(I+1,J)+POLD(I+1,J-1) ) / 2.0D0
          PLOLD = ( POLD(I,J)+POLD(I,J-1) ) / 2.0D0
          PUOLD = ( POLD(I+1,J)+POLD(I,J) ) / 2.0D0
          PDOLD = ( POLD(I+1,J-1)+POLD(I,J-1) ) / 2.0D0
          EN = ( EIJP12+E(I,J) ) / 2.0D0
          EC = ( E(I,J)+E(I,J-1) ) / 2.0D0
          ES = ( E(I,J-1)+EIJM22 ) / 2.0D0
          EE = ( EIP1J2+EIP1JM12 ) / 2.0D0
          EW = ( EIM1J2+EIM1JM12 ) / 2.0D0
          ENE = ( EIP1J2+E(I,J) ) / 2.0D0
          ENW = ( E(I,J)+EIM1J2 ) / 2.0D0
          ESE = ( EIP1JM12+E(I,J-1) ) / 2.0D0
          ESW = ( E(I,J-1)+EIM1JM12 ) / 2.0D0
C
          BUN = ( 1.0D0/3.0D0+BB ) * HY(I,J)*HY(I,J) *( 
     1          - RDY2DT*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     2          + RDXDYDT*( ( P(I+1,J)-P(I+1,J-1)
     3                                   -P(I,J)+P(I,J-1) )
     4                     -( POLD(I+1,J)-POLD(I+1,J-1)
     5                                 -POLD(I,J)+POLD(I,J-1) ) ) )
          BUN2 = BB*G*HY(I,J)*HY(I,J)*HY(I,J) *( 
     1      1.0D0/DY/DY/DY*( EIJP12-3.0D0*E(I,J)+3.0D0*E(I,J-1)-EIJM22 )
     2     +1.0D0/DY/DX/DX*( ( EIP1J2-2.0D0*E(I,J)+EIM1J2 )
     3                       -( EIP1JM12-2.0D0*E(I,J-1)+EIM1JM12 ) ) )
          BUN3 = BB*G*HY(I,J)*HY(I,J) *( 
     1         ( H(I,J)-H(I,J-1) )/DY *( 
     2              2.0D0*( EN-2.0D0*EC+ES )/DY/DY
     3                 +( EE-2.0D0*EC+EW )/DX/DX )
     4        +( HP(I+1,J)-HP(I,J) )/DX *
     5              ( ENE-ENW-ESE+ESW )/DX/DY )
          BUN4 = HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY* (
     1                        - ( Q(I,J+1)-Q(I,J-1) )/DY/6.0D0
     2                        + ( PR-PL-PROLD+PLOLD )/DX/6.0D0 )
     3         + HY(I,J)*( HP(I+1,J)-HP(I,J) )/DT/DX* (
     4                        + ( PU-PD-PUOLD+PDOLD )/DY/6.0D0 )
          SATSU = FFY(I,J) * SQRT(Q(I,J)*Q(I,J)+PAVG*PAVG)
     1            / DC2/DC2 / 4.0D0
          SAIHA = YNYU(I,J) * RDY2 / 2.0D0
C
          PORO2 = FDY(I,J)*( Q(I,J)*0.5D0 - (
     &              ( 1.0D0/3.0D0+BB ) * HY(I,J)*HY(I,J)
     &              *( ( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )*RDY2*0.5D0
     &                +( P(I+1,J)-P(I,J)-P(I+1,J-1)+P(I,J-1) )*RDXDY )
     &            + HY(I,J)*( H(I,J)-H(I,J-1) )
     &              *( 1.0D0/3.0D0*( Q(I,J+1)-Q(I,J-1) )*R4DY2
     &                +1.0D0/6.0D0*( PR      -PL       )*RDXDY )
     &            + HY(I,J)*( HP(I+1,J)-HP(I,J) )
     &              *( 1.0D0/6.0D0*( PU      -PD       )*RDXDY )     ) )
C
C
          RMATRIX(J,1) = -R4DY*(Q(I,J)+Q(I,J-1))/DD2
     1        - DTR4DY2*G*DC2
     1               - ( 1.0D0/3.0D0+BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     2               - SAIHA
     3               + HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY/DY/6.0D0
          RMATRIX(J,1) = RMATRIX(J,1)
     &    + FDY(I,J)*( - ( 1.0D0/3.0D0+BB )*HY(I,J)*HY(I,J)*RDY2*0.5D0
     &                 + HY(I,J)*( H(I,J)-H(I,J-1) )*R4DY2/3.0D0 )
C
          RMATRIX(J,2) = 1.0D0/DT
     1      + R4DY*( (Q(I,J)+Q(I,J+1))/DU2 - (Q(I,J)+Q(I,J-1))/DD2 )
     2      + R4DX*( (P(I+1,J-1)+P(I+1,J))/DR2-(P(I,J-1)+P(I,J))/DL2)
     3        + DTR2DY2*G*DC2
     4        + ( 2.0D0/3.0D0+2.0D0*BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     5        + SATSU + SAIHA*2.0D0
          RMATRIX(J,2)= RMATRIX(J,2)
     &    + FDY(I,J)*( 0.5D0+RDY2*( 1.0D0/3.0D0+BB )*HY(I,J)*HY(I,J) )
C
          RMATRIX(J,3) = R4DY*(Q(I,J)+Q(I,J+1))/DU2
     1        - DTR4DY2*G*DC2
     2        - ( 1.0D0/3.0D0+BB )/DY/DY/DT * HY(I,J) * HY(I,J)
     3                   - SAIHA
     4                   - HY(I,J)*( H(I,J)-H(I,J-1) )/DT/DY/DY/6.0D0
          RMATRIX(J,3) = RMATRIX(J,3)
     &    + FDY(I,J)*( - ( 1.0D0/3.0D0+BB )*HY(I,J)*HY(I,J)*RDY2*0.5D0
     &                 - HY(I,J)*( H(I,J)-H(I,J-1) )*R4DY2/3.0D0 )
C
          RMATRIX(J,4) = 1.0D0/DT*Q(I,J)
     1      - R4DX*( QIP1J2*(P(I+1,J-1)+P(I+1,J))/DR2
     2               - QIM1J2*(P(I,J-1)+P(I,J))/DL2 )
     3    - G/DY*DC2*( ( EOLD(I,J)-EOLD(I,J-1) )
     4               - DTR4DY*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     5               - ( DPDX(I,J) - DPDX(I,J-1) ) )
     8               + BUN + BUN2 + BUN3 + BUN4 - SATSU*Q(I,J)
     9               + SAIHA*( Q(I,J+1)-2.0D0*Q(I,J)+Q(I,J-1) )
     1               + YNYU(I,J)*RDX2*( QIP1J2-2.0D0*Q(I,J)+QIM1J2 )
          RMATRIX(J,4) = RMATRIX(J,4)
     &    - PORO2
C
  112   CONTINUE
C
      ENDIF
C
C
        CALL  TRISOL( LDM, JJS, JJE, RMATRIX, RX )
C
C
        DO  120  J = JJS, JJE
          QOLD(I,J) = RX(J)
  120   CONTINUE
C
      RETURN
      END
C
C     -------------  SUBROUTINE WVL -----------
C
      SUBROUTINE WVL (DEP, T, AL )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      D1 = 10.0D0
      D2 = 1.0D0
      ER = 5.0D-4
C
      PAI=3.14159265D0
      G  =9.80D0                                                   
      SG =1.0D0/T*2.0D0*PAI                                            
      D  =SG*SG*DEP / G                                          
      IF ( D .GT. D1 ) THEN
        XX=D                                                            
      ELSE
        IF ( D .GE. D2 ) THEN
          X=D
        ELSE
          X= SQRT( D )
        ENDIF
    5   COTHX = 1.0D0/ TANH( X )                                           
        XX= X - ( X - D*COTHX )/(1.0D0+D*(COTHX**2-1.0D0))                    
        E = 1.0D0-XX/X                                                     
        X = XX                                                          
        IF ( ABS(E) .GE. ER ) GOTO 5
      ENDIF
      WAVE = XX                                                       
      AKH =  WAVE                                                     
      AK  =  AKH/DEP                                                 
      AL  =  PAI*2.0D0/  AK                                              
C                                                                       
      RETURN                                                          
      END                                                             
C
C     -------------  SUBROUTINE WVL_MADSEN -----------
C
      SUBROUTINE WVL_M (DEP, T, AL )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      ER = 5.0D-4
C
      PAI=3.14159265D0
      PAI2 = PAI**2
      G  =9.80D0
      B = 1.0D0 / 15.0D0
C      B = 0.0D0
C
      AL0 = SQRT(G*DEP) * T
C      AL0 = 1.56D0 * T**2
 1000 CONTINUE
        AA = SQRT(G*DEP) * T
        BB = 4.0D0 * PAI2 * (B+1.0D0/3.0D0) * DEP**2
        CC = 4.0D0 * PAI2 * B * DEP**2
        YL = AL0 - AA * SQRT((AL0**2+CC)/(AL0**2+BB))
        YDL = 1.0D0 - 1.0D0/2.0D0*AA*SQRT((AL0**2+BB)/(AL0**2+CC))
     1      * 2.0D0*AL0*(BB-CC)/(AL0**2+BB)**2
        AL = AL0 - YL / YDL
        E = 1.0D0-AL/AL0
        IF ( ABS(E) .GT. ER ) THEN
          AL0 = AL
          GOTO 1000
        ENDIF
C
      RETURN
      END
C
C     ----------------  SUBROUTINE  TRISOL  ------------
C
      SUBROUTINE  TRISOL( LDM, I1, I2, RMATRIX, RX )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   RMATRIX(LDM,4), RX(LDM)
C
      ER = 1.0D-7
C
      DO 100  I  = I1, I2-1
        RPIVOT = RMATRIX(I,2)
        IF ( ABS(RPIVOT)  .LT. ER ) THEN
          WRITE( 6, 6000 )
 6000     FORMAT ( '  VERY SMALL' )
          RETURN
        ELSE
          RMULT = RMATRIX(I+1,1)/RPIVOT
          RMATRIX(I+1,1) = RMULT
          RMATRIX(I+1,2) = RMATRIX(I+1,2) - RMULT*RMATRIX(I,3)
          RMATRIX(I+1,4) = RMATRIX(I+1,4) - RMULT*RMATRIX(I,4)
        ENDIF
  100 CONTINUE
C
      IF ( ABS(RMATRIX(I2,2))  .LT. ER ) THEN
          WRITE( 6, 6000 )
          RETURN
      ELSE
        RX(I2) = RMATRIX(I2,4) / RMATRIX(I2,2)
        DO  200  I = I2-1, I1, -1
          RX(I) = ( RMATRIX(I,4) - RMATRIX(I,3)*RX(I+1) ) / RMATRIX(I,2)
  200   CONTINUE
      ENDIF
C
C
      RETURN
      END
C
C     ------------ IRREGULAR WAVE  -------------
C
      SUBROUTINE IREGWAV_M( HZ,HH13,T13,H10,H1,SIT0,SMAX,NS,FLIMIT,IWTP)
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      include 'bsq_bsq46c8a_r1.inc'
      include 'wav_bsq46c8a_r1.inc'
C
      COMMON/ IRWAVE / AMP, AK, SITW, F, EPS
      DIMENSION        AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)
C
      DIMENSION        SF(NN), DF(NN)
C
      COMMON/ IRWAVE3 / AMP_J, AK_J, PHSJ
      DIMENSION         AMP_J(NN,JMAX), AK_J(NN,JMAX), PHSJ(NN,JMAX)
C
      DIMENSION  HZ(JMAX)
C
C      DATA  C1/ 0.205D0 /, C2/ 0.75D0 /  ! (BS-G Sf)
C      DATA  C1/ 0.257D0 /, C2/ 1.03D0 /  ! (BS Sf)
      DATA  PI/ 3.14159265D0 /, SIMIN/ -90.0D0 /, SIMAX/ 90.0D0 /
      DATA  M/ 101 /, IS1/ 100 /, IS2/ 200 /
C
C    W̐ݒ
      IF (IWTP.EQ.1) THEN
       C1 = 0.257D0
       C2 = 1.03D0
      ELSEIF(IWTP.EQ.2) THEN
       C1 = 0.205D0
       C2 = 0.75D0
      ELSEIF(IWTP.EQ.3) THEN
       WRITE(*,*) 
       WRITE(*,*)
       WRITE(*,*) 'JONSWAP^ɂẮCg쐬vO'
       WRITE(*,*) 'ɂ쐬CO͂ƂČvZsĂ'
       STOP
      ENDIF
C
      IF( H10.GT.0.0D0 )THEN
        DEP= H1
      ELSE
        JC = JMAX/2
        DEP= HZ(JC)
        IF( DEP.LE.0.0D0 )THEN
          WRITE(*,*) 'HZ(JC)<=0.0D0 \[͂Ă'
          READ(*,*) H1DMY
          DEP = H1DMY+H1
        END IF
      END IF
C
      IF ( NS .NE. 1 ) THEN
        CALL SPECTR_M
     1      ( HH13, T13, C1, C2, NS, F, SF, DF, AMP, AM0 )

        DO I = 1, NS
          T = 1.0D0 / F(I)
          CALL WVL_M( DEP, T, AL )
          AK(I)=  2.0D0 * PI / AL
        END DO
C
C        WRITE( 6, '(I5, F10.7)' ) NS, AM0
C
C        DO 150 I=1,NS
C          WRITE( 6, '(5F10.6)' )
C     1         AMP(I), AK(I), SITW(I), F(I), EPS(I)
C  150   CONTINUE
C
        CALL HFCUT( NS, F, SF, DF, AMP, AM0, FLIMIT )
C
        CALL DIRECT
     1      ( T13, SIMIN, SIMAX, SIT0, M, SITW, IS1, NS, F, SMAX )

        DO 100 I=1,NS
          EPS(I) = ARAND(IS2) * PI * 2.0D0
          T = 1.0D0 / F(I)
          DO J = 3, JMAX-2
            AMP_J(I,J) = AMP(I)
            IF( H10.GT.0.0D0 )THEN
              AK_J(I,J) = AK(I)
            ELSE
              DEP = HZ(J)
              IF( DEP.GT.0.0D0 )THEN
                CALL WVL_M( DEP, T, AL )
                AK_J(I,J) = 2.0D0 * PI / AL
              ELSE
                AK_J(I,J) = 0.0D0
              END IF
            END IF
          END DO
  100   CONTINUE

      ELSE

        CALL WVL_M( DEP, T13, AL )

        AK(1)     = 2.0D0 * PI / AL
        AMP(1)    = HH13 / 2.0D0
        SITW(1)   = SIT0 /180.0D0*PI
        F(1)      = 1.0D0 / T13
        EPS(1)    = 0.0D0
        AM0=0.0D0

        DO J = 3, JMAX-2
          AMP_J(1,J) = AMP(1)
          IF( H10.GT.0.0D0 )THEN
            AK_J(1,J) = AK(1)
          ELSE
            DEP = HZ(J)
            IF( DEP.GT.0.0D0 )THEN
              CALL WVL_M( DEP, T13, AL )
              AK_J(1,J) = 2.0D0 * PI / AL
            ELSE
              AK_J(1,J) = 0.0D0
            END IF
          END IF
        END DO

      ENDIF
C
!      WRITE( 6, '(I5, F10.7)' ) NS, AM0
!      DO 200 I=1,NS
!        WRITE( 6, '(5F10.6)' )
!     1         AMP(I), AK(I), SITW(I), F(I), EPS(I)
!  200 CONTINUE
C
      RETURN
      END
C
C     -------------  SPECTR ------------
C
      SUBROUTINE   SPECTR_M
     1   (HH13, T13, C1, C2, NS, F, SF, DF, AMP, AM0 )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      include 'wav_bsq46c8a_r1.inc'
C
      DIMENSION  F(NN), SF(NN), DF(NN), AMP(NN), FD(NN)
C
C
      RLIMIT = 30.0D0
C
      PI = 3.14159265D0
C
!      WRITE (6, *)('   SPECTR NO NAKA  FRAG *** 1')
C
      DO 1  I = 1, NS
        X= 2.0D0 * DBLE(NS) / (2.0D0 * DBLE(I) - 1.0D0 )
        Y=LOG (X)
        F(I)= C2**0.25D0 / T13 / SQRT(SQRT(Y))
    1 CONTINUE
C
!      WRITE (6, *)('   SPECTR NO NAKA  FRAG *** 2')
C
      DO 2 I=  1, NS-1
        X= 2.0D0*DBLE( NS )/(2.0D0*DBLE(I))
        Y=  LOG (X)
        FD(I)= C2**0.25D0 / T13 / SQRT(SQRT(Y))
    2 CONTINUE
      DO 3  I= 2, NS-1
        DF(I)= FD(I)- FD(I-1)
    3 CONTINUE
      DF(1)=(FD(1)-F(1)) * 2.0D0
      DF(NS)=(F(NS)- FD(NS-1))*2.0D0
      DO 4  I= 1, NS
        TF= T13* F(I)
        R= C2/ TF**4
        IF( R .GE. RLIMIT ) GO TO 5
        SF(I)= C1*HH13**2* T13/(TF**5)/ EXP( R )
        GO TO 4
    5   SF(I)=0.0D0
    4 CONTINUE
C
!      WRITE (6, *)('   SPECTR NO NAKA  AMP, SF, DF')
C
      DO 6  I=1,  NS
        AMP(I)= SQRT(2.0D0* SF(I)* DF(I))
    6 CONTINUE
      SUM = 0.0D0
      DO 7 I= 1,NS
        SUM = SUM + SF(I)* DF(I)
    7 CONTINUE
      AM0=  SUM
C
      RETURN
      END
C
C     ------------- CUT HIGH FREQUENCY ------------
C
      SUBROUTINE  HFCUT( NS, F, SF, DF, AMP, AM0, FLIMIT )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      include 'wav_bsq46c8a_r1.inc'
C
      DIMENSION  F(NN), SF(NN), DF(NN), AMP(NN)
C
      ILIMIT = NS + 1
C
      DO 1  I = 1, NS
        IF ( F(I) .GT. FLIMIT ) THEN
          ILIMIT = I
          GOTO 99
        ENDIF
    1 CONTINUE
C
      IF ( ILIMIT .EQ. NS+1 ) GOTO 999
C
   99 SFDF1 = 0.0D0
      DO 2 I =  1, ILIMIT-1
        SFDF1 = SFDF1 + SF(I) * DF(I)
    2 CONTINUE
      SFDF2 = 0.0D0
      DO 3  I = ILIMIT, NS
        SFDF2 = SFDF2 + SF(I) * DF(I)
    3 CONTINUE
C
      NS = ILIMIT -1
C
      DO 4  I = 1, NS
        SFDF = SF(I) * DF(I) * ( 1.0D0 + SFDF2 / SFDF1 )
        SF(I) = SFDF / DF(I)
        AMP(I)= SQRT( 2.0D0 * SF(I) * DF(I) )
    4 CONTINUE
C
      SUM = 0.0D0
      DO 5 I = 1, NS
        SUM = SUM + SF(I) * DF(I)
    5 CONTINUE
      AM0 =  SUM
C
  999 RETURN
      END
C
C     -------------  SUBROUTINE  DIRECT  -------------
C
      SUBROUTINE  DIRECT
     1    ( T13, SIMIN, SIMAX, SIT0, M, SITW, IS1, NS, F, SMAX )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      include 'wav_bsq46c8a_r1.inc'
C
      DIMENSION  F(NN),SP(NN), GN(NN), SITW(NN)
      DIMENSION  SITK(200), SITD(200), GD(200), G(200)
C
      S999 = 999.0D0
      S200 = 200.0D0
C
           PI = 3.14159265D0
C C           FP = 1.0D0/(1.13D0* T13 )  ! (BS-G Sf)
           FP = 1.0D0/(1.05D0* T13 )  ! (BS Sf)
           SIT00= SIT0/180.0D0* PI
           SIMAX= SIMAX / 180.0D0 * PI
           SIMIN= SIMIN /180.0D0 * PI
           DSIT = (SIMAX - SIMIN)/DBLE(M-1)
C
           IF( SMAX. EQ. S999 ) GO TO 33
C
           IF ( SMAX . GE. S200 ) GO TO 33
C
           DO 1 I= 1, NS
           IF ( F(I).LE.FP) SP(I)=SMAX *(F(I)/FP) **5
           IF ( F(I).GT.FP) SP(I)=SMAX/ (F(I)/FP) **2.5D0
    1      CONTINUE
C
           DSIT = (SIMAX-SIMIN)/(DBLE(M)-1.0D0)
           DO 2  K= 1, M
           SITK(K)=SIMIN + DBLE(K-1)* DSIT
    2      CONTINUE
C
           DO 3 I= 1,NS
             GN(I) = ARAND( IS1 )
    3      CONTINUE
C
           DO 4 I= 1, NS
             DO 5 K= 1, M
               SITD(K)= SITK(K) - SIT00
               GD(K)=COS( SITD(K)/2.0D0) **( 2.0D0* SP(I))
    5        CONTINUE
             SUM = 0.0D0
             DO 6 K= 2,M-1
              SUM = GD(K)*DSIT + SUM
    6        CONTINUE
             SUM = SUM+ ( GD(1) + GD(M)) * DSIT/2.0D0
             DO 7 K= 1,M
               G(K)  =  GD( K ) / SUM
    7        CONTINUE
C
             SUM =0.0D0
             GD(1)= 0.0D0
             DO 8 K= 2,M
               GD(K) = (G(K)+G(K-1))/2.0D0*DSIT + SUM
               SUM = GD( K)
    8        CONTINUE
C
             DO 9 K = 1,M
             IF( GN(I).GE.GD(K)) GO TO 9
               DDD = DSIT * DBLE( K-1 ) + SIMIN
               SITW(I)= (GN(I)-GD(K-1))/(GD(K)-GD(K-1))*DSIT+DDD-DSIT
               GO TO 10
    9        CONTINUE
C
   10        CONTINUE
C
    4      CONTINUE
           GO TO 44
   33      CONTINUE
             DO 331 I= 1, NS
               SITW(I)= SIT00
  331        CONTINUE
C
   44        CONTINUE
             RETURN
             END
C
C     ---------- RANSU HASSEI FUNCTION ----------
C
             FUNCTION  ARAND ( IR )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C             IMPLICIT  INTEGER * 4 (I-N)
             IMPLICIT  INTEGER (I-N)
             PARAMETER (ML= 1664501)
             PARAMETER (IA =1229, IC = 351750)
             PARAMETER  ( ANORM = 1.0D0/  ML)
                 IR= MOD (IA* IR + IC , ML )
             ARAND = IR * ANORM
             RETURN
             END
C
C
      SUBROUTINE CALCUV( IMAX, JMAX, P, Q, POLD, QOLD, EOLD,
     &      U, V, HX, HY,
     &      NSTEP, LDM, LPX1, LPXJ, LXD1, LXD2, LPY1, LPYI, LYD1, LYD2 )
C
*---  produced by T.Naruke & K.Hirayama ( 2006.06.22 )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION EOLD(IMAX,JMAX)
      DIMENSION HX(IMAX,JMAX), HY(IMAX,JMAX)
      DIMENSION P(IMAX,JMAX),  POLD(IMAX,JMAX)
      DIMENSION Q(IMAX,JMAX),  QOLD(IMAX,JMAX)
      DIMENSION U(IMAX,JMAX),  V(IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      INTEGER   LPX1,
     1          LPXJ(LDM),LXD1(LDM),LXD2(LDM)
      INTEGER   LPY1,
     1          LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
      DO 40  M = 1, LPX1
        J = LPXJ(M)
        DO 41 I = LXD1(M), LXD2(M)
          DDD =  HX(I,J)+(EOLD(I-1,J)+EOLD(I,J))/2.0D0
          if( mod(NSTEP,2) .eq. 0 )then 
            U(I,J) = P(I,J)/DDD                          ! (y-dir) U(n+1/2)
          else 
            U(I,J) = ( P(I,J)+POLD(I,J) ) / 2.0D0 / DDD  ! (x-dir) U(n)
          endif 
   41   CONTINUE
   40 CONTINUE
      DO  42  M = 1, LPY1
        I = LPYI(M)
        DO  43  J = LYD1(M), LYD2(M)
          DDD =  HY(I,J)+(EOLD(I,J-1)+EOLD(I,J))/2.0D0
          if( mod(NSTEP,2) .eq. 1 )then   ! debug 2010/12/22
            V(I,J) = Q(I,J)/DDD                          ! (x-dir) V(n)
          else 
            V(I,J) = ( Q(I,J)+QOLD(I,J) ) / 2.0D0 / DDD  ! (y-dir) V(n+1/2)
          endif 
   43   CONTINUE
   42 CONTINUE
C
      RETURN
      END
C
C
      subroutine calbrk( nstep, imax, jmax, NS
     &         , NDT, T13, dx, dy, TT, EAVG
     &         , P, Q, Pold, Qold, us, vs, prouss
     &         , anyud, bnyud, dmean, dmold, E, EOLD
     &         , h, hx, hy, XNYU, YNYU, suv
     &         , Pmax, Pmaxold, Pmin, Pminold
     &         , Qmax, Qmaxold, Qmin, Qminold
     &         , HAKOU, U, V, IBFLAG
     &         , nd
     &         , HLIMIT, EMIN, EMAX
     &         , S0, C1, RB
     &         , LDM, LPX1, LPXJ, LXD1, LXD2
     &         ,      LPY1, LPYI, LYD1, LYD2 )
C
*---  modified by T.Naruke & K.Hirayama ( 2006.06.22 )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION P(imax,jmax), Q(imax,jmax), Pold(imax,jmax)
     &     , Qold(imax,jmax), us(imax,jmax), vs(imax,jmax)
     &     , prouss(imax,jmax), EAVG(IMAX,JMAX), EOLD(IMAX,JMAX)
     &     , anyud(imax,jmax), bnyud(imax,jmax), dmean(imax,jmax)
     &     , dmold(imax,jmax), E(imax,jmax), h(imax,jmax)
     &     , hx(imax,jmax), hy(imax,jmax), XNYU(imax,jmax)
     &     , YNYU(imax,jmax), suv(imax,jmax), Pmax(imax,jmax)
     &     , Pmaxold(imax,jmax), Pmin(imax,jmax), Pminold(imax,jmax)
     &     , Qmax(imax,jmax), Qmaxold(imax,jmax), Qmin(imax,jmax)
     &     , Qminold(imax,jmax)
     &     , HAKOU(imax,jmax)
C
      DIMENSION U(IMAX,JMAX), V(IMAX,JMAX)
      INTEGER IBFLAG(imax,jmax)
C
      DIMENSION EMIN(IMAX,JMAX),  EMAX(IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      INTEGER    LPXJ(LDM),LXD1(LDM),LXD2(LDM),
     *           LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
      ZERO = 0.0D0
      HER  = 1.0D-5
      DER  = 1.0D-5
C
      g  = 9.8D0
      pi = 3.14159265D0
      sigma = 2.0D0 * pi / T13
C
      IF( NS.EQ.1 )THEN
        ADR = 2.5D0         ! for regular waves
      ELSE
        ADR = 2.5D0 * 2.0D0 ! for irregular waves
      END IF
C
      HLIM = 0.0001D0
C
C
      DO 45  M = 1, LPX1
        J = LPXJ(M)
        DO 46 I = LXD1(M), LXD2(M)
          DUDX2 = ( U(I+1,J)-2.0D0*U(I,J)+U(I-1,J) ) / DX/DX
          IF ( ( I .EQ. LXD1(M) ).OR.( I .EQ. LXD2(M) ) ) THEN
            US(I,J) = U(I,J)
          ELSE
            US(I,J) = U(I,J)                                         !(x-dir) US(n)
     1      - ( (HX(I,J)+(EOLD(I-1,J)+EOLD(I,J))/2.0D0)**2.0 / 2.0D0 !(y-dir) US(n+1/2)
     2           - HX(I,J)**2.0 / 6.0D0 ) * DUDX2
          ENDIF
   46   CONTINUE
   45 CONTINUE
      DO  47  M = 1, LPY1
        I = LPYI(M)
        DO  48  J = LYD1(M), LYD2(M)
          DVDY2 = ( V(I,J+1)-2.0D0*V(I,J)+V(I,J-1) ) / DY/DY
          IF ( ( J .EQ. LYD1(M) ).OR.( J .EQ. LYD2(M) ) ) THEN
            VS(I,J) = V(I,J)
          ELSE
            VS(I,J) = V(I,J)                                         !(x-dir) VS(n)*
     1      - ( (HY(I,J)+(EOLD(I,J-1)+EOLD(I,J))/2.0D0)**2.0 / 2.0D0 !(y-dir) VS(n+1/2)
     2           - HY(I,J)**2.0 / 6.0D0 ) * DVDY2
          ENDIF
   48   CONTINUE
   47 CONTINUE
C
C
      call chnval( imax, jmax, dmean, dmold )
      call init( imax, jmax, dmean )
C
C
      DO 100  M = 1, LPX1
        J = LPXJ(M)
        DO 101 I = LXD1(M)-1, LXD2(M)
C
            dmean(i,j) = h(i,j)+EAVG(I,J)
C
            BNYUD(I,J) = 0.0D0
C
            IF( ( (EOLD(I,J)-EAVG(I,J))*(E(I,J)-EAVG(I,J)).LT. HLIMIT )
     &       .AND. ( E(I,J) .GT. EAVG(I,J) )
     &       .AND. (( EMAX(I,J)-EMIN(I,J) ) .GT. HLIM ) )THEN
              Pminold(i,j) = Pmin(i,j)
              Pmaxold(i,j) = Pmax(i,j)
              Pmin(i,j) =  1.0D4
              Pmax(i,j) = -1.0D4
              Qminold(i,j) = Qmin(i,j)
              Qmaxold(i,j) = Qmax(i,j)
              Qmin(i,j) =  1.0D4
              Qmax(i,j) = -1.0D4
            ENDIF
C
            IF ( H(I,J) .GT. HER ) THEN
              CB = SQRT( G * dmean(i,j) )
            ELSE
              CB = 0.0D0
            ENDIF
            PU = ( US(I,J) + US(I+1,J) ) / 2.0D0      ! (x-dir) PU(n), (y-dir) PU(n+1/2)
            PV = ( VS(I,J) + VS(I,J+1) ) / 2.0D0      ! (x-dir) PV(n), (y-dir) PV(n+1/2)
            SUV(I,J) = SQRT(PU*PU+PV*PV)              !(x-dir) SUV(n),(y-dir) SUV(n+1/2)
            PROUSS(I,J) = PU*(HX(I+1,J)-HX(I,J))/DX   !(x-dir) PROUSS(n)
     1            + PV*(HY(I,J+1)-HY(I,J)) /DY        !(y-dir) PROUSS(n+1/2)
C
C            bnyud(i,j) = C1*SQRT(g*dmold(i,j))*dmold(i,j)/S0
C
C
            IF ( ( SUV(I,J) .GE. RB*CB).AND.( E(I,J) .GT. HLIMIT )
     1            .AND.( PROUSS(I,J) .LT. ZERO ) ) then
              IBFLAG(I,J) = 1
              SNYU = PROUSS(I,J) / SUV(I,J)
C
              IF ( DMOLD(I,J) .LE. DER ) DMOLD(I,J) = 0.0D0
C
              Pr = 0.135D0*SQRT(g*dmold(i,j)) * dmold(i,j)   !(x-dir) Pr(n), (y-dir) Pr(n+1/2)
              Ps = 0.4D0*(0.57D0+5.3D0*abs(snyu))            !(x-dir) Ps(n)
     &            *SQRT(g*dmold(i,j))* dmold(i,j)            !(y-dir) Ps(n+1/2)
              Phat = ( Pmaxold(i,j)-Pminold(i,j) )/2.0D0
              Qhat = ( Qmaxold(i,j)-Qminold(i,j) )/2.0D0
              ahat = SQRT(Phat**2+Qhat**2)
              if( ahat .gt. Pr )
     1          bnyud(i,j)=bnyud(i,j)+adr*abs(snyu)*g*dmold(i,j)
     2            /sigma**2*SQRT(g/dmold(i,j)*(ahat-Pr)/(Ps-Pr))
C
            ELSEIF ( ( E(I,J) .GT. HLIMIT )
     1              .AND.( PROUSS(I,J) .LT. ZERO )
     2              .AND.( IBFLAG(I,J) .EQ. 1 ) ) then
              SNYU = PROUSS(I,J) / SUV(I,J)
c
              IF ( DMOLD(I,J) .LE. DER ) DMOLD(I,J) = 0.0D0
C
              Pr = 0.135D0*SQRT(g*dmold(i,j)) * dmold(i,j)   !(x-dir) Pr(n), (y-dir) Pr(n+1/2)
              Ps = 0.4D0*(0.57D0+5.3D0*abs(snyu))            !(x-dir) Ps(n)
     &            *SQRT(g*dmold(i,j))* dmold(i,j)            !(y-dir) Ps(n+1/2)
              Phat = ( Pmaxold(i,j)-Pminold(i,j) )/2.0D0
              Qhat = ( Qmaxold(i,j)-Qminold(i,j) )/2.0D0
              ahat = SQRT(Phat**2+Qhat**2)
              if( ahat .gt. Pr )
     1          bnyud(i,j)=bnyud(i,j)+adr*abs(snyu)*g*dmold(i,j)
     2            /sigma**2*SQRT(g/dmold(i,j)*(ahat-Pr)/(Ps-Pr))
C
            ELSE
              IBFLAG(I,J) = 0
            ENDIF
c
  101   CONTINUE
  100 CONTINUE
C
C
      IF( MOD(NSTEP,2) .EQ. 1 ) THEN
        DO  630  M = 1, LPX1
          J = LPXJ(M)
          DO  631  I = LXD1(M)-1, LXD2(M)
            PC = ( P(i,j)+P(i+1,j) )/2.0D0
            if( P(i,j) .lt. Pmin(i,j) ) Pmin(i,j)=PC
            if( P(i,j) .gt. Pmax(i,j) ) Pmax(i,j)=PC
  631     CONTINUE
  630   CONTINUE
      END IF
C
      IF( MOD(NSTEP,2) .EQ. 0 ) THEN
        DO  632  M = 1, LPY1
          I = LPYI(M)
          DO  633  J = LYD1(M)-1, LYD2(M)
            QC = ( Q(i,j)+Q(i,j+1) )/2.0D0
            if( Q(i,j) .lt. Qmin(i,j) ) Qmin(i,j)=QC
            if( Q(i,j) .gt. Qmax(i,j) ) Qmax(i,j)=QC
  633     CONTINUE
  632   CONTINUE
      END IF
C
C
      call init(imax,jmax,anyud)
C
C
      DO 500  M = 1, LPX1
        J = LPXJ(M)
        DO 501 I = LXD1(M)-1, LXD2(M)
            IF ( H(I,J) .GT. HER ) THEN
              CB = SQRT( G * dmold(i,j) )
            ELSE
              CB = 0.0D0
            ENDIF
            if ( BNYUD(I,J) .GT. ZERO ) then
c
            if(i.eq.lxd1(m)-1)
     +      write(*,'(a15,i10,3i5)')
     +      ' calbrk  nstep=',nstep, lxd1(m)-1, lxd2(m), j
c
              nb = cb*T13/dx+0.5D0
              do 510 jj = -nb,nb
                do 511 ii = -nb,nb
                  rnyu = SQRT(DBLE(ii*ii+jj*jj))
                  if( rnyu .lt. DBLE(nb) ) then
                    YU = (1.-rnyu/DBLE(nb))*bnyud(i,j)
                    III = i+ii
                    JJJ = j+jj
                    IF( ((III.lt.IS).or.(III.gt.IE)).or.
     &                  ((JJJ.lt.JS).or.(JJJ.gt.JE)) ) goto 511 
                    IF( H(III,JJJ).le.HLIMIT ) goto 511
                    if (YU.gt.anyud(III,JJJ)) then
                       anyud(III,JJJ)=YU
                    endif
                  endif
  511           CONTINUE
  510         CONTINUE
            endif
  501   CONTINUE
  500 CONTINUE
C
      if(mod(nstep,2).eq.0)then
        DO 300  M = 1, LPX1
          J = LPXJ(M)
          DO 301 I = LXD1(M), LXD2(M)
            IF ( I .GE. I0+3 ) THEN
              IF ( I .EQ. LXD1(M) ) THEN
                XNYU(i,j) = ANYUD(i,j)
              ELSEIF ( I .EQ. LXD2(M) ) THEN
                XNYU(i,j) = ANYUD(i-1,j)
              ELSE
               XNYU(i,j) = (ANYUD(i-1,j)+ANYUD(i,j))/2.0D0
              ENDIF
            ENDIF
  301     CONTINUE
  300   CONTINUE
      end if
c
      if(mod(nstep,2).eq.1)then
        DO  302  M = 1, LPY1
          I = LPYI(M)
          DO  303  J = LYD1(M), LYD2(M)
            IF ( I .GE. I0+3 ) THEN
              IF ( J .EQ. LYD1(M) ) THEN
                YNYU(i,j) = ANYUD(i,j)
              ELSEIF ( J .EQ. LYD2(M) ) THEN
                YNYU(i,j) = ANYUD(i,j-1)
              ELSE
                YNYU(i,j) = (ANYUD(i,j-1)+ANYUD(i,j))/2.0D0
              ENDIF
            ENDIF
  303     CONTINUE
  302   CONTINUE
      end if
C
      return
      end
C
C
      SUBROUTINE CALHAKOU ( IMAX, JMAX,
     &   E, EOLD, EMIN, EMAX, HAKOU, HLIMIT, H, HX, HY, P, Q,
     &   SUMCWX, SUMCWY, CWX, CWY, SYUKI, SUMSYUKI,
     &   EAVG, UAVG, VAVG, POLD, QOLD,
     &   NZST, NDIRC, NSTEP, NDT, NWAVE, SUMWAVE, NTSVE )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   H(IMAX,JMAX), HX(IMAX,JMAX), HY(IMAX,JMAX)
      DIMENSION   P(IMAX,JMAX), Q(IMAX,JMAX)
      DIMENSION   POLD(IMAX,JMAX), QOLD(IMAX,JMAX)
C
      DIMENSION   E(IMAX,JMAX), EOLD(IMAX,JMAX)
      DIMENSION   EMIN(IMAX,JMAX),  EMAX(IMAX,JMAX)
      DIMENSION   HAKOU(IMAX,JMAX), EAVG(IMAX,JMAX)
      DIMENSION   UAVG(IMAX,JMAX), VAVG(IMAX,JMAX)
      DIMENSION   SUMWAVE(IMAX,JMAX)
      DIMENSION   NWAVE(IMAX,JMAX)
C
      DIMENSION   SUMCWX(IMAX,JMAX), SUMCWY(IMAX,JMAX)
      DIMENSION   CWX(IMAX,JMAX), CWY(IMAX,JMAX)
      DIMENSION   SYUKI(IMAX,JMAX),SUMSYUKI(IMAX,JMAX)
      DIMENSION   NZST(IMAX,JMAX), NDIRC(IMAX,JMAX)
C
C
      G = 9.8D0
      PI = 3.14159265D0
C
      DLMT = 0.0001D0
      HLIM = 0.0001D0
      REMX = 7.0D0/3.0D0
C
C
      DO 10 J = 1, JMAX
        DO 11 I = 1, IMAX
C
          DDD  = H(I,J)+( EOLD(I,J)-EAVG(I,J) )
          IF( DDD.GE.DLMT )THEN
            CMAX = SQRT( G*DDD )
          ELSE
            CMAX = 0.0D0
          END IF
C
          IF( ( (EOLD(I,J)-EAVG(I,J))*(E(I,J)-EAVG(I,J)).LT. HLIMIT )
     &       .AND. ( E(I,J) .GT. EAVG(I,J) )
     &       .AND. (( EMAX(I,J)-EMIN(I,J) ) .GT. HLIM ) )THEN
            IF( NSTEP.GE.NTSVE )THEN
              NWAVE(I,J)=NWAVE(I,J)+1
              SUMWAVE(I,J) = SUMWAVE(I,J)+ ( EMAX(I,J)-EMIN(I,J) )
              SUMSYUKI(I,J)= SUMSYUKI(I,J) + DBLE(NSTEP-NZST(I,J))
              HAKOU(I,J)   = SUMWAVE(I,J) /DBLE(NWAVE(I,J))
              SYUKI(I,J)   = SUMSYUKI(I,J)/DBLE(NWAVE(I,J))
              NZST(I,J) = NSTEP
              CWV2= CWX(I,J)**2+CWY(I,J)**2
              IF( CWV2.GT.0.0D0 )THEN
                CCC = SQRT(CWV2)
              ELSE
                CCC = 999.0D0
              END IF
              IF( ABS(EMIN(I,J)-EAVG(I,J)).GE.HLIM )THEN
                RE = ABS( (EMAX(I,J)-EAVG(I,J))/(EMIN(I,J)-EAVG(I,J)) )
              ELSE
                RE = 999.0D0
              END IF
CCCCCC              IF( (CCC.LE.CMAX).AND.(RE.LE.REMX) )THEN
              IF( CCC.LE.CMAX )THEN
                NDIRC(I,J)  = NDIRC(I,J)+1
                SUMCWX(I,J) = SUMCWX(I,J) + CWX(I,J)
                SUMCWY(I,J) = SUMCWY(I,J) + CWY(I,J)
              END IF
            ELSE
              SUMWAVE(I,J) = 0.0D0
              SUMSYUKI(I,J)= 0.0D0
                HAKOU(I,J) = 0.0D0
                SYUKI(I,J) = 0.0D0
              NZST(I,J)    = NSTEP
              SUMCWX(I,J)  = 0.0D0
              SUMCWY(I,J)  = 0.0D0
            END IF
            EMIN(I,J) = EAVG(I,J)
            EMAX(I,J) = EAVG(I,J)
          ENDIF
C
          IF( E(I,J) .LT. EMIN(I,J) ) EMIN(I,J)=E(I,J)
CCCCCC          IF( E(I,J) .GT. EMAX(I,J) ) EMAX(I,J)=E(I,J)
          IF( E(I,J) .GT. EMAX(I,J) )THEN
            EMAX(I,J)=E(I,J)
            IF( ABS(E(I,J)-EAVG(I,J)).GE.HLIM/2.0D0 )THEN
              DDX0 = HX(I  ,J)+( E(I-1,J)+E(I,J) )*0.5D0
              DDX1 = HX(I+1,J)+( E(I,J)+E(I+1,J) )*0.5D0
              DDY0 = HY(I,J  )+( E(I,J-1)+E(I,J) )*0.5D0
              DDY1 = HY(I,J+1)+( E(I,J)+E(I,J+1) )*0.5D0
              IF( ((DDX0.GE.DLMT).AND.(DDX1.GE.DLMT)).AND.
     &            ((DDY0.GE.DLMT).AND.(DDY1.GE.DLMT)) )THEN
                DOLD = H(I,J) + (EOLD(I,J)-EAVG(I,J))
                IF( MOD(NSTEP,2).EQ.1 )THEN
                  CWX(I,J) = ( P(I,J)+P(I+1,J)+POLD(I,J)+POLD(I+1,J)
     &                        -2.0D0*( UAVG(I,J)+UAVG(I+1,J) )*DOLD )
     &                       *0.25D0/( EOLD(I,J)-EAVG(I,J) )
                  CWY(I,J) = ( Q(I,J)+Q(I,J+1)
     &                        -( VAVG(I,J)+VAVG(I,J+1) )*DOLD )
     &                       *0.50D0/( EOLD(I,J)-EAVG(I,J) )
                ELSE IF( MOD(NSTEP,2).EQ.0 )THEN
                  CWX(I,J) = ( P(I,J)+P(I+1,J)
     &                        -( UAVG(I,J)+UAVG(I+1,J) )*DOLD )
     &                       *0.50D0/( EOLD(I,J)-EAVG(I,J) )
                  CWY(I,J) = ( Q(I,J)+Q(I,J+1)+QOLD(I,J)+QOLD(I,J+1)
     &                        -2.0D0*( VAVG(I,J)+VAVG(I,J+1) )*DOLD )
     &                       *0.25D0/( EOLD(I,J)-EAVG(I,J) )
                END IF
              ELSE
                CWX(I,J) = 0.0D0
                CWY(I,J) = 0.0D0
              END IF
            ELSE
              CWX(I,J) = 0.0D0
              CWY(I,J) = 0.0D0
            END IF
          END IF
C
   11   CONTINUE
   10 CONTINUE
C
C
      RETURN
      END
C
C
      subroutine init( imax, jmax, a ) 
c
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C      implicit    none
      integer   imax, jmax, i, j
      DIMENSION         a(imax,jmax)
c
      do  10  j = 1 , jmax
      do  11  i = 1 , imax
          a(i,j) = 0.0D0
  11  continue
  10  continue
c
      return
      end
C
      subroutine chnval( imax, jmax, ANOW, AOLD )
c
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C      implicit    none
      integer   imax, jmax, i, j
      DIMENSION      ANOW(imax,jmax), AOLD(imax,jmax)
c
      do  10  j = 1 , jmax
      do  11  i = 1 , imax
         AOLD(i,j) = ANOW(i,j)
  11  continue
  10  continue
c
      return
      end
C
C
      SUBROUTINE  AFLVCSX( IMAX, JMAX, P, PIN, PTMP, HX, HLIMIT,
     &                     LDM, LPX1, LPXJ, LXD1, LXD2 )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   P(IMAX,JMAX), PTMP(IMAX,JMAX), HX(IMAX,JMAX)
      DIMENSION   PIN(IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      INTEGER   LPX1,
     1          LPXJ(LDM),LXD1(LDM),LXD2(LDM)
C
      BLMT = 0.01D0
      EPS  = 0.00001D0
C
      DO 110 M=1, LPX1
        J = LPXJ(M)
C C        IF( (LXD2(M)-LXD1(M)).GE.2 )THEN
C C        DO 111 I = LXD1(M)+1, LXD2(M)-1
        DO 111 I = LXD1(M), LXD2(M)
          PIJP12  = P(I,J+1)
          PIJM12  = P(I,J-1)
          IF( HX(I,J+1).LE.HLIMIT ) PIJP12 = P(I,J)
          IF( HX(I,J-1).LE.HLIMIT ) PIJM12 = P(I,J)
          IF( I.EQ.I0-1  )THEN
            PIP1J = P(I+1,J)-PIN(I+1,J)
            BBI = ABS( P(I-1,J)+2.0D0*P(I,J)+PIP1J )
            IF( BBI.GT.BLMT )THEN
              EKI = EPS * ABS( P(I-1,J)-2.0D0*P(I,J)+PIP1J )/BBI
            ELSE
              EKI = 0.0D0
            END IF
            BBJ = ABS(   PIJM12+2.0D0*P(I,J)+PIJP12   )
            IF( BBJ.GT.BLMT )THEN
              EKJ = EPS * ABS(   PIJM12-2.0D0*P(I,J)+PIJP12   )/BBJ
            ELSE
              EKJ = 0.0D0
            END IF
            PTMP(I,J) = P(I,J)
     +                + EKI * ( P(I-1,J)-2.0D0*P(I,J)+PIP1J )
     +                + EKJ * (   PIJM12-2.0D0*P(I,J)+PIJP12   )
          ELSE IF( I.EQ.I0  )THEN
            PIM1J = P(I-1,J)+PIN(I0-1,J)
            BBI = ABS( PIM1J+2.0D0*P(I,J)+P(I+1,J) )
            IF( BBI.GT.BLMT )THEN
              EKI = EPS * ABS( PIM1J-2.0D0*P(I,J)+P(I+1,J) )/BBI
            ELSE
              EKI = 0.0D0
            END IF
            BBJ = ABS(   PIJM12+2.0D0*P(I,J)+PIJP12   )
            IF( BBJ.GT.BLMT )THEN
              EKJ = EPS * ABS(   PIJM12-2.0D0*P(I,J)+PIJP12   )/BBJ
            ELSE
              EKJ = 0.0D0
            END IF
            PTMP(I,J) = P(I,J)
     +                + EKI * ( PIM1J-2.0D0*P(I,J)+P(I+1,J) )
     +                + EKJ * (   PIJM12-2.0D0*P(I,J)+PIJP12   )
          ELSE
            BBI = ABS( P(I-1,J)+2.0D0*P(I,J)+P(I+1,J) )
            IF( BBI.GT.BLMT )THEN
              EKI = EPS * ABS( P(I-1,J)-2.0D0*P(I,J)+P(I+1,J) )/BBI
            ELSE
              EKI = 0.0D0
            END IF
            BBJ = ABS(   PIJM12+2.0D0*P(I,J)+PIJP12   )
            IF( BBJ.GT.BLMT )THEN
              EKJ = EPS * ABS(   PIJM12-2.0D0*P(I,J)+PIJP12   )/BBJ
            ELSE
              EKJ = 0.0D0
            END IF
            PTMP(I,J) = P(I,J)
     +                + EKI * ( P(I-1,J)-2.0D0*P(I,J)+P(I+1,J) )
     +                + EKJ * (   PIJM12-2.0D0*P(I,J)+PIJP12   )
          END IF
  111   CONTINUE
C C        PTMP(LXD1(M),J) = P(LXD1(M),J)
C C        PTMP(LXD2(M),J) = P(LXD2(M),J)
C C        ELSE
C C        DO 112 I = LXD1(M), LXD2(M)
C C          PTMP(I,J) = P(I,J)
C C  112   CONTINUE
C C        END IF
  110 CONTINUE
C
      DO 120 M=1, LPX1
        J = LPXJ(M)
        DO 121 I = LXD1(M), LXD2(M)
          P(I,J) = PTMP(I,J)
  121   CONTINUE
  120 CONTINUE
C
      RETURN
      END
C
C
      SUBROUTINE  AFLVCSY( IMAX, JMAX, Q, QIN, QTMP, HY, HLIMIT,
     &                     LDM, LPY1, LPYI, LYD1, LYD2 )
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
      DIMENSION   Q(IMAX,JMAX), QTMP(IMAX,JMAX), HY(IMAX,JMAX)
      DIMENSION   QIN(IMAX,JMAX)
C
      COMMON    / RYOIKI / IS, I0, I1, IE, JS, J0, J1, JE
      INTEGER              IS, I0, I1, IE, JS, J0, J1, JE
C
      INTEGER   LPY1,
     1          LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
      BLMT = 0.01D0
      EPS  = 0.00001D0
C
      DO 110 M=1, LPY1
        I = LPYI(M)
        IF( I.EQ.I0-1 )THEN
C C          IF( (LYD2(M)-LYD1(M)).GE.2 )THEN
C C          DO 112 J = LYD1(M)+1, LYD2(M)-1
          DO 112 J = LYD1(M), LYD2(M)
            QIP1J2  = Q(I+1,J) - QIN(I0,J)
            QIM1J2  = Q(I-1,J)
            IF( HY(I+1,J).LE.HLIMIT ) QIP1J2 = Q(I,J)
            IF( HY(I-1,J).LE.HLIMIT ) QIM1J2 = Q(I,J)
            BBJ = ABS( Q(I,J-1)+2.0D0*Q(I,J)+Q(I,J+1) )
            IF( BBJ.GT.BLMT )THEN
              EKJ = EPS * ABS( Q(I,J-1)-2.0D0*Q(I,J)+Q(I,J+1) )/BBJ
            ELSE
              EKJ = 0.0D0
            END IF
            BBI = ABS(   QIM1J2+2.0D0*Q(I,J)+QIP1J2   )
            IF( BBI.GT.BLMT )THEN
              EKI = EPS * ABS(   QIM1J2-2.0D0*Q(I,J)+QIP1J2   )/BBI
            ELSE
              EKI = 0.0D0
            END IF
            QTMP(I,J) = Q(I,J)
     +                + EKJ * ( Q(I,J-1)-2.0D0*Q(I,J)+Q(I,J+1) )
     +                + EKI * (   QIM1J2-2.0D0*Q(I,J)+QIP1J2   )
  112     CONTINUE
C C          QTMP(I,LYD1(M)) = Q(I,LYD1(M))
C C          QTMP(I,LYD2(M)) = Q(I,LYD2(M))
C C          ELSE
C C          DO 122 J = LYD1(M), LYD2(M)
C C            QTMP(I,J) = Q(I,J)
C C  122     CONTINUE
C C          END IF
        ELSE IF( I.EQ.I0 )THEN
C C          IF( (LYD2(M)-LYD1(M)).GE.2 )THEN
C C          DO 113 J = LYD1(M)+1, LYD2(M)-1
          DO 113 J = LYD1(M), LYD2(M)
            QIP1J2  = Q(I+1,J)
            QIM1J2  = Q(I-1,J) + QIN(I0-1,J)
            IF( HY(I+1,J).LE.HLIMIT ) QIP1J2 = Q(I,J)
            IF( HY(I-1,J).LE.HLIMIT ) QIM1J2 = Q(I,J)
            BBJ = ABS( Q(I,J-1)+2.0D0*Q(I,J)+Q(I,J+1) )
            IF( BBJ.GT.BLMT )THEN
              EKJ = EPS * ABS( Q(I,J-1)-2.0D0*Q(I,J)+Q(I,J+1) )/BBJ
            ELSE
              EKJ = 0.0D0
            END IF
            BBI = ABS(   QIM1J2+2.0D0*Q(I,J)+QIP1J2   )
            IF( BBI.GT.BLMT )THEN
              EKI = EPS * ABS(   QIM1J2-2.0D0*Q(I,J)+QIP1J2   )/BBI
            ELSE
              EKI = 0.0D0
            END IF
            QTMP(I,J) = Q(I,J)
     +                + EKJ * ( Q(I,J-1)-2.0D0*Q(I,J)+Q(I,J+1) )
     +                + EKI * (   QIM1J2-2.0D0*Q(I,J)+QIP1J2   )
  113     CONTINUE
C C          QTMP(I,LYD1(M)) = Q(I,LYD1(M))
C C          QTMP(I,LYD2(M)) = Q(I,LYD2(M))
C C          ELSE
C C          DO 123 J = LYD1(M), LYD2(M)
C C            QTMP(I,J) = Q(I,J)
C C  123     CONTINUE
C C          END IF
        ELSE
C C          IF( (LYD2(M)-LYD1(M)).GE.2 )THEN
C C          DO 111 J = LYD1(M)+1, LYD2(M)-1
          DO 111 J = LYD1(M), LYD2(M)
            QIP1J2  = Q(I+1,J)
            QIM1J2  = Q(I-1,J)
            IF( HY(I+1,J).LE.HLIMIT ) QIP1J2 = Q(I,J)
            IF( HY(I-1,J).LE.HLIMIT ) QIM1J2 = Q(I,J)
            BBJ = ABS( Q(I,J-1)+2.0D0*Q(I,J)+Q(I,J+1) )
            IF( BBJ.GT.BLMT )THEN
              EKJ = EPS * ABS( Q(I,J-1)-2.0D0*Q(I,J)+Q(I,J+1) )/BBJ
            ELSE
              EKJ = 0.0D0
            END IF
            BBI = ABS(   QIM1J2+2.0D0*Q(I,J)+QIP1J2   )
            IF( BBI.GT.BLMT )THEN
              EKI = EPS * ABS(   QIM1J2-2.0D0*Q(I,J)+QIP1J2   )/BBI
            ELSE
              EKI = 0.0D0
            END IF
            QTMP(I,J) = Q(I,J)
     +                + EKJ * ( Q(I,J-1)-2.0D0*Q(I,J)+Q(I,J+1) )
     +                + EKI * (   QIM1J2-2.0D0*Q(I,J)+QIP1J2   )
  111     CONTINUE
C C          QTMP(I,LYD1(M)) = Q(I,LYD1(M))
C C          QTMP(I,LYD2(M)) = Q(I,LYD2(M))
C C          ELSE
C C          DO 121 J = LYD1(M), LYD2(M)
C C            QTMP(I,J) = Q(I,J)
C C  121     CONTINUE
C C          END IF
        END IF
  110 CONTINUE
C
      DO 120 M=1, LPY1
        I = LPYI(M)
        DO 121 J = LYD1(M), LYD2(M)
          Q(I,J) = QTMP(I,J)
  121   CONTINUE
  120 CONTINUE
C
      RETURN
      END
C
C
      SUBROUTINE  BDCALX2D( IMAX, JMAX, H, E, HLIMIT,
     1                      LDM, LPX1, LPXJ, LXD1, LXD2 )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C
C     DEFINITION OF X-DIRECTION CALCULATION LINE
C
      DIMENSION  H(IMAX,JMAX), E(IMAX,JMAX)
      INTEGER    LPX1,
     1           LPXJ(LDM),LXD1(LDM),LXD2(LDM)
C
C
      LPX1=0
C
C ** CALCULATION LINE FOR THETA POINT
C        NOW : FLAG FOR CALCULATION POINT OF THE MESH
C        MAE : FLAG FOR CALCULATION POINT OF THE ONE MESH BEFORE
C
C      WRITE(6,'(6HCHECK ,I3)') 111
C
C
      DO 10 J=2,JMAX-1
        MAE=0
        DO 11 I=2,IMAX
C
          DIM1J2 = H(I-1,J)+E(I-1,J)
          DIJ2   = H(I  ,J)+E(I  ,J)
          IF( (DIM1J2.GT. HLIMIT ).AND.(DIJ2.GT. HLIMIT ) ) THEN
            NOW=1
          ELSE
            NOW=0
          END IF
C
          IF( MAE.EQ.0 ) THEN
            IF( NOW.EQ.1 ) THEN
              LPX1 = LPX1 + 1
C
C      WRITE(6,'(6HCHECK ,3I3)') I, J, LPX1
C
              IF(LPX1.GT.LDM) GO TO 9001
              LPXJ(LPX1)=J
              LXD1(LPX1)=I
            ENDIF
          ELSE IF( NOW.EQ.0 ) THEN
            LXD2(LPX1)=I-1
          ENDIF
C
          MAE=NOW
C
   11   CONTINUE
   10 CONTINUE
C
C      WRITE(6,'(6HCHECK ,I3)') 112
C
      IF( LPX1.EQ.0 )THEN
        WRITE(*,*) '** KEISANSEN GA NAI (BDCALX) **'
        GO TO 9999
      END IF
C
      RETURN
C
 9001 WRITE(6,9010) LPX1
 9010 FORMAT('** KEISANSEN NO KAZU GA TARINAI (BDCALX) **',I10)
C
 9999 CONTINUE
      STOP
      END
C
C
      SUBROUTINE  BDCALY2D( IMAX, JMAX, H, E, HLIMIT,
     1                      LDM, LPY1, LPYI, LYD1, LYD2 )
C
C
      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )
C
C     DEFINITION OF Y-DIRECTION CALCULATION LINE
C
      DIMENSION  H(IMAX,JMAX), E(IMAX,JMAX)
      INTEGER    LPY1,
     1           LPYI(LDM),LYD1(LDM),LYD2(LDM)
C
C
      LPY1=0
C
C ** CALCULATION LINE FOR THETA POINT
C        NOW : FLAG FOR CALCULATION POINT OF THE MESH
C        MAE : FLAG FOR CALCULATION POINT OF THE ONE MESH BEFORE
C
C
      DO 10 I=2,IMAX-1
        MAE=0
        DO 11 J=2,JMAX
C
          DIJM12 = H(I,J-1)+E(I,J-1)
          DIJ2   = H(I,J  )+E(I,J  )
          IF ( (DIJM12.GT. HLIMIT ).AND.(DIJ2.GT. HLIMIT ) ) THEN
            NOW=1
          ELSE
            NOW=0
          END IF
C
          IF( MAE.EQ.0 ) THEN
            IF( NOW.EQ.1 ) THEN
              LPY1=LPY1+1
              IF(LPY1.GT.LDM) GO TO 9001
              LPYI(LPY1)=I
              LYD1(LPY1)=J
            ENDIF
          ELSE IF( NOW.EQ.0 ) THEN
            LYD2(LPY1)=J-1
          ENDIF
C
          MAE=NOW
C
   11   CONTINUE
   10 CONTINUE
C
      IF( LPY1.EQ.0 )THEN
        WRITE(*,*) '** KEISANSEN GA NAI (BDCALY) **'
        GO TO 9999
      END IF
C
      RETURN
C
 9001 WRITE(6,9010) LPY1
 9010 FORMAT('** KEISANSEN NO KAZU GA TARINAI (BDCALY) **',I10)
C
 9999 CONTINUE
      STOP
      END

C**********************************************************************
      subroutine readcalcnd
     &           (IMAX, JMAX, 
     &            HH13, T13, SIT0, SMAX, NS, WL, H10, HLIMIT2,
     &            IBRK, RB, HLIMIT3,
     &            DT, TDEL, TOUT, TTIN, TSVE, TEND, 
     &            KAISU, IWTP, FLIMIT ,FF1, FF2, FFHLM)
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      
cccccc      OPEN(91, FILE = 'calcnd',STATUS='OLD')   ! Rg[t@CI[v
      
      READ(91,'(3F10.0)'     ) HH13, T13, SIT0
      READ(91,'(I10,2F10.0)' ) NS, SMAX, TLIMIT
      READ(91,'(3F10.0)'     ) WL, H10, HLIMIT2
      READ(91,'(I10,2F10.0)' ) IBRK, RB, HLIMIT3
      READ(91,'(3F10.0)'     ) FF1, FF2, FFHLM
      READ(91,'(3F10.0)'     ) DT, TDEL, TOUT
      READ(91,'(3F10.0)'     ) TTIN, TSVE, TEND
      READ(91,'(2I10)'       ) KAISU, IWTP
      

! TLIMITFLIMITɕϊ
      FLIMIT = 1.0d0 / TLIMIT
      
      IF(TOUT <= 0.0D0) TOUT = TEND            ! TOUT0.0ȉݒ肵ꍇCo͂TEND݂̂Ƃ
      
C----Check Value

      IF(NS > 1000) THEN
       WRITE(*,*) 'NS<1000'
       STOP
      ENDIF
      
      IF(WL < 0.0D0) THEN
       WRITE(*,*) 'CHECK WL'
       STOP
      ENDIF

      IF(H10 <= 0.0D0) THEN
       WRITE(*,*) '(H1=0̂ƂCgE̎[pđg܂)'
       WRITE(*,*)
       IF( H10 < 0.0D0 )THEN
         WRITE(*,*) 'CHECK H1<0'
         STOP
       ENDIF
      ENDIF

      IF(HLIMIT2 <= 0.0D0) THEN
       WRITE(*,*) 'CHECK HLIMIT2'
       STOP
      ENDIF

      IF(DT <= 0.0D0) THEN
       WRITE(*,*) 'CHECK DT'
       STOP
      ENDIF
      
      IF(IWTP <= 0 ) THEN
       WRITE(*,*) 'CHECK IWTP'
       STOP
      ENDIF
      
      IF(KAISU < 0) THEN
       WRITE(*,*) 'CHECK KAISU'
       STOP
      ENDIF
      
      IF(TOUT > TEND) THEN
       WRITE(*,*) 'CHECK TOUT'
       STOP
      ENDIF
      
      WRITE(*,103)  HH13,T13,SIT0,SMAX,TLIMIT
      WRITE(*,104)  NS
      WRITE(*,105)  WL,H10,HLIMIT2
      WRITE(*,110)  IBRK,RB,HLIMIT3
      WRITE(*,109)  FF1, FF2, FFHLM
      WRITE(*,106)  DT,TDEL,TOUT
      WRITE(*,107)  TTIN,TSVE,TEND
      WRITE(*,108)  KAISU,IWTP

 100  FORMAT(2x,'IS =',I5,2X,'I0 =',I5,2X,'I1 =',I5,2X,'IE =',I5)
 101  FORMAT(2x,'JS =',I5,2X,'J0 =',I5,2X,'J1 =',I5,2X,'JE =',I5)
 102  FORMAT(2x,'DX =',F5.1)
 103  FORMAT(2x,'H13 =',F5.2,'s',2X,'T13 =',F5.2,'s',2X,
     +       ' =',F5.2,2X,
     +       'Smax =',F7.1,2x,'TLIMIT=',F5.2,'s')
 104  FORMAT(2x,'NS =',I7)
 105  FORMAT(2x,'WL =',F7.3,2X,'H1 =',F8.2,2X,'HLIMIT2 =',F8.3)
 106  FORMAT(2x,'DT =',F7.3,2X,'TDEL =',F7.3,2X,'TOUT =',F10.2)
 107  FORMAT(2x,'TTIN =',F8.2,2X,'TSVE =',F8.2,2X,'TEND =',F8.2)
 108  FORMAT(2x,'KAISU =',I5,2X,'IWTP =',I5)
 109  FORMAT(2x,'FF1 =',F7.3,2X,'FF2 =',F8.2,2X,'FFHLM =',F8.3)
 110  FORMAT(2x,'IBRK =',I5,2X,'RB =',F7.3,2X,'HLIMIT3 =',F8.3)

cccccc      CLOSE(91)

      RETURN
      END

C**********************************************************************
C  gt@C̓ǂݍ

      SUBROUTINE READSPECTIN( NRP,HZ,H10,H1,NS,IWTP,GAMMA )

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      include 'bsq_bsq46c8a_r1.inc'
      include 'wav_bsq46c8a_r1.inc'

      COMMON/ IRWAVE / AMP, AK, SITW, F, EPS
      DIMENSION        AMP(NN), AK(NN), SITW(NN), F(NN), EPS(NN)

      COMMON/ IRWAVE2 / AMP_P, AK_P
      DIMENSION         AMP_P(NN,JMAX), AK_P(NN,JMAX)

      COMMON/ IRWAVE3 / AMP_J, AK_J, PHSJ
      DIMENSION         AMP_J(NN,JMAX), AK_J(NN,JMAX), PHSJ(NN,JMAX)

      DIMENSION   AMPAVG(NN), AKAVG(NN)

      DIMENSION   HZ(JMAX)

      INTEGER  JRP(JMAX)

      DIMENSION   AMPMIN(NN), AKMIN(NN)

      PI = 3.14159265D0


      IF( H10.GT.0.0D0 )THEN
        DEP= H1
      ELSE
        JC = JMAX/2
        DEP= HZ(JC)
        IF( DEP.LE.0.0D0 )THEN
          WRITE(*,*) 'HZ(JC)<=0.0D0 \[͂Ă'
          READ(*,*) H1DMY
          DEP = H1DMY+H1
        END IF
      END IF

      OPEN(92,FILE='spectdat.in',STATUS='OLD',ERR=100)

      READ(92,'(I5)',ERR=101) NRP

      IF( NRP.GT.1 )THEN

        DO NP = 1, NRP
          READ(92,'(2I5,F10.0,I5)',ERR=101) NS,IWTP,GAMMA,JRP(NP)
          WRITE(*,'(2I5,F10.0,I5)',ERR=101) NS,IWTP,GAMMA,JRP(NP)
          DO I = 1, NS
            READ(92,'(4E15.6)',ERR=101) F(I),AMP_P(I,NP),SITW(I),EPS(I)
cccccc            WRITE(*,'(4E15.6)',ERR=101) F(I),AMP_P(I,NP),SITW(I),EPS(I)
              T = 1.0D0 / F(I)
              DEPP = HZ(JRP(NP))
                IF( DEPP.LE.0.0D0 )THEN
                  WRITE(*,'(2I5,F10.4,A18)') NP,JRP(NP),HZ(JRP(NP)),
     &                   'HZ(JRP(NP))<=0.0D0'
                  WRITE(*,*) 'oWmFĂ'
                  STOP
                END IF
              CALL WVL_M( DEPP, T, AL )
            AK_P(I,NP) =  2.0D0 * PI / AL
          ENDDO
        ENDDO

        DO I = 1, NS
        AMPAVG(I) = 0.0D0
         AKAVG(I) = 0.0D0
          DO NP = 1, NRP
            AMPAVG(I) = AMPAVG(I) + AMP_P(I,NP)*AMP_P(I,NP)
             AKAVG(I) =  AKAVG(I) +  AK_P(I,NP)
          END DO
          IF( AMPAVG(I).GT.0.0D0 )THEN
            AMP(I) = SQRT( AMPAVG(I) )/DBLE(NRP)
          ELSE
            AMP(I) = 0.0D0
          END IF
          AK(I) = AKAVG(I)/DBLE(NRP)
        END DO

      ELSE IF( NRP.LT.1 )THEN

        WRITE(*,*) '̓XyNg[ȉ (NRP < 1)'
        STOP

      ELSE

        READ(92,'(2I5,F10.0)',ERR=101) NS,IWTP,GAMMA
        WRITE(*,'(2I5,F10.0)',ERR=101) NS,IWTP,GAMMA
        DO I = 1, NS
          READ(92,'(4E15.6)',ERR=101) F(I), AMP(I), SITW(I), EPS(I)
cccccc          WRITE(*,'(4E15.6)',ERR=101) F(I), AMP(I), SITW(I), EPS(I)
            T = 1.0D0 / F(I)
            CALL WVL_M( DEP, T, AL )
          AK(I)  =  2.0D0 * PI / AL
        END DO

      END IF

      CLOSE(92)

      IF( NRP.GT.1 )THEN

C *** ёւi: JRPj*********************************************

        DO 200 NP = 1, NRP-1
          JRPMIN = JRP(NP)
          DO I = 1, NS
            AMPMIN(I) = AMP_P(I,NP)
             AKMIN(I) =  AK_P(I,NP)
          END DO
          NPMIN = NP
          DO 210 MP=NP+1,NRP
            IF( JRP(MP).LT.JRPMIN )THEN
              DO I = 1, NS
                AMPMIN(I) = AMP_P(I,MP)
                 AKMIN(I) =  AK_P(I,MP)
              END DO
              NPMIN = MP
C *** DEBUG 2019/10/27 *******
              JRPMIN = JRP(MP)
C ****************************
            END IF
  210     CONTINUE
          IF( NPMIN.NE.NP )THEN
            JRP(NPMIN) = JRP(NP)
            JRP(NP)    = JRPMIN
            DO I = 1, NS
              AMP_P(I,NPMIN) = AMP_P(I,NP)
              AMP_P(I,NP)    = AMPMIN(I)
               AK_P(I,NPMIN) =  AK_P(I,NP)
               AK_P(I,NP)    =  AKMIN(I)
            END DO
          END IF
  200   CONTINUE

        DO NP = 1, NRP
          WRITE(*,'(2I5,2F10.4)') NP,JRP(NP),AMP_P(1,NP),AK_P(1,NP)
        END DO

C **********************************************************************

        DO I = 1, NS
          T = 1.0D0 / F(I)
          DO J = 3, JMAX-2
            IF( J.LT.JRP(1) )THEN
              AMP_J(I,J) = AMP_P(I,1)
            ELSE IF( J.GE.JRP(NRP) )THEN
              AMP_J(I,J) = AMP_P(I,NRP)
            ELSE
              DO NP = 2, NRP
                IF( (J.GE.JRP(NP-1)).AND.(J.LT.JRP(NP)) )THEN
                  AMP_J(I,J) = AMP_P(I,NP-1)
     &                       + (AMP_P(I,NP)-AMP_P(I,NP-1))
     &                         /DBLE(JRP(NP)-JRP(NP-1))
     &                         *DBLE(J-JRP(NP-1))
                END IF
              END DO
            END IF
              DEP = HZ(J)
              IF( DEP.GT.0.0D0 )THEN
                CALL WVL_M( DEP, T, AL )
                AK_J(I,J)  = 2.0D0 * PI / AL
              ELSE
                AK_J(I,J)  = 0.0D0
              END IF
          END DO
        END DO

      ELSE

        DO I = 1, NS
          T = 1.0D0 / F(I)
          DO J = 3, JMAX-2
            AMP_J(I,J) = AMP(I)
            IF( H10.GT.0.0D0 )THEN
              AK_J(I,J) = AK(I)
            ELSE
              DEP = HZ(J)
              IF( DEP.GT.0.0D0 )THEN
                CALL WVL_M( DEP, T, AL )
                AK_J(I,J)  = 2.0D0 * PI / AL
              ELSE
                AK_J(I,J)  = 0.0D0
              END IF
            END IF
          END DO
        END DO

      END IF

      RETURN

 100  WRITE(*,'(3X,''Can not open spectdat.in file'')')             ! ERROR
      STOP

 101  WRITE(*,'(3X,''Can not read spectdat.in data'')')             ! ERROR
      STOP

      END

!=====================================================================
      SUBROUTINE CALRLHRLG(FR,AMP,NS,RLH,RLG)

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      include 'wav_bsq46c8a_r1.inc'

      DIMENSION FR(NN),AMP(NN)

      PI = 3.14159265D0

!  XyNg0[ǧvZ
      SUMM0 = 0.0D0
      DO I = 1, NS
       SUMM0 = SUMM0 + AMP(I)**2 * 0.5D0
      ENDDO

!  XyNg1[ǧvZ
      SUMM1 = 0.0D0
      DO I = 1, NS
       SUMM1 = SUMM1 + AMP(I)**2 * 0.5D0 * FR(I)
      ENDDO
   
      T0 = SUMM0 / SUMM1
   
      SUMSIN = 0.0D0
      DO I = 1, NS
       SIN2PAI = SIN(2.0D0*PI*FR(I)*T0)
       SUMSIN = SUMSIN + AMP(I)**2 * 0.5D0 * SIN2PAI
      ENDDO
      SUMSIN = SUMSIN / SUMM0
   
      SUMCOS = 0.0D0
      DO I = 1, NS
       COS2PAI = COS(2.0D0*PI*FR(I)*T0)
       SUMCOS = SUMCOS + AMP(I)**2 * 0.5D0 * COS2PAI
      ENDDO
      SUMCOS = SUMCOS / SUMM0
   
      CAPPA = DSQRT(SUMSIN**2 + SUMCOS**2)

      RLH = 3.459D0 + 1.353D0 * CAPPA - 1.385D0 * CAPPA**2
     +                                + 0.5786D0 * CAPPA**3
     
      RLG = 1.493D0 + 0.233d0 * CAPPA - 0.153D0 * CAPPA**2
     +                                + 0.0065D0 * CAPPA**3

      WRITE(*,100) CAPPA, RLH, RLG
      
 100  FORMAT('=',F5.2,2X,'RLH=',F5.2,2x,'RLG=',F5.2)
 
      RETURN
      END
      